/*
** Copyright (c) 1999 PIXAR.  All rights reserved.  This program or
** documentation contains proprietary confidential information and trade
** secrets of PIXAR.  Reverse engineering of object code is prohibited.
** Use of copyright notice is precautionary and does not imply
** publication.
**
**                      RESTRICTED RIGHTS NOTICE
**
** Use, duplication, or disclosure by the Government is subject to the
** following restrictions:  For civilian agencies, subparagraphs (a) through
** (d) of the Commercial Computer Software--Restricted Rights clause at
** 52.227-19 of the FAR; and, for units of the Department of Defense, DoD
** Supplement to the FAR, clause 52.227-7013 (c)(1)(ii), Rights in
** Technical Data and Computer Software.
**
** Pixar
** 1001 West Cutting Blvd.
** Richmond, CA  94804
**
** ----------------------------------------------------------------------------
*/
/* code generated by slim 1.0b3, RAT 4.0b3 (Jan 11 2000 01:59:35) */
/* for dsisson@glaw.rainsound.com at: Tue Jan 11 12:47:45 PST 2000 */
surface AdditiveFX_0 (
  string ReflectionMap_0_RefMap="";
  )
{
/* begin referenced functions ----------------------*/

	    void
	    pxslReflectionMap( string refmap; 
	    	    	    	float kr;
				color coloration;
				float nScale;
				float blur;
				output color result; )
	    {
	    	if( refmap != "" )
		{
	    	    extern point P;
		    extern normal N, Ng;
		    point PP = P + nScale * (normalize(N)-normalize(Ng));
		    point PNDC = transform("NDC", PP);
		    result = kr * coloration * 
		    	texture(refmap, xcomp(PNDC), ycomp(PNDC), "blur", blur);
		}
		else
		    result = color(0);
	    }
	

	   void
	   pxslBlinn(color SurfaceColor;
		   color SurfaceOpacity;
		   color ambientColor;
		   color Incandescence;
		   float diffuseCoeff;
		   float translucenceCoeff;
		   color specularColor;
		   float eccentricity;
		   float specularRollOff;
		   float reflectivity;
		   output color CI;
		   output color OI; )
	   {
	       color
	       getTranslucence( normal Nf; float c; )
	       {
		   color C = 0;
		   extern point P;
		   extern color Cl;
		   float nondiff;

		   if( c != 0 )
		   {
		       illuminance(P, Nf, PI)
		       {
			   if( 0 == lightsource("__nondiffuse", nondiff) )
			       nondiff = 0;
			   C += (1 - nondiff) * Cl;
		       }
		       C *= c;
 		   }
		   return C;
	       }
	       color
	       getBlinn( normal Nf;
		       float eccentricity, specularRollOff;
		       output color Cr; )
	       {
		   float E;
		   color C = 0;
		   vector H, Ln, V, Nn;
		   float NH, NH2, NHSQ, Dd, Gg, VN, VH, LN, Ff, tmp;
		   float nondiff, nonspec;
		   extern point P;
		   extern vector L, I;
		   extern color Cl;

		   if(eccentricity != 1)
 			E = 1 / (eccentricity * eccentricity - 1);
		   else
			E = -1e5;
		   Cr = 0;
		   V = normalize(-I);
		   VN = V.Nf;
		   illuminance(P, Nf, 1.57079632679)
		   {
		       if( 0 == lightsource("__nonspecular", nonspec) )
			   nonspec = 0;
		       if( nonspec < 1 )
		       {
			   Ln = normalize(L);
			   H = normalize(Ln+V);
			   NH = Nf.H;
			   NHSQ = NH*NH;
			   NH2 = NH * 2;
			   Dd = (E+1) / (NHSQ + E);
			   Dd *= Dd;
			   VH = V.H;
			   LN = Ln.Nf;
			   if( VN < LN )
			   {
			       if( VN * NH2 < VH )
				   Gg = NH2 / VH;
			       else
				   Gg = 1 / VN;
			   }
			   else
			   {
			       if( LN * NH2 < VH )
				   Gg = (LN * NH2) / (VH * VN);
			       else
				   Gg = 1 / VN;
			   }
			   /* poor man's Fresnel */
			   tmp = pow((1 - VH), 3);
			   Ff = tmp + (1 - tmp) * specularRollOff;
			   C += Cl * Dd * Gg * Ff;

			   /* now look for environment reflections.  These
			       are indicated by lights which are specular AND
			       nondiffuse */
			   if( 0 != lightsource("__nondiffuse", nondiff) )
			   {
			       Cr += (1 - nonspec) * nondiff * Ff * Cl;
			   }
		       }
		   }
		   return C;
	       }
	       normal Nf;
	       vector R;
	       color Ia, Id, Itr, Is, Ir, Isr;
	       extern normal N;
	       extern vector I;
	       Nf = faceforward( normalize(N), I );
	       R = reflect(normalize(I), Nf);
	       Ia = ambientColor * ambient();
	       Id = diffuseCoeff*diffuse(Nf);
	       Itr = getTranslucence(Nf, translucenceCoeff);
	       Is = getBlinn(Nf, eccentricity, specularRollOff, Ir);
	       Ir = reflectivity * Ir;
	       Isr = specularColor * (Is + Ir);
	       OI = SurfaceOpacity;
	       CI = OI * SurfaceColor * (Ia + Id + Itr + Incandescence + Isr);
	   }
       

	   void pxslFloatToColor(float fa; color ca; output color c;)
	   {
	       c = ca * color(fa,fa,fa);
	   }
       

		void
		pxslShapes (
		    float	shape;
		    float	fuzziness;
		    float	invert; 
		    point	Q;
		    vector	duQ;
		    vector	dvQ;
		    output float	result;
		)
		{
		    uniform float	size = .45;

		    if(shape == 1) /* star */
		    {
			varying float	x, y;

			/* from peachey */
			uniform float starangle = 2*PI / 5;
			uniform float rmin = .14;
			uniform float rmax = .4;
			uniform point p0 = rmax * (cos(0), sin(0), 0);
			uniform point p1 = rmin * 
			    (cos(starangle/2), sin(starangle/2), 0);
			uniform vector	d0 = p1 - p0;
			vector d1;
			float r, a, angle;

			varying point	Qr;

			angle = 2*PI/5*zcomp(Q);
			Qr = rotate (Q-.5, angle, point(0,0,0), point(0,0,1));
			x = xcomp(Qr);
			y = ycomp(Qr);

			angle = atan(x, y) + PI;
			r = sqrt(x*x + y*y);
			a = mod(angle, starangle) / starangle;
			if( a >= .5 )
			    a = 1 - a;

			d1 = r * (cos(a), sin(a), 0) - p0;

			result = (1 - filterstep(rmax, r,
				"width", 1+4*fuzziness, "filter", "gaussian")) *
				 filterstep (0, zcomp(d0^d1), 
			    	"width", 1+4*fuzziness, "filter", "gaussian");
		    }
		    else
		    if(shape == 2) /* circle */
		    {
			varying float	x, y;
			varying float	r, dr;

			x = xcomp(Q)-.5;
			y = ycomp(Q)-.5;
			r = sqrt(x*x + y*y);
			
			x = xcomp(duQ) + xcomp(dvQ);
			y = ycomp(duQ) + ycomp(dvQ);
			dr = max (.5*fuzziness, sqrt (x*x + y*y));

			result = 1 - filterstep (size, r, r+dr);
		    }
		    else
		    if(shape == 3) /* square */
		    {
			varying float	x, y;
			varying float	dx, dy;

			x = xcomp(Q)-.5;
			y = ycomp(Q)-.5;
			dx = max (.5*fuzziness, abs(xcomp(duQ)) +
			    	 abs(xcomp(dvQ)));
			dy = max (.5*fuzziness, abs(ycomp(duQ)) +
			    	 abs(ycomp(dvQ)));

			result = filterstep (-size, x, x+dx) - 
			    	filterstep (size, x, x+dx);
			result *= filterstep (-size, y, y+dy) - 
			    	filterstep (size, y, y+dy);
		    }
		    else
		    if(shape == 4) /* diamond */
		    {
			uniform float	w = size / sqrt(2.0);
			varying float	angle = radians(45) + PI/2*zcomp(Q);

			varying point	Qr;
			varying vector	duQr, dvQr;
			varying float	x, y;
			varying float	dx, dy;

			Qr = rotate (Q-.5, angle, point(0,0,0), point(0,0,1)); 
			duQr = rotate (duQ, angle, point(0,0,0), point(0,0,1)); 
			dvQr = rotate (dvQ, angle, point(0,0,0), point(0,0,1)); 

			x = xcomp(Qr);
			y = ycomp(Qr);
			dx = max (.5*fuzziness, abs(xcomp(duQr)) +
			    	 abs(xcomp(dvQr)));
			dy = max (.5*fuzziness, abs(ycomp(duQr)) +
			    	 abs(ycomp(dvQr)));

			result = filterstep (-w, x, x+dx) - 
			    	filterstep (w, x, x+dx);
			result *= filterstep (-w, y, y+dy) - 
			    	filterstep (w, y, y+dy);
		    }
		    else
		    if(shape == 5) /* checker-like thingy */
		    {
			varying float	x, y;
			varying float	dx, dy;

			x = mod (xcomp(Q)-.5, 1);
			y = mod (ycomp(Q)-.5, 1);
			dx = max (.5*fuzziness, abs(xcomp(duQ)) +
			    	     abs(xcomp(dvQ)));
			dy = max (.5*fuzziness, abs(ycomp(duQ)) +
			    	 abs(ycomp(dvQ)));

			x = filterstep(.5, x, x+dx);
			y = filterstep(.5, y, y+dy);
			result = mix (x, (1-x), y);
		    }
		    else
		    if(shape == 6) /* x ramp */
		    {
			varying float	x, dx;

			x = xcomp(Q)-.5;
			dx = max (.5*fuzziness, abs(xcomp(duQ)) +
			    	 abs(xcomp(dvQ)));

			result = mix (x+1, x, filterstep (0, x, x+dx));
		    }
		    else
		    if(shape == 7) /* y ramp */
		    {
			varying float	y, dy;

			y = ycomp(Q)-.5;
			dy = max (.5*fuzziness, abs(ycomp(duQ)) +
			    	 abs(ycomp(dvQ)));

			result = mix (y+1, y, filterstep (0, y, y+dy));
		    }
		    else
		    if(shape == 8) /* xy ramp */
		    {
			varying float	x, y;
			varying float	dx, dy;

			x = xcomp(Q)-.5;
			y = ycomp(Q)-.5;
			dx = max (.5*fuzziness, abs(xcomp(duQ)) +
			    	 abs(xcomp(dvQ)));
			dy = max (.5*fuzziness, abs(ycomp(duQ)) +
			    	 abs(ycomp(dvQ)));

			result = mix (x+1, x, filterstep (0, x, x+dx));
			result += mix (y+1, y, filterstep (0, y, y+dy));
			result *= .5;
		    }
		    else
		    if(shape == 9) /* squiggles */
		    {
			varying float	x, y;
			varying float	r, dr;

			x = xcomp(duQ) + xcomp(dvQ);
			y = ycomp(duQ) + ycomp(dvQ);
			dr = max (.5*fuzziness, sqrt (x*x + y*y));

			if (zcomp(Q) < .5)
			    x = 1-xcomp(Q);
			else
			    x = xcomp(Q);

			x = x;
			y = ycomp(Q);

			r = sqrt(x*x + y*y);
			result = filterstep (.4, r, r+dr) - 
			    	    filterstep (.6, r, r+dr);

			x = 1-x;
			y = 1-y;

			r = sqrt(x*x + y*y);
			result = max (result, filterstep (.4, r, r+dr) -
			    	     filterstep (.6, r, r+dr));
		    }

		    if (invert != 0)
			result = 1 - result;    
		}
	    

#include "pxslRemap.h"
		void 
		pxslRemapF(float f; 
			float inputmin, inputmax;
			float outputmin, outputmax;
			float disablegain;
			float bias, gain;
			output float result; )
		{
		    result = clamp(f, inputmin, inputmax);
		    result = outputmin + (outputmax - outputmin) * 
		    	(result - inputmin) / (inputmax - inputmin);
		    if (disablegain == 0)
		    {
		    	result = pxslFloatBias(bias, result);
		    	result = pxslFloatGain(gain, result);
		    }
		}
	    

		void pxslST (
			  uniform float angle;
			  uniform float repeatS; uniform float repeatT;
			  uniform float offsetS; uniform float offsetT;
			  output point Q;
			  output vector dQu;
			  output vector dQv;
			  )
		{
		    extern float s, t, du, dv;

		    setxcomp(Q, repeatS * s + offsetS);
		    setycomp(Q, repeatT * t + offsetT);
		    setzcomp(Q, 0);

		    if(angle != 0)
			Q = rotate(Q, radians(angle), 
			    	    point(0,0,0), point(0,0,1)); 

		    dQu = vector Du(Q)*du;
		    dQv = vector Dv(Q)*dv;
		}
	    

	    void
	    pxslAdditiveFX( 
	    	    color CS; color OS;
		    float k1;
	    	    color ch1;
		    float k2;
		    color ch2;
		    float k3;
		    color ch3;
		    output color CI;
		    output color OI; )
	    {
	    	CI = CS + k1 * ch1 + k2 * ch2 + k3 * ch3;
		OI = OS;
	    }
	

		void
		pxslTile (
		    uniform point frequency; 
		    uniform float tilesize;
		    uniform float jitter; 
		    uniform float rowoffset;
		    uniform float randomz;
		    point Qin;
		    vector dQuin;
		    vector dQvin;
		    output point Q;
		    output vector dQu;
		    output vector dQv;
		)
		{
		    float x, y, xOffset = 0;
		    point jitterPt;
		    
		    dQu = dQuin * frequency * tilesize;
		    dQv = dQvin * frequency * tilesize;

		    Q = Qin * frequency;
		    x = xcomp(Q);
		    y = ycomp(Q);

		    if ((rowoffset != 0) && (abs (mod (y, 2)) < 1))
			    x += .5;

		    jitterPt = point (x, y, 0);

		    x = mod (x, 1);
		    y = mod (y, 1);
		    Q = tilesize*(point (x, y, .5) - vector .5) + vector .5;

		    Q += jitter*(tilesize-1) * 
		    	    (vector .5 - vector cellnoise (jitterPt));

		    if (randomz != 0)
			setzcomp (Q, float cellnoise (jitterPt));
		    else
			setzcomp (Q, 0);
		}
	    
/* end referenced functions ------------------------*/
  color tmp0;
  pxslReflectionMap ( /* ReflectionMap_0 */
    ReflectionMap_0_RefMap,
    1 /* Kr */,
    color(1,1,1) /* Coloration */,
    .1 /* Scale Normals */,
    0 /* Blur */,
    tmp0
    );
  point tmp1;
  vector tmp2;
  vector tmp3;
  pxslST ( /* ST_0 */
    0 /* Angle */,
    1 /* S Repeats */,
    1 /* T Repeats */,
    0 /* S Offset */,
    0 /* T Offset */,
    tmp1,
    tmp2,
    tmp3
    );
  point tmp4;
  vector tmp5;
  vector tmp6;
  pxslTile ( /* Tile_0 */
    point(8.00,8.00,8.00) /* Frequency */,
    1 /* Tile Size */,
    0 /* Jitter */,
    1 /* Row Offset */,
    0 /* Random Z */,
    tmp1,
    tmp2,
    tmp3,
    tmp4,
    tmp5,
    tmp6
    );
  float tmp7;
  pxslShapes ( /* Shapes_0 */
    2 /* Shape */,
    0 /* Fuzziness */,
    0 /* Invert */,
    tmp4,
    tmp5,
    tmp6,
    tmp7
    );
  color tmp8;
  pxslFloatToColor ( /* FloatToColor_0 */
    tmp7,
    color(1,1,1) /* Coloration */,
    tmp8
    );
  float tmp9;
  pxslRemapF ( /* Remap_0 */
    tmp7,
    0 /* inputmin */,
    1 /* inputmax */,
    1.00 /* outputmin */,
    0.00 /* outputmax */,
    0 /* Disable Bias/Gain */,
    0.00 /* Bias */,
    .5 /* Gain */,
    tmp9
    );
  color tmp10;
  pxslFloatToColor ( /* FloatToColor_2 */
    tmp9,
    color(1,1,1) /* Coloration */,
    tmp10
    );
  color tmp11;
  color tmp12;
  pxslBlinn ( /* Blinn_0 */
    tmp8,
    color(1,1,1) /* Opacity */,
    color(0.499992370489,0.499992370489,0.499992370489) /* Ambient Color */,
    color(0.4,0.499992370489,0.0) /* Incandescence */,
    .8 /* Diffuse Coefficient */,
    0 /* Translucence Coefficient */,
    tmp10,
    .5 /* Eccentricity */,
    .1 /* Specular Rolloff */,
    1.00 /* Reflectivity */,
    tmp11,
    tmp12
    );
  pxslAdditiveFX ( /* AdditiveFX_0 */
    tmp11,
    tmp12,
    1 /* k1 */,
    tmp0,
    1 /* k2 */,
    color(0,0,0) /* ch2 */,
    1 /* k3 */,
    color(0,0,0) /* ch3 */,
    tmp8,
    tmp10
    );
  Ci = tmp8;
  Oi = tmp10;
}

