/*
** Copyright (c) 2000 PIXAR.  All rights reserved.  This program or
** documentation contains proprietary confidential information and trade
** secrets of PIXAR.  Reverse engineering of object code is prohibited.
** Use of copyright notice is precautionary and does not imply
** publication.
**
**                      RESTRICTED RIGHTS NOTICE
**
** Use, duplication, or disclosure by the Government is subject to the
** following restrictions:  For civilian agencies, subparagraphs (a) through
** (d) of the Commercial Computer Software--Restricted Rights clause at
** 52.227-19 of the FAR; and, for units of the Department of Defense, DoD
** Supplement to the FAR, clause 52.227-7013 (c)(1)(ii), Rights in
** Technical Data and Computer Software.
**
** Pixar
** 1001 West Cutting Blvd.
** Richmond, CA  94804
**
** ----------------------------------------------------------------------------
*/
/* code generated by slim 1.1b2, RAT 4.1b2 (May 17 2000 02:01:47) */
/* for dsisson@glaw.rainsound.com at: Wed May 17 18:32:32 PDT 2000 */
surface ChromeColor_Metal (
  varying point __Pref=point(-1e10,-1e10,-1e10);
  color ChromeColor_Metal_SurfaceColor=color(0.749996185245,0.749996185245,0.749996185245);
  )
{
/* begin referenced functions ----------------------*/

	    	void pxslF_Fractal (
		    float	Layers;
		    float	Frequency;
		    float	Lacunarity;
		    float	Dimension;
		    float	Erosion;
		    float	Variation;
		    point	Q;
		    vector	duQ;
		    vector	dvQ;
		    output float	result;
		)
		{
		    float Noise (point Q)
		    {
			extern float	Variation;

			return (smoothstep (.2, .8, float noise (Q, Variation)));
		    }
		    
		    uniform float	i;
		    float	sum, mag, f;
		    float	dQ;

		    dQ = max (
			max (
			    abs(xcomp(duQ)) + abs(xcomp(dvQ)),
			    abs(ycomp(duQ)) + abs(ycomp(dvQ))
			),
			abs(zcomp(duQ)) + abs(zcomp(dvQ))
		    );

		    f = Frequency;
		    result = mix (Noise (f*Q), .5, smoothstep (.25, 1, f*dQ));
		    sum = 1;

		    for (i=1; i < Layers; i+=1) {
			f *= Lacunarity;
			mag = 1/pow (f, 3-2*Dimension + mix (-Erosion, Erosion, result/sum));
			result += mag*mix (Noise (f*Q), .5, smoothstep (.25, 1, f*dQ));
			sum += mag;
		    }

		    result /= sum;
		}
	    

	   void
	   pxslMetal(color SurfaceColor;
		   color SurfaceOpacity;
		   float Ka;
		   float Kd;
		   float Ks;
		   float Roughness;
		   output color CI;
		   output color OI;
		   )
	   {
	       normal Nf;
	       extern normal N;
	       extern vector I;
	       Nf = faceforward( normalize(N), I );
	       OI = SurfaceOpacity;
	       CI = SurfaceOpacity * 
		       SurfaceColor *
			   (Ka*ambient() + Kd*diffuse(Nf) +
			    Ks * specular(Nf,-normalize(I),Roughness));
	   }
	

#include "pxslRemap.h"
		void 
		pxslRemapF(float f; 
			float inputmin, inputmax;
			float outputmin, outputmax;
			float disablegain;
			float bias, gain;
			output float result; )
		{
		    result = clamp(f, inputmin, inputmax);
		    result = outputmin + (outputmax - outputmin) * 
		    	(result - inputmin) / (inputmax - inputmin);
		    if (disablegain == 0)
		    {
		    	result = pxslFloatBias(bias, result);
		    	result = pxslFloatGain(gain, result);
		    }
		}
	    

		void pxslSurfacePoint (
		    uniform string coordsys;
		    uniform float frequency;
		    uniform float ignorePref;
		    output point Q; 
		    output vector dQu;
		    output vector dQv;
		) 
		{
		    extern point P;
		    extern vector dPdu, dPdv;
		    extern point __Pref;
		    extern float du, dv;
		    uniform string sys;

		    if(coordsys == "")
		    	sys = "shader";
		    else
		    	sys = coordsys;

		    if (xcomp(__Pref) == -1e10 || ignorePref != 0)
		    {
		    	Q = transform (sys, frequency*P);
		    	dQu = vtransform (sys, dPdu*du*frequency);
		    	dQv = vtransform (sys, dPdv*dv*frequency);
		    }
		    else 
		    {
			Q = frequency * transform (sys, __Pref);
			dQu = vector Du(Q)*du;
		        dQv = vector Dv(Q)*dv;
		    }
		}
	    
/* end referenced functions ------------------------*/
  point tmp0;
  vector tmp1;
  vector tmp2;
  pxslSurfacePoint ( /* ChromiumSurfacePoint */
    "" /* Space */,
    1 /* Frequency */,
    0 /* IgnorePref */,
    tmp0,
    tmp1,
    tmp2
    );
  float tmp3;
  pxslF_Fractal ( /* ChromeColorFractal */
    8 /* Layers */,
    0.96 /* Frequency */,
    2.06 /* Lacunarity */,
    1.27 /* Dimension */,
    0 /* Erosion */,
    0 /* Variation */,
    tmp0,
    tmp1,
    tmp2,
    tmp3
    );
  float tmp4;
  pxslRemapF ( /* ChromeColorRemap */
    tmp3,
    0 /* inputmin */,
    1 /* inputmax */,
    0.10 /* outputmin */,
    0.40 /* outputmax */,
    0 /* Disable Bias/Gain */,
    0.56 /* Bias */,
    0.32 /* Gain */,
    tmp4
    );
  float tmp5;
  pxslRemapF ( /* ChromeSpecRemap */
    tmp3,
    0 /* inputmin */,
    1 /* inputmax */,
    0.30 /* outputmin */,
    1 /* outputmax */,
    0 /* Disable Bias/Gain */,
    0.44 /* Bias */,
    0.44 /* Gain */,
    tmp5
    );
  color tmp6;
  color tmp7;
  pxslMetal ( /* ChromeColor_Metal */
    ChromeColor_Metal_SurfaceColor,
    color(1,1,1) /* Opacity */,
    .05 /* Ka */,
    tmp4,
    tmp5,
    tmp4,
    tmp6,
    tmp7
    );
  Ci = tmp6;
  Oi = tmp7;
}

