/*
** Copyright (c) 2000 PIXAR.  All rights reserved.  This program or
** documentation contains proprietary confidential information and trade
** secrets of PIXAR.  Reverse engineering of object code is prohibited.
** Use of copyright notice is precautionary and does not imply
** publication.
**
**                      RESTRICTED RIGHTS NOTICE
**
** Use, duplication, or disclosure by the Government is subject to the
** following restrictions:  For civilian agencies, subparagraphs (a) through
** (d) of the Commercial Computer Software--Restricted Rights clause at
** 52.227-19 of the FAR; and, for units of the Department of Defense, DoD
** Supplement to the FAR, clause 52.227-7013 (c)(1)(ii), Rights in
** Technical Data and Computer Software.
**
** Pixar
** 1001 West Cutting Blvd.
** Richmond, CA  94804
**
** ----------------------------------------------------------------------------
*/
/* code generated by slim 1.1b2, RAT 4.1b2 (May 17 2000 02:01:47) */
/* for dsisson@glaw.rainsound.com at: Wed May 17 18:32:08 PDT 2000 */
surface Chromium_AdditiveFX (
  varying point __Pref=point(-1e10,-1e10,-1e10);
  color ChromeColor_Metal_SurfaceColor=color(0.749996185245,0.749996185245,0.749996185245);
  float ChromeReflections_eta=1.10;
  output varying vector __L=vector(0,0,1);
  output varying float __blur=0;
  )
{
/* begin referenced functions ----------------------*/

	    void pxslCollectReflections (
		uniform float eta;
		float	Kr;
		uniform float KrEdge, KrCenter;
		float	Roughness;

		output color result;
	    )
	    {
		extern point	P;
		extern vector	I;
		extern normal	N;
		extern color	Cl;
		extern float	__blur;
		extern vector	__L;
				
	    	uniform float Ri = 1 - min (max (eta, 1e-6), 1-1e-6);
	    	uniform float IR = 1 / Ri;
		uniform float kRlowest = pow ((IR-1)/(IR+1), 2);
		
		varying vector R, T;
		varying float kr, kt;
    	    	varying vector IN = normalize(I);
		varying normal Nf = faceforward(normalize(N), I);
		varying point Q = P;	/* blow the cache */

   		fresnel (IN, Nf, Ri, kr, kt, R, T);
		if (KrCenter != 0)
		    kr = mix (KrCenter, KrEdge, (kr-kRlowest)/(1-kRlowest));
		__L = R;
		__blur = pow (Roughness, 2);
		result = color 0;
		illuminance ("environment", Q) {
		    result += Cl;
		}

		result *= Kr * kr;
	    }
	

	   void
	   pxslMetal(color SurfaceColor;
		   color SurfaceOpacity;
		   float Ka;
		   float Kd;
		   float Ks;
		   float Roughness;
		   output color CI;
		   output color OI;
		   )
	   {
	       normal Nf;
	       extern normal N;
	       extern vector I;
	       Nf = faceforward( normalize(N), I );
	       OI = SurfaceOpacity;
	       CI = SurfaceOpacity * 
		       SurfaceColor *
			   (Ka*ambient() + Kd*diffuse(Nf) +
			    Ks * specular(Nf,-normalize(I),Roughness));
	   }
	

	    	void pxslF_Fractal (
		    float	Layers;
		    float	Frequency;
		    float	Lacunarity;
		    float	Dimension;
		    float	Erosion;
		    float	Variation;
		    point	Q;
		    vector	duQ;
		    vector	dvQ;
		    output float	result;
		)
		{
		    float Noise (point Q)
		    {
			extern float	Variation;

			return (smoothstep (.2, .8, float noise (Q, Variation)));
		    }
		    
		    uniform float	i;
		    float	sum, mag, f;
		    float	dQ;

		    dQ = max (
			max (
			    abs(xcomp(duQ)) + abs(xcomp(dvQ)),
			    abs(ycomp(duQ)) + abs(ycomp(dvQ))
			),
			abs(zcomp(duQ)) + abs(zcomp(dvQ))
		    );

		    f = Frequency;
		    result = mix (Noise (f*Q), .5, smoothstep (.25, 1, f*dQ));
		    sum = 1;

		    for (i=1; i < Layers; i+=1) {
			f *= Lacunarity;
			mag = 1/pow (f, 3-2*Dimension + mix (-Erosion, Erosion, result/sum));
			result += mag*mix (Noise (f*Q), .5, smoothstep (.25, 1, f*dQ));
			sum += mag;
		    }

		    result /= sum;
		}
	    

	    	void
		pxslFacingForward(float Clamp; 
		    	    	float Attenuation;
				output float result;)
		{
		    extern normal N;
		    extern vector I;
		    normal NN = faceforward(normalize(N), I);
		    float cosangle = normalize(I).NN;
		    if(cosangle < 0)
		    {
		    	result = pow(-cosangle, Attenuation);
		    }
		    else
		    {
		    	result = pow(cosangle, Attenuation);
		    }
		    if(Clamp != 0)
		    {
		    	result = clamp(result, 0, 1);
		    }
		}
	    

	    void
	    pxslAdditiveFX( 
	    	    color CS; color OS;
		    float k1;
	    	    color ch1;
		    float k2;
		    color ch2;
		    float k3;
		    color ch3;
		    output color CI;
		    output color OI; )
	    {
	    	CI = CS + k1 * ch1 + k2 * ch2 + k3 * ch3;
		OI = OS;
	    }
	

		void
		pxslCombine( float method; float f1; float f2;
			output float result; )
		{
		    if (method == 0)
		    {
			/* Intersection */
			result = f1 * f2;
		    }
		    else
		    if (method == 1)
		    {
			/* Union */
			result = f1 + f2 - f1 * f2;
		    }
		    else
		    if (method == 2)
		    {
			/* Difference */
			result = f1 - f1 * f2;
		    }
		}
	    

#include "pxslRemap.h"
		void 
		pxslRemapF(float f; 
			float inputmin, inputmax;
			float outputmin, outputmax;
			float disablegain;
			float bias, gain;
			output float result; )
		{
		    result = clamp(f, inputmin, inputmax);
		    result = outputmin + (outputmax - outputmin) * 
		    	(result - inputmin) / (inputmax - inputmin);
		    if (disablegain == 0)
		    {
		    	result = pxslFloatBias(bias, result);
		    	result = pxslFloatGain(gain, result);
		    }
		}
	    

		void pxslSurfacePoint (
		    uniform string coordsys;
		    uniform float frequency;
		    uniform float ignorePref;
		    output point Q; 
		    output vector dQu;
		    output vector dQv;
		) 
		{
		    extern point P;
		    extern vector dPdu, dPdv;
		    extern point __Pref;
		    extern float du, dv;
		    uniform string sys;

		    if(coordsys == "")
		    	sys = "shader";
		    else
		    	sys = coordsys;

		    if (xcomp(__Pref) == -1e10 || ignorePref != 0)
		    {
		    	Q = transform (sys, frequency*P);
		    	dQu = vtransform (sys, dPdu*du*frequency);
		    	dQv = vtransform (sys, dPdv*dv*frequency);
		    }
		    else 
		    {
			Q = frequency * transform (sys, __Pref);
			dQu = vector Du(Q)*du;
		        dQv = vector Dv(Q)*dv;
		    }
		}
	    
/* end referenced functions ------------------------*/
  float tmp0;
  pxslFacingForward ( /* Chromium_FacingForward */
    1 /* Clamp */,
    3.08 /* Attenuation */,
    tmp0
    );
  point tmp1;
  vector tmp2;
  vector tmp3;
  pxslSurfacePoint ( /* ChromiumSurfacePoint */
    "" /* Space */,
    1 /* Frequency */,
    0 /* IgnorePref */,
    tmp1,
    tmp2,
    tmp3
    );
  float tmp4;
  pxslRemapF ( /* ChromiumFF_Remap */
    tmp0,
    0 /* inputmin */,
    1 /* inputmax */,
    0.30 /* outputmin */,
    1 /* outputmax */,
    0 /* Disable Bias/Gain */,
    0.35 /* Bias */,
    0.44 /* Gain */,
    tmp4
    );
  pxslF_Fractal ( /* ChromeColorFractal */
    8 /* Layers */,
    0.96 /* Frequency */,
    2.06 /* Lacunarity */,
    1.27 /* Dimension */,
    0 /* Erosion */,
    0 /* Variation */,
    tmp1,
    tmp2,
    tmp3,
    tmp0
    );
  float tmp5;
  pxslRemapF ( /* ChromeColorRemap */
    tmp0,
    0 /* inputmin */,
    1 /* inputmax */,
    0.10 /* outputmin */,
    0.40 /* outputmax */,
    0 /* Disable Bias/Gain */,
    0.56 /* Bias */,
    0.32 /* Gain */,
    tmp5
    );
  float tmp6;
  pxslRemapF ( /* Chrome_ReflectRemap */
    tmp0,
    0 /* inputmin */,
    1 /* inputmax */,
    0.30 /* outputmin */,
    1 /* outputmax */,
    0 /* Disable Bias/Gain */,
    .5 /* Bias */,
    .5 /* Gain */,
    tmp6
    );
  float tmp7;
  pxslRemapF ( /* ChromeSpecRemap */
    tmp0,
    0 /* inputmin */,
    1 /* inputmax */,
    0.30 /* outputmin */,
    1 /* outputmax */,
    0 /* Disable Bias/Gain */,
    0.44 /* Bias */,
    0.44 /* Gain */,
    tmp7
    );
  pxslCombine ( /* ChromeRelfectCombine */
    0 /* Combine Method */,
    tmp4,
    tmp6,
    tmp0
    );
  color tmp8;
  color tmp9;
  pxslMetal ( /* ChromeColor_Metal */
    ChromeColor_Metal_SurfaceColor,
    color(1,1,1) /* Opacity */,
    .05 /* Ka */,
    tmp5,
    tmp7,
    tmp5,
    tmp8,
    tmp9
    );
  color tmp10;
  pxslCollectReflections ( /* ChromeReflections */
    ChromeReflections_eta,
    tmp0,
    1 /* Edge Kr */,
    0 /* Center Kr */,
    0.60 /* Roughness */,
    tmp10
    );
  color tmp11;
  color tmp12;
  pxslAdditiveFX ( /* Chromium_AdditiveFX */
    tmp8,
    tmp9,
    1 /* k1 */,
    tmp10,
    1 /* k2 */,
    color(0,0,0) /* ch2 */,
    1 /* k3 */,
    color(0,0,0) /* ch3 */,
    tmp11,
    tmp12
    );
  Ci = tmp11;
  Oi = tmp12;
}

