/*
** Copyright (c) 1999 PIXAR.  All rights reserved.  This program or
** documentation contains proprietary confidential information and trade
** secrets of PIXAR.  Reverse engineering of object code is prohibited.
** Use of copyright notice is precautionary and does not imply
** publication.
**
**                      RESTRICTED RIGHTS NOTICE
**
** Use, duplication, or disclosure by the Government is subject to the
** following restrictions:  For civilian agencies, subparagraphs (a) through
** (d) of the Commercial Computer Software--Restricted Rights clause at
** 52.227-19 of the FAR; and, for units of the Department of Defense, DoD
** Supplement to the FAR, clause 52.227-7013 (c)(1)(ii), Rights in
** Technical Data and Computer Software.
**
** Pixar
** 1001 West Cutting Blvd.
** Richmond, CA  94804
**
** ----------------------------------------------------------------------------
*/
/* code generated by slim 1.0d01, RAT 4.0d01 (Sep 10 1999 10:37:26) */
/* for dsisson@glaw.rainsound.com at: Fri Sep 10 11:24:56 PDT 1999 */
displacement RockoBumpS (
  string rockSpace_Space="";
  float rockSpace_UsePref=0;
  varying point __Pref=point(-1e10,-1e10,-1e10);
  string SurfacePoint_Space="";
  float SurfacePoint_UsePref=0;
  float Projection0_projection=2;
  float RockWaves_outputmin=0;
  float RockWaves_outputmax=1;
  float RockWaves_Bias=0.79;
  float RockWaves_Gain=0.24;
  float DoDisplacement=1;
  float Kb=0.200;
  float combineOp=0;
  float Kb1=.1;
  float Kb2=-0.3;
  float Kb3=0.4;
  float Kb4=-0.3;
  )
{
/* begin referenced functions ----------------------*/

#include "pxslRemap.h"
		void 
		pxslRemap(float f; 
			float inputmin, inputmax;
			float outputmin, outputmax;
			float bias, gain;
			output float result; )
		{
		    result = clamp(f, inputmin, inputmax);
		    result = outputmin + (outputmax - outputmin) * 
		    	(result - inputmin) / (inputmax - inputmin);
		    result = pxslFloatBias(bias, result);
		    result = pxslFloatGain(gain, result);
		}   
	    

	   void pxslFloatToColor(float ca; output color c;)
	   {
	       c = color(ca,ca,ca);
	   }
       

		/*  Worley noise -- 3-D, 2-feature version.*/
		void
		pxslWorley (float frequency;
		    	    uniform string distancemetric;
		    	    float jitter;
			    uniform float clamp;
		    	    float c1, c2;
			    point p;
			    vector dpdu;
			    vector dpdv;
			    output float g;
		    	    )
		{
    	    	    float f1,f2;
		    point pp = frequency * p;
		    point thiscell = point (floor(xcomp(pp))+0.5,
		     	    	    	    floor(ycomp(pp))+0.5,
					    floor(zcomp(pp))+0.5);
		    f1 = f2 = 1000;
		    uniform float i, j, k;
		    for (i = -1;  i <= 1;  i += 1) {
        		for (j = -1;  j <= 1;  j += 1) {
        		    for (k = -1;  k <= 1;  k += 1) {
				point testcell = thiscell + vector(i,j,k);
                		point pos = testcell + jitter * 
				    (vector cellnoise (testcell) - 0.5);
				vector offset = pos - pp;
                		float dist;
				if (distancemetric == "Euclidian")  	
				    dist = offset.offset;
				else
				{
				    dist =  abs(xcomp(offset)) +
				    	    abs(ycomp(offset)) +
					    abs(zcomp(offset));
				}
                		if (dist < f1) {
                		    f2 = f1;
                		    f1 = dist;
                		} else if (dist < f2) {
                		    f2 = dist;
				}
        		    }
			}
		    }
		    if (distancemetric == "Euclidian")  	
    	    	    {
		    	f1 = sqrt(f1);
		    	f2 = sqrt(f2);
		    }
		    g = f1 * c1 + f2 * c2;
		    if (clamp != 0)
		    {
		    	g = clamp(g, 0, 1);
		    }
		}
	    

#include "pxslUtil.h"
#include "noises.h"
	void
	pxslVBrownian (uniform float octaves, lacunarity, gain; float fourthdimension;
	     point p;
	     vector dpu, dpv;
	     output vector result;)
	{
	    uniform float amp = 1;
	    varying point pp = p;
	    varying float fw = pxslFilterWidth(dpu, dpv);
	    uniform float i;
    	    result = 0;
	    for (i = 0;  i < octaves;  i += 1) {
#pragma nolint
		result += amp * filteredvsnoiset(pp, fw, fourthdimension);
		amp *= gain;  pp *= lacunarity;  fw *= lacunarity;
	    }
	}
    

	   void
	   pxslMarble(
		   color cs;
		   float veining;
		   point Pt;
		   vector dPdu;
		   vector dPdv;
		   output color Cmarble;)
	   {
	       float pixelsize, twice, scale, weight, turbulence, sat, val;
	       color cshsv, csrgb;
	       point PP = Pt;

    	       /* frequency adjustment (S-shaped curve) */
	       PP = PP * veining / 2; 
	       pixelsize = sqrt(area(PP)); 
	       twice = 2 * pixelsize;

	       /* compute turbulence */
	       turbulence = 0;
	       for (scale = 1; scale > twice; scale /= 2) {
		   turbulence += scale * abs(noise(PP/scale)-0.5);
	       }
	       /* gradual fade out of highest freq component near
		    visibility limit */
	       if (scale > pixelsize) {
		   weight = (scale / pixelsize) - 1;
		   weight = clamp(weight, 0, 1);
		   turbulence += weight * scale * abs(noise(PP/scale)-0.5);
	       }

	       /*
		* Assuming that Cs is in RGB space, convert to HSV space so
		* that we can modulate saturation and value without
		* changing hue.
		*/
	       cshsv = ctransform("hsv", cs);

	       /*
		* Now we have Cs in hue,sat,val (HSV) form.  Proceed to
		* modulate saturation and value based on the turbulence
		* computed earlier. Value is blended between the value of
		* Cs and white (value = 1). So a "black" marble has black
		* veins and a "white" marble has white veins outlined in
		* dark gray.
		*/
	       sat = comp(cshsv, 1);
	       val = comp(cshsv, 2);
	       sat *= float spline(turbulence,
		       0.999, 0.999, 0.200, 0.060, 0.030, 0.020,
		       0.010, 0.010, 0.000);
	       val *=  float spline(turbulence,
		       0.999, 0.999, 0.400, 0.000,
		       0.000, 0.000, 0.000,
		       0.000, 0.000, 0.000, 0.000
		       ) + float spline(turbulence,
		       0.000, 0.000, 0.000, 0.800,
		       0.800, 0.800, 0.800,
		       0.999, 0.999, 0.999, 0.999);
	       setcomp(cshsv, 1, sat);
	       setcomp(cshsv, 2, val);
	       Cmarble = ctransform("hsv", "rgb", cshsv);
	   }
       

		void pxslSurfacePoint (
		    	string coordsys;
			float usepref;
		    	output point Q; 
			output vector dQu;
			output vector dQv;
			) 
		{
		    extern point P;
		    extern vector dPdu, dPdv;
		    extern point __Pref;
		    extern float du, dv;
		    uniform string sys;
		    if(coordsys == "")
		    	sys = "shader";
		    else
		    	sys = coordsys;
		    if (usepref == 0)
		    {
		    	Q = transform(sys, P);
		    	dQu = transform (sys, P + dPdu*du) - Q;
		    	dQv = transform (sys, P + dPdv*dv) - Q;
		    }
		    else
		    {
			Q = transform(sys, __Pref);
			dQu = Du(Q) * du;
			dQv = Dv(Q) * dv;
		    }
		}
	    

		void
		pxslProjection( uniform float projection;
		    	    	uniform float imgcorrection;
				uniform float angle;
				uniform float repeatS; uniform float repeatT;
				uniform float offsetS; uniform float offsetT;
				point inQ;
				vector dinQu;
				vector dinQv;
				output point Q;
				output vector dQu;
				output vector dQv;
			      )
		{
		    float x, y;
		    uniform float pi2 = radians(360), pi = radians(180);
		    
		    if (projection == 0) /* planarx */
		    {
		    	if(imgcorrection == 0)
			{
			    x = zcomp(inQ);
			    y = ycomp(inQ);
			}
			else
			{
			    x = .5 - zcomp(inQ);
			    y = .5 - ycomp(inQ);/* 1-y-.5 */
    	    	    	}
			dQu = dinQu * vector(0,1,1);
			dQv = dinQv * vector(0,1,1);
		    }
		    else
		    if (projection == 1)  /* planary */
		    {
		    	if(imgcorrection == 0)
			{
			    x = xcomp(inQ);
			    y = zcomp(inQ);
			}
			else
			{
			    x = .5 - xcomp(inQ);
			    y = .5 - zcomp(inQ);
			}
			dQu = dinQu * vector(1,0,1);
			dQv = dinQv * vector(1,0,1);
		    }
		    else
		    if (projection == 2) /* planarz */
		    {
		    	if(imgcorrection == 0)
			{
			    x = xcomp(inQ);
			    y = ycomp(inQ);
			}
			else
			{
			    x = .5 - xcomp(inQ);
			    y = .5 - ycomp(inQ);
    	    	    	}
			dQu = dinQu * vector(1,1,0);
			dQv = dinQv * vector(1,1,0);
		    }
		    else
		    if (projection == 3) /* planarz-persp */
		    {
		    	float zinv = 1 / max(1e-6, zcomp(inQ));
			if(imgcorrection == 0)
			{
			    x = xcomp(inQ) * zinv;
			    y = ycomp(inQ) * zinv;
			}
			else
			{
			    x = (.5 - xcomp(inQ)) * zinv;
			    y = (.5 - ycomp(inQ)) * zinv;
    	    	    	}
			dQu = zinv * dinQu * vector(1,1,0);
			dQv = zinv * dinQv * vector(1,1,0);
		    }
		    else
		    if (projection == 4) /* autoplanar */
		    { 
			vector N = -normalize( calculatenormal(inQ) );
			x = N.vector (0,0,1);	/* x = cos of rotation */
			if (x < -.9998) /* if near 180 degrees */
			{	
			    /* just use z planar */
			    if(imgcorrection == 0)
			    {
			    	x = xcomp(inQ);
			    	y = ycomp(inQ);
			    }
			    else
			    {
			    	x = .5 - xcomp(inQ);
			    	y = .5 - ycomp(inQ);
    	    	    	    }
			    dQu = dinQu * vector(1,1,0);
			    dQv = dinQv * vector(1,1,0);
			}
			else 
			{
			    /* otherwise, rotate */
			    point QQ;
			    N = N^vector (0,0,1);
			    y = length (N); /* y = sin of rotation */
			    N = normalize (N);	/* N = rotation vector */
			    QQ = inQ*x + (vector(inQ).N)*N*(1-x) +
			    	 (N^vector(inQ))*y; /* rotate */
			    dQu = dinQu * x + (dinQu.N)*N*(1-x) +
			    	 (N^vector(dinQu))*y; /* rotate */
			    dQv = dinQv * x + (dinQv.N)*N*(1-x) +
			    	 (N^vector(dinQv))*y; /* rotate */
			    if(imgcorrection == 0)
			    {
			    	x = xcomp(QQ);
			    	y = ycomp(QQ);
			    }
			    else
			    {
    	    	    	    	x = .5 - xcomp(QQ);
				y = .5 - ycomp(QQ);
			    }
			}
		    }
		    else
		    if (projection == 5) /* box */
		    { 
			x = zcomp(inQ);
			y = ycomp(inQ); 
			if (abs (y) > abs (x))
			    x = y;
			y = xcomp(inQ);
			if (abs (y) > abs (x))
			    x = y;
			if (x == zcomp(inQ)) /* planar z */
			{
			    x = (-x < 0 ? -1 : 1) * xcomp(inQ);
			    y = -ycomp(inQ);
			}
			else
			if (x == xcomp(inQ)) /* planar x */
			{
			    x = (x < 0 ? -1 : 1) * zcomp(inQ);
			    y = -ycomp(inQ);
			}
			else
			if (x == ycomp(inQ)) /* planar y */
			{
			    x = xcomp(inQ);
			    y = (x < 0 ? -1 : 1) * zcomp(inQ);
			}
			x = x - .5;
			y = y - .5;
		    }
		    else
		    if (projection == 6) /* box spherical */
		    {
			point QQ;
			x = zcomp(inQ);
			y = ycomp(inQ);
			if (abs (y) > abs (x))
			    x = y;
			y = xcomp(inQ); 
			if (abs (y) > abs (x))
			    x = y;
			if (x == zcomp(inQ))
			{
			    QQ = point ( (-x < 0 ? -1 : 1) * xcomp(inQ), 
					ycomp(inQ), 
					(-x < 0 ? -1 : 1) * zcomp(inQ) );
			}
			else
			if (x == xcomp(inQ))
			{
			    QQ = point ( (x < 0 ? -1 : 1) * zcomp(inQ), 
					ycomp(inQ),
					(-x < 0 ? -1 : 1) * xcomp(inQ) );
			}
			else
			if (x == ycomp(inQ))
			{
			    QQ = point ( xcomp(inQ),
					(x < 0 ? -1 : 1) * zcomp(inQ),
					(-x < 0 ? -1 : 1) * ycomp(inQ) );
			}
			x = .5 + atan (xcomp(QQ), -zcomp(QQ)) / pi2;
			y = length (vector (xcomp(QQ), 0, zcomp(QQ)));
			y = .5 - atan (ycomp(QQ), y) / pi;
		    }
		    else
		    if (projection == 7) /* spherical */
		    {
		    	/* atan2: -pi->pi */
			x = .5 + atan(xcomp(inQ), -zcomp(inQ)) / pi2;  
			y = length( vector( xcomp(inQ), 0, zcomp(inQ) ));
			y = .5 - atan(ycomp(inQ), y) / pi;
		    }
		    else
		    if (projection == 8) /* cylindrical */
		    { 
		    	/* atan2: -pi->pi */
			x = .5 + atan(xcomp(inQ), -zcomp(inQ)) / pi2; 
			y = -ycomp(inQ);
			y = y - .5;
		    }
		    else    /* st */
		    {
    	    	    	extern float s, t;
			x = s;
			y = t;
		    }
		    setxcomp(Q, repeatS * x + offsetS);
		    setycomp(Q, repeatT * y + offsetT);
		    setzcomp(Q, 0);
		    if(angle != 0)
		    {
			Q = rotate(Q, radians(angle), point(0,0,0),
			    	    point(0,0,1)); 
		    }
		}
	    

#include "pxslUtil.h"
#include "noises.h"
	void
	pxslTurbulence (uniform float octaves, lacunarity, gain;
	    float fourthdimension;
	    point p;
	    vector dpu, dpv;
	    output float result;)
	{
	    uniform float amp = 1;
	    varying point pp = p;
	    varying float fw = pxslFilterWidth(dpu, dpv);
	    uniform float i;
	    extern float du, dv; /* for filterwidth macro */
    	    result = 0;
	    for (i = 0;  i < octaves;  i += 1) {
	#pragma nolint
		float n = filteredsnoiset (pp, fw, fourthdimension);
		float dn = filterwidth(n);
		result += amp * filteredabs (n, dn);
		amp *= gain;  pp *= lacunarity;  fw *= lacunarity;
	    }
	}
    

		void 
		pxslWarp( 
		    vector warpFunc;
		    uniform vector Kw;
		    point inQ;
		    vector indQx;
		    vector indQy;
		    output point Q;
		    output vector dQx;
		    output vector dQy;
		    )
		{
		    Q =  inQ + Kw * warpFunc;
		    dQx = indQx;
		    dQy = indQy; /* to do */
		}
	    

#include "pxslRemap.h"
		void
		pxslColorToGray( color c;
			float conversion;
			float invert;
			float bias;
			float gain;
			output float result; )
		{
		    if(conversion == 0)
		    {
			result = comp(c,0);
		    }
		    else
		    if(conversion == 1)
		    {
			result = comp(c,1);
		    }
		    else
		    if(conversion == 2)
		    {
			result = comp(c,2);
		    }
		    else
		    if(conversion == 3)
		    {
			result = .3 * comp(c, 0) + .59 * comp(c, 1) + 
			    .11 * comp(c, 2);
		    }
		    else
		    if(conversion == 4)
		    {
			result = max( comp(c,0), comp(c,1), comp(c,2) );
		    }
		    else
		    if(conversion == 5)
		    {
			result = (comp(c,0) + comp(c,1) + comp(c,2)) / 3;
		    }
		    else
		    if(conversion == 6)
		    {
			result = min( comp(c,0), comp(c,1), comp(c,2) );
		    }
		    if(invert == 1)
			result = 1 - result;
		    result = pxslFloatBias(bias, result);
		    result = pxslFloatGain(gain, result);
		}
	    
/* end referenced functions ------------------------*/
  normal Nf;
  point PP = transform("shader", P);
  float disptotal;
  point tmp0;
  vector tmp1;
  vector tmp2;
  pxslSurfacePoint ( /* rockSpace */
    rockSpace_Space,
    rockSpace_UsePref,
    tmp0,
    tmp1,
    tmp2
    );
  point tmp3;
  vector tmp4;
  vector tmp5;
  pxslSurfacePoint ( /* SurfacePoint */
    SurfacePoint_Space,
    SurfacePoint_UsePref,
    tmp3,
    tmp4,
    tmp5
    );
  point tmp6;
  vector tmp7;
  vector tmp8;
  pxslProjection ( /* Projection0 */
    Projection0_projection,
    1 /* Planar for Textures */,
    0 /* Angle */,
    1 /* S Repeats */,
    1 /* T Repeats */,
    0 /* S Offset */,
    0 /* T Offset */,
    tmp0,
    tmp1,
    tmp2,
    tmp6,
    tmp7,
    tmp8
    );
  vector tmp9;
  pxslVBrownian ( /* VBrownian */
    4 /* octaves */,
    2 /* lacunarity */,
    .5 /* gain */,
    0 /* Fourth Dimension */,
    tmp3,
    tmp4,
    tmp5,
    tmp9
    );
  float tmp10;
  pxslTurbulence ( /* Turbulence0 */
    8 /* octaves */,
    3.75 /* lacunarity */,
    0.33 /* gain */,
    0 /* Fourth Dimension */,
    tmp6,
    tmp7,
    tmp8,
    tmp10
    );
  float tmp11;
  pxslWorley ( /* Dots */
    42.4 /* frequency */,
    "Euclidian" /* distancemetric */,
    0.96 /* jitter */,
    1 /* clamp */,
    2.00 /* c1 */,
    0.72 /* c2 */,
    tmp6,
    tmp7,
    tmp8,
    tmp11
    );
  color tmp12;
  pxslMarble ( /* Marble2 */
    color(0,.25,.6) /* MarbleColor */,
    3.47 /* MarbleVeining */,
    tmp6,
    tmp7,
    tmp8,
    tmp12
    );
  point tmp13;
  vector tmp14;
  vector tmp15;
  pxslWarp ( /* Warp0 */
    tmp9,
    vector(0.50,0.50,0.50) /* Kw */,
    tmp6,
    tmp7,
    tmp8,
    tmp13,
    tmp14,
    tmp15
    );
  float tmp16;
  pxslRemap ( /* RockWaves */
    tmp10,
    0 /* inputmin */,
    1 /* inputmax */,
    RockWaves_outputmin,
    RockWaves_outputmax,
    RockWaves_Bias,
    RockWaves_Gain,
    tmp16
    );
  pxslColorToGray ( /* ColorToGray2 */
    tmp12,
    3 /* Conversion */,
    0 /* Invert */,
    0.63 /* Bias */,
    0.27 /* Gain */,
    tmp10
    );
  float tmp17;
  pxslWorley ( /* Worley1 */
    2.8 /* frequency */,
    "Euclidian" /* distancemetric */,
    0.86 /* jitter */,
    1 /* clamp */,
    1.97 /* c1 */,
    0.08 /* c2 */,
    tmp13,
    tmp14,
    tmp15,
    tmp17
    );
  float tmp18;
  pxslRemap ( /* Remap1 */
    tmp10,
    0 /* inputmin */,
    1 /* inputmax */,
    0 /* outputmin */,
    1 /* outputmax */,
    .5 /* Bias */,
    .5 /* Gain */,
    tmp18
    );
  pxslRemap ( /* Spots */
    tmp17,
    0 /* inputmin */,
    1 /* inputmax */,
    0.80 /* outputmin */,
    0.00 /* outputmax */,
    .5 /* Bias */,
    .5 /* Gain */,
    tmp10
    );
  pxslFloatToColor ( /* FloatToColor5 */
    tmp18,
    tmp12
    );
  pxslColorToGray ( /* ColorToGray0 */
    tmp12,
    3 /* Conversion */,
    0 /* Invert */,
    .5 /* Bias */,
    .5 /* Gain */,
    tmp17
    );
  if(combineOp == 0) /* add */
      disptotal = 0;
  else
  if(combineOp == 1) /* multiply */
     disptotal = 1;
  Nf = normalize( ntransform("shader", N) );
  if(combineOp == 0) /* add */
      disptotal += Kb1 * tmp11;
  else /* multiply */
      disptotal *= Kb1 * tmp11;
  if(combineOp == 0) /* add */
      disptotal += Kb2 * tmp10;
  else /* multiply */
      disptotal *= Kb2 * tmp10;
  if(combineOp == 0) /* add */
      disptotal += Kb3 * tmp16;
  else /* multiply */
      disptotal *= Kb3 * tmp16;
  if(combineOp == 0) /* add */
      disptotal += Kb4 * tmp17;
  else /* multiply */
      disptotal *= Kb4 * tmp17;
  PP += Kb * disptotal * Nf;
  PP = transform("shader", "current", PP);
  N = calculatenormal(PP);
  if( DoDisplacement != 0 )
       P = PP;
}

