/*
** Copyright (c) 2000 PIXAR.  All rights reserved.  This program or
** documentation contains proprietary confidential information and trade
** secrets of PIXAR.  Reverse engineering of object code is prohibited.
** Use of copyright notice is precautionary and does not imply
** publication.
**
**                      RESTRICTED RIGHTS NOTICE
**
** Use, duplication, or disclosure by the Government is subject to the
** following restrictions:  For civilian agencies, subparagraphs (a) through
** (d) of the Commercial Computer Software--Restricted Rights clause at
** 52.227-19 of the FAR; and, for units of the Department of Defense, DoD
** Supplement to the FAR, clause 52.227-7013 (c)(1)(ii), Rights in
** Technical Data and Computer Software.
**
** Pixar
** 1001 West Cutting Blvd.
** Richmond, CA  94804
**
** ----------------------------------------------------------------------------
*/
/* code generated by slim 1.1b1, RAT 4.1b1 (Apr 25 2000 13:42:49) */
/* for dsisson@glaw.rainsound.com at: Tue Apr 25 17:29:30 PDT 2000 */
displacement Simple_0_0 (
  string SurfacePoint_Space="";
  varying point __Pref=point(-1e10,-1e10,-1e10);
  )
{
/* begin referenced functions ----------------------*/

	    	void pxslF_Fractal (
		    float	Layers;
		    float	Frequency;
		    float	Lacunarity;
		    float	Dimension;
		    float	Erosion;
		    float	Variation;
		    point	Q;
		    vector	duQ;
		    vector	dvQ;
		    output float	result;
		)
		{
		    float Noise (point Q)
		    {
			extern float	Variation;

			return (smoothstep (.2, .8, float noise (Q, Variation)));
		    }
		    
		    uniform float	i;
		    float	sum, mag, f;
		    float	dQ;

		    dQ = max (
			max (
			    abs(xcomp(duQ)) + abs(xcomp(dvQ)),
			    abs(ycomp(duQ)) + abs(ycomp(dvQ))
			),
			abs(zcomp(duQ)) + abs(zcomp(dvQ))
		    );

		    f = Frequency;
		    result = mix (Noise (f*Q), .5, smoothstep (.25, 1, f*dQ));
		    sum = 1;

		    for (i=1; i < Layers; i+=1) {
			f *= Lacunarity;
			mag = 1/pow (f, 3-2*Dimension + mix (-Erosion, Erosion, result/sum));
			result += mag*mix (Noise (f*Q), .5, smoothstep (.25, 1, f*dQ));
			sum += mag;
		    }

		    result /= sum;
		}
	    

		void pxslSurfacePoint (
		    uniform string coordsys;
		    uniform float frequency;
		    uniform float ignorePref;
		    output point Q; 
		    output vector dQu;
		    output vector dQv;
		) 
		{
		    extern point P;
		    extern vector dPdu, dPdv;
		    extern point __Pref;
		    extern float du, dv;
		    uniform string sys;

		    if(coordsys == "")
		    	sys = "shader";
		    else
		    	sys = coordsys;

		    if (xcomp(__Pref) == -1e10 || ignorePref != 0)
		    {
		    	Q = transform (sys, frequency*P);
		    	dQu = vtransform (sys, dPdu*du*frequency);
		    	dQv = vtransform (sys, dPdv*dv*frequency);
		    }
		    else 
		    {
			Q = frequency * transform (sys, __Pref);
			dQu = vector Du(Q)*du;
		        dQv = vector Dv(Q)*dv;
		    }
		}
	    
/* end referenced functions ------------------------*/
  normal Nf;
  point PP = transform("shader", P);
  point tmp0;
  vector tmp1;
  vector tmp2;
  pxslSurfacePoint ( /* SurfacePoint */
    SurfacePoint_Space,
    1 /* Frequency */,
    0 /* IgnorePref */,
    tmp0,
    tmp1,
    tmp2
    );
  float tmp3;
  pxslF_Fractal ( /* Fractal_1 */
    8 /* Layers */,
    1.59 /* Frequency */,
    2 /* Lacunarity */,
    1.18 /* Dimension */,
    1.15 /* Erosion */,
    0 /* Variation */,
    tmp0,
    tmp1,
    tmp2,
    tmp3
    );
  Nf = normalize( ntransform("shader", N) );
  PP += 0.040 * tmp3*Nf;
  PP = transform("shader", "current", PP);
  if(0 != 0) { 
      normal deltaN = normalize(N) - normalize(Ng);
      N = normalize(calculatenormal(PP)) + deltaN;
  } else {
      N = calculatenormal(PP);
  }
  if(0 != 0)
      P = PP;
}

