/*
** Copyright (c) 2000 PIXAR.  All rights reserved.  This program or
** documentation contains proprietary confidential information and trade
** secrets of PIXAR.  Reverse engineering of object code is prohibited.
** Use of copyright notice is precautionary and does not imply
** publication.
**
**                      RESTRICTED RIGHTS NOTICE
**
** Use, duplication, or disclosure by the Government is subject to the
** following restrictions:  For civilian agencies, subparagraphs (a) through
** (d) of the Commercial Computer Software--Restricted Rights clause at
** 52.227-19 of the FAR; and, for units of the Department of Defense, DoD
** Supplement to the FAR, clause 52.227-7013 (c)(1)(ii), Rights in
** Technical Data and Computer Software.
**
** Pixar
** 1001 West Cutting Blvd.
** Richmond, CA  94804
**
** ----------------------------------------------------------------------------
*/
/* code generated by slim 1.1b0, RAT 4.1b0 (Apr 21 2000 13:02:16) */
/* for dsisson@glaw.rainsound.com at: Fri Apr 21 16:32:25 PDT 2000 */
surface Tile_1 (
  float TileST_repeatS=10.000;
  float TileST_repeatT=10.000;
  )
{
/* begin referenced functions ----------------------*/

		void 
		pxslWarp( 
		    vector warpFunc;
		    uniform vector Kw;
		    point Qin;
		    vector dQuin;
		    vector dQvin;
		    output point Q;
		    output vector dQu;
		    output vector dQv;
		    )
		{
		    extern float du, dv;
		    Q = Qin + Kw * warpFunc;
		    dQu = vector Du(Q)*du;
		    dQv = vector Dv(Q)*dv;
		}
	    

	   void pxslFloatToColor(float fa; color ca; output color c;)
	   {
	       c = ca * color(fa,fa,fa);
	   }
       

		void
		pxslShapes (
		    float	shape;
		    float	fuzziness;
		    float	invert; 
		    point	Q;
		    vector	duQ;
		    vector	dvQ;
		    output float	result;
		)
		{
		    uniform float	size = .45;

		    if(shape == 1) /* star */
		    {
			varying float	x, y;

			/* from peachey */
			uniform float starangle = 2*PI / 5;
			uniform float rmin = .14;
			uniform float rmax = .4;
			uniform point p0 = rmax * (cos(0), sin(0), 0);
			uniform point p1 = rmin * 
			    (cos(starangle/2), sin(starangle/2), 0);
			uniform vector	d0 = p1 - p0;
			vector d1;
			float r, a, angle;

			varying point	Qr;

			angle = 2*PI/5*zcomp(Q);
			Qr = rotate (Q-.5, angle, point(0,0,0), point(0,0,1));
			x = xcomp(Qr);
			y = ycomp(Qr);

			angle = atan(x, y) + PI;
			r = sqrt(x*x + y*y);
			a = mod(angle, starangle) / starangle;
			if( a >= .5 )
			    a = 1 - a;

			d1 = r * (cos(a), sin(a), 0) - p0;

			result = (1 - filterstep(rmax, r,
				"width", 1+4*fuzziness, "filter", "gaussian")) *
				 filterstep (0, zcomp(d0^d1), 
			    	"width", 1+4*fuzziness, "filter", "gaussian");
		    }
		    else
		    if(shape == 2) /* circle */
		    {
			varying float	x, y;
			varying float	r, dr;

			x = xcomp(Q)-.5;
			y = ycomp(Q)-.5;
			r = sqrt(x*x + y*y);
			
			x = xcomp(duQ) + xcomp(dvQ);
			y = ycomp(duQ) + ycomp(dvQ);
			dr = max (.5*fuzziness, sqrt (x*x + y*y));

			result = 1 - filterstep (size, r, r+dr);
		    }
		    else
		    if(shape == 3) /* square */
		    {
			varying float	x, y;
			varying float	dx, dy;

			x = xcomp(Q)-.5;
			y = ycomp(Q)-.5;
			dx = max (.5*fuzziness, abs(xcomp(duQ)) +
			    	 abs(xcomp(dvQ)));
			dy = max (.5*fuzziness, abs(ycomp(duQ)) +
			    	 abs(ycomp(dvQ)));

			result = filterstep (-size, x, x+dx) - 
			    	filterstep (size, x, x+dx);
			result *= filterstep (-size, y, y+dy) - 
			    	filterstep (size, y, y+dy);
		    }
		    else
		    if(shape == 4) /* diamond */
		    {
			uniform float	w = size / sqrt(2.0);
			varying float	angle = radians(45) + PI/2*zcomp(Q);

			varying point	Qr;
			varying vector	duQr, dvQr;
			varying float	x, y;
			varying float	dx, dy;

			Qr = rotate (Q-.5, angle, point(0,0,0), point(0,0,1)); 
			duQr = rotate (duQ, angle, point(0,0,0), point(0,0,1)); 
			dvQr = rotate (dvQ, angle, point(0,0,0), point(0,0,1)); 

			x = xcomp(Qr);
			y = ycomp(Qr);
			dx = max (.5*fuzziness, abs(xcomp(duQr)) +
			    	 abs(xcomp(dvQr)));
			dy = max (.5*fuzziness, abs(ycomp(duQr)) +
			    	 abs(ycomp(dvQr)));

			result = filterstep (-w, x, x+dx) - 
			    	filterstep (w, x, x+dx);
			result *= filterstep (-w, y, y+dy) - 
			    	filterstep (w, y, y+dy);
		    }
		    else
		    if(shape == 5) /* checker-like thingy */
		    {
			varying float	x, y;
			varying float	dx, dy;

			x = mod (xcomp(Q)-.5, 1);
			y = mod (ycomp(Q)-.5, 1);
			dx = max (.5*fuzziness, abs(xcomp(duQ)) +
			    	     abs(xcomp(dvQ)));
			dy = max (.5*fuzziness, abs(ycomp(duQ)) +
			    	 abs(ycomp(dvQ)));

			x = filterstep(.5, x, x+dx);
			y = filterstep(.5, y, y+dy);
			result = mix (x, (1-x), y);
		    }
		    else
		    if(shape == 6) /* x ramp */
		    {
			varying float	x, dx;

			x = xcomp(Q)-.5;
			dx = max (.5*fuzziness, abs(xcomp(duQ)) +
			    	 abs(xcomp(dvQ)));

			result = mix (x+1, x, filterstep (0, x, x+dx));
		    }
		    else
		    if(shape == 7) /* y ramp */
		    {
			varying float	y, dy;

			y = ycomp(Q)-.5;
			dy = max (.5*fuzziness, abs(ycomp(duQ)) +
			    	 abs(ycomp(dvQ)));

			result = mix (y+1, y, filterstep (0, y, y+dy));
		    }
		    else
		    if(shape == 8) /* xy ramp */
		    {
			varying float	x, y;
			varying float	dx, dy;

			x = xcomp(Q)-.5;
			y = ycomp(Q)-.5;
			dx = max (.5*fuzziness, abs(xcomp(duQ)) +
			    	 abs(xcomp(dvQ)));
			dy = max (.5*fuzziness, abs(ycomp(duQ)) +
			    	 abs(ycomp(dvQ)));

			result = mix (x+1, x, filterstep (0, x, x+dx));
			result += mix (y+1, y, filterstep (0, y, y+dy));
			result *= .5;
		    }
		    else
		    if(shape == 9) /* squiggles */
		    {
			varying float	x, y;
			varying float	r, dr;

			x = xcomp(duQ) + xcomp(dvQ);
			y = ycomp(duQ) + ycomp(dvQ);
			dr = max (.5*fuzziness, sqrt (x*x + y*y));

			if (zcomp(Q) < .5)
			    x = 1-xcomp(Q);
			else
			    x = xcomp(Q);

			x = x;
			y = ycomp(Q);

			r = sqrt(x*x + y*y);
			result = filterstep (.4, r, r+dr) - 
			    	    filterstep (.6, r, r+dr);

			x = 1-x;
			y = 1-y;

			r = sqrt(x*x + y*y);
			result = max (result, filterstep (.4, r, r+dr) -
			    	     filterstep (.6, r, r+dr));
		    }

		    if (invert != 0)
			result = 1 - result;    
		}
	    

		/*  Worley noise -- 3-D, 2-feature version.*/
		void
		pxslWorley (float frequency;
		    	    uniform string distancemetric;
		    	    float jitter;
			    uniform float clamp;
		    	    float c1, c2;
			    point p;
			    vector dpdu;
			    vector dpdv;
			    output float g;
		    	    )
		{
    	    	    float f1,f2;
		    point pp = frequency * p;
		    point thiscell = point (floor(xcomp(pp))+0.5,
		     	    	    	    floor(ycomp(pp))+0.5,
					    floor(zcomp(pp))+0.5);
		    f1 = f2 = 1000;
		    uniform float i, j, k;
		    for (i = -1;  i <= 1;  i += 1) {
        		for (j = -1;  j <= 1;  j += 1) {
        		    for (k = -1;  k <= 1;  k += 1) {
				point testcell = thiscell + vector(i,j,k);
                		point pos = testcell + jitter * 
				    (vector cellnoise (testcell) - 0.5);
				vector offset = pos - pp;
                		float dist;
				if (distancemetric == "Euclidian")  	
				    dist = offset.offset;
				else
				{
				    dist =  abs(xcomp(offset)) +
				    	    abs(ycomp(offset)) +
					    abs(zcomp(offset));
				}
                		if (dist < f1) {
                		    f2 = f1;
                		    f1 = dist;
                		} else if (dist < f2) {
                		    f2 = dist;
				}
        		    }
			}
		    }
		    if (distancemetric == "Euclidian")  	
    	    	    {
		    	f1 = sqrt(f1);
		    	f2 = sqrt(f2);
		    }
		    g = f1 * c1 + f2 * c2;
		    if (clamp != 0)
		    {
		    	g = clamp(g, 0, 1);
		    }
		}
	    

#include "pxslRemap.h"
		void 
		pxslRemapF(float f; 
			float inputmin, inputmax;
			float outputmin, outputmax;
			float disablegain;
			float bias, gain;
			output float result; )
		{
		    result = clamp(f, inputmin, inputmax);
		    result = outputmin + (outputmax - outputmin) * 
		    	(result - inputmin) / (inputmax - inputmin);
		    if (disablegain == 0)
		    {
		    	result = pxslFloatBias(bias, result);
		    	result = pxslFloatGain(gain, result);
		    }
		}
	    

	   void
	   pxslCombineColors( float method; color f1; color f2; 
		    	       output color result;)
	   {
	       if (method == 0)
	       {
		   /* Intersection */
		   result = f1 * f2;
	       }
	       else
	       if (method == 1)
	       {
		   /* Union */
		   result = f1 + f2 - f1 * f2;
	       }
	       else
	       if (method == 2)
	       {
		   /* Difference */
		   result = f1 - f1 * f2;
	       }
	   }
       

		void pxslST (
			  uniform float angle;
			  uniform float repeatS; uniform float repeatT;
			  uniform float offsetS; uniform float offsetT;
			  output point Q;
			  output vector dQu;
			  output vector dQv;
			  )
		{
		    extern float s, t, du, dv;

		    setxcomp(Q, repeatS * s + offsetS);
		    setycomp(Q, repeatT * t + offsetT);
		    setzcomp(Q, 0);

		    if(angle != 0)
			Q = rotate(Q, radians(angle), 
			    	    point(0,0,0), point(0,0,1)); 

		    dQu = vector Du(Q)*du;
		    dQv = vector Dv(Q)*dv;
		}
	    

#include "pxslUtil.h"
#include "noises.h"
	void
	pxslVBrownian (
	    uniform float baseFreq;
	    uniform float octaves, lacunarity, gain; float fourthdimension;
	    point p;
	    vector dpu, dpv;
	    output vector result;)
	{
	    uniform float amp = 1;
	    uniform float sum = 0;
	    varying point pp = baseFreq * p;
	    varying float fw = pxslFilterWidth(baseFreq*dpu, baseFreq*dpv);
	    uniform float i;
    	    result = 0;
	    for (i = 0;  i < octaves;  i += 1) {
#pragma nolint
		result += amp * filteredvsnoiset(pp, fw, fourthdimension);
		sum += amp;  amp *= gain;  pp *= lacunarity;  fw *= lacunarity;
	    }
	    result /= sum;
	}
    

		void
		pxslTile (
		    uniform point frequency; 
		    uniform float tilesize;
		    uniform float jitter; 
		    uniform float rowoffset;
		    uniform float randomz;
		    point Qin;
		    vector dQuin;
		    vector dQvin;
		    output point Q;
		    output vector dQu;
		    output vector dQv;
		)
		{
		    float x, y, xOffset = 0;
		    point jitterPt;
		    
		    dQu = dQuin * frequency * tilesize;
		    dQv = dQvin * frequency * tilesize;

		    Q = Qin * frequency;
		    x = xcomp(Q);
		    y = ycomp(Q);

		    if ((rowoffset != 0) && (abs (mod (y, 2)) < 1))
			    x += .5;

		    jitterPt = point (x, y, 0);

		    x = mod (x, 1);
		    y = mod (y, 1);
		    Q = tilesize*(point (x, y, .5) - vector .5) + vector .5;

		    Q += jitter*(tilesize-1) * 
		    	    (vector .5 - vector cellnoise (jitterPt));

		    if (randomz != 0)
			setzcomp (Q, float cellnoise (jitterPt));
		    else
			setzcomp (Q, 0);
		}
	    

	   void
	   pxslPlastic(color SurfaceColor;
		   color SurfaceOpacity;
		   float Ka;
		   float Kd;
		   float Ks;
		   float Roughness;
		   color SpecularColor;
		   output color CI;
		   output color OI;
		   )
	   {
	       normal Nf;
	       vector V;
	       extern normal N;
	       extern vector I;
	       Nf = faceforward( normalize(N), I );
	       V = -normalize(I);
	       OI = SurfaceOpacity;
	       CI = SurfaceOpacity * 
		       (SurfaceColor *
		    	   (Ka*ambient() + Kd*diffuse(Nf)) +
			   SpecularColor * Ks * specular(Nf,V,Roughness));
	   }
       
/* end referenced functions ------------------------*/
  point tmp0;
  vector tmp1;
  vector tmp2;
  pxslST ( /* TileST */
    0 /* Angle */,
    TileST_repeatS,
    TileST_repeatT,
    0 /* S Offset */,
    0 /* T Offset */,
    tmp0,
    tmp1,
    tmp2
    );
  point tmp3;
  vector tmp4;
  vector tmp5;
  pxslST ( /* ST */
    0 /* Angle */,
    1 /* S Repeats */,
    1 /* T Repeats */,
    0 /* S Offset */,
    0 /* T Offset */,
    tmp3,
    tmp4,
    tmp5
    );
  vector tmp6;
  pxslVBrownian ( /* SpecBrownian */
    5.000 /* Base Frequency */,
    4 /* octaves */,
    2 /* lacunarity */,
    .5 /* gain */,
    0 /* Fourth Dimension */,
    tmp0,
    tmp1,
    tmp2,
    tmp6
    );
  point tmp7;
  vector tmp8;
  vector tmp9;
  pxslTile ( /* Tile_Tile */
    point(3.00,3.00,3.00) /* Frequency */,
    1 /* Tile Size */,
    0 /* Jitter */,
    0 /* Row Offset */,
    0 /* Random Z */,
    tmp0,
    tmp1,
    tmp2,
    tmp7,
    tmp8,
    tmp9
    );
  point tmp10;
  vector tmp11;
  vector tmp12;
  pxslWarp ( /* SPecWarp */
    tmp6,
    vector(0.15,0.15,0.15) /* Kw */,
    tmp3,
    tmp4,
    tmp5,
    tmp10,
    tmp11,
    tmp12
    );
  point tmp13;
  vector tmp14;
  pxslTile ( /* ColorTile */
    point(1.00,1.00,1.00) /* Frequency */,
    0.95 /* Tile Size */,
    0 /* Jitter */,
    0 /* Row Offset */,
    0 /* Random Z */,
    tmp7,
    tmp8,
    tmp9,
    tmp13,
    tmp6,
    tmp14
    );
  float tmp15;
  pxslWorley ( /* SpecWorley */
    26.4 /* frequency */,
    "Euclidian" /* distancemetric */,
    .75 /* jitter */,
    1 /* clamp */,
    .8 /* c1 */,
    -.2 /* c2 */,
    tmp10,
    tmp11,
    tmp12,
    tmp15
    );
  float tmp16;
  pxslShapes ( /* Tile_Shapes */
    3 /* Shape */,
    0.08 /* Fuzziness */,
    0 /* Invert */,
    tmp13,
    tmp6,
    tmp14,
    tmp16
    );
  float tmp17;
  pxslRemapF ( /* KdRemap */
    tmp15,
    0 /* inputmin */,
    1 /* inputmax */,
    0.50 /* outputmin */,
    0.64 /* outputmax */,
    0 /* Disable Bias/Gain */,
    .5 /* Bias */,
    .5 /* Gain */,
    tmp17
    );
  color tmp18;
  pxslFloatToColor ( /* TileFloatToColor */
    tmp16,
    color(1,1,1) /* Coloration */,
    tmp18
    );
  color tmp19;
  pxslCombineColors ( /* CombineColors_1_0 */
    0 /* Combine Method */,
    tmp18,
    color(0.647058823529,0.617564285229,0.515109573241) /* f2 */,
    tmp19
    );
  color tmp20;
  pxslPlastic ( /* Tile_1 */
    tmp19,
    color(1,1,1) /* Opacity */,
    .05 /* Ka */,
    tmp17,
    tmp15,
    0.14 /* Roughness */,
    color(1,1,1) /* Specular Color */,
    tmp18,
    tmp20
    );
  Ci = tmp18;
  Oi = tmp20;
}

