/*
** Copyright (c) 1999 PIXAR.  All rights reserved.  This program or
** documentation contains proprietary confidential information and trade
** secrets of PIXAR.  Reverse engineering of object code is prohibited.
** Use of copyright notice is precautionary and does not imply
** publication.
**
**                      RESTRICTED RIGHTS NOTICE
**
** Use, duplication, or disclosure by the Government is subject to the
** following restrictions:  For civilian agencies, subparagraphs (a) through
** (d) of the Commercial Computer Software--Restricted Rights clause at
** 52.227-19 of the FAR; and, for units of the Department of Defense, DoD
** Supplement to the FAR, clause 52.227-7013 (c)(1)(ii), Rights in
** Technical Data and Computer Software.
**
** Pixar
** 1001 West Cutting Blvd.
** Richmond, CA  94804
**
** ----------------------------------------------------------------------------
*/
/* code generated by slim 1.0d01, RAT 4.0d01 (Sep 10 1999 10:37:26) */
/* for dsisson@glaw.rainsound.com at: Fri Sep 10 11:45:40 PDT 1999 */
surface Wall5 (
  float ST1_repeatS=8.0;
  float ST1_repeatT=4.0;
  float ST2_repeatS=8.0;
  float ST2_repeatT=4.0;
  float Projection0_projection=2;
  color color2_f2=color(0.716945143816,0.725474937057,0.0);
  color color1_f2=color(0.809994659342,0.402609292744,0.202487220569);
  color Metal0_SurfaceColor=color(0.749996185245,0.749996185245,0.749996185245);
  )
{
/* begin referenced functions ----------------------*/

#include "pxslRemap.h"
		void 
		pxslRemap(float f; 
			float inputmin, inputmax;
			float outputmin, outputmax;
			float bias, gain;
			output float result; )
		{
		    result = clamp(f, inputmin, inputmax);
		    result = outputmin + (outputmax - outputmin) * 
		    	(result - inputmin) / (inputmax - inputmin);
		    result = pxslFloatBias(bias, result);
		    result = pxslFloatGain(gain, result);
		}   
	    

	   void
	   pxslBlinn(color SurfaceColor;
		   color SurfaceOpacity;
		   color ambientColor;
		   color Incandescence;
		   float diffuseCoeff;
		   float translucenceCoeff;
		   color specularColor;
		   float eccentricity;
		   float specularRollOff;
		   float reflectivity;
		   output color CI;
		   output color OI; )
	   {
	       color
	       getTranslucence( normal Nf; float c; )
	       {
		   color C = 0;
		   extern point P;
		   extern color Cl;
		   float nondiff;

		   if( c != 0 )
		   {
		       illuminance(P, Nf, PI)
		       {
			   if( 0 == lightsource("__nondiffuse", nondiff) )
			       nondiff = 0;
			   C += (1 - nondiff) * Cl;
		       }
		       C *= c;
 		   }
		   return C;
	       }
	       color
	       getBlinn( normal Nf;
		       float eccentricity, specularRollOff;
		       output color Cr; )
	       {
		   float E = 1 / (eccentricity * eccentricity - 1);
		   color C = 0;
		   vector H, Ln, V, Nn;
		   float NH, NH2, NHSQ, Dd, Gg, VN, VH, LN, Ff, tmp;
		   float nondiff, nonspec;
		   extern point P;
		   extern vector L, I;
		   extern color Cl;

		   Cr = 0;
		   V = normalize(-I);
		   VN = V.Nf;
		   illuminance(P, Nf, 1.57079632679)
		   {
		       if( 0 == lightsource("__nonspecular", nonspec) )
			   nonspec = 0;
		       if( nonspec < 1 )
		       {
			   Ln = normalize(L);
			   H = normalize(Ln+V);
			   NH = Nf.H;
			   NHSQ = NH*NH;
			   NH2 = NH * 2;
			   Dd = (E+1) / (NHSQ + E);
			   Dd *= Dd;
			   VH = V.H;
			   LN = Ln.Nf;
			   if( VN < LN )
			   {
			       if( VN * NH2 < VH )
				   Gg = NH2 / VH;
			       else
				   Gg = 1 / VN;
			   }
			   else
			   {
			       if( LN * NH2 < VH )
				   Gg = (LN * NH2) / (VH * VN);
			       else
				   Gg = 1 / VN;
			   }
			   /* poor man's Fresnel */
			   tmp = pow((1 - VH), 3);
			   Ff = tmp + (1 - tmp) * specularRollOff;
			   C += Cl * Dd * Gg * Ff;

			   /* now look for environment reflections.  These
			       are indicated by lights which are specular AND
			       nondiffuse */
			   if( 0 != lightsource("__nondiffuse", nondiff) )
			   {
			       Cr += (1 - nonspec) * nondiff * Ff * Cl;
			   }
		       }
		   }
		   return C;
	       }
	       normal Nf;
	       vector R;
	       color Ia, Id, Itr, Is, Ir, Isr;
	       extern normal N;
	       extern vector I;
	       Nf = faceforward( normalize(N), I );
	       R = reflect(normalize(I), Nf);
	       Ia = ambientColor * ambient();
	       Id = diffuseCoeff*diffuse(Nf);
	       Itr = getTranslucence(Nf, translucenceCoeff);
	       Is = getBlinn(Nf, eccentricity, specularRollOff, Ir);
	       Ir = reflectivity * Ir;
	       Isr = specularColor * (Is + Ir);
	       OI = SurfaceOpacity;
	       CI = OI * SurfaceColor * (Ia + Id + Itr + Incandescence + Isr);
	   }
       

		void pxslST (
			  uniform float angle;
			  uniform float repeatS; uniform float repeatT;
			  uniform float offsetS; uniform float offsetT;
			  output point Q;
			  output vector dQu;
			  output vector dQv;
			  )
		{
		    extern float s, t, du, dv;
		    setxcomp(Q, repeatS * s + offsetS);
		    setycomp(Q, repeatT * t + offsetT);
		    setzcomp(Q, 0);
		    if(angle != 0)
		    {
			Q = rotate(Q, radians(angle), point(0,0,0),
			    	     point(0,0,1)); 
		    }
		    dQu = Du(Q) * du;
		    dQv = Dv(Q) * dv;
		}
	    

	   void pxslFloatToColor(float ca; output color c;)
	   {
	       c = color(ca,ca,ca);
	   }
       

		void
		pxslWaves1D(float shape;
			    float shapeFactor;
			    float freqVariance;
			    float ampVariance;
			    float domain;
			    float min;
			    float max;
			    float frequency;
			    float velocity;
			    point pt;
			    vector dptdu;
			    vector dptdv;
			    output float result)
		{
		    /* adapted from Schlick: Graphics Gems Vol V */
		    float
		    rwave(float tt; float s; float f; float a)
		    {
			float t = tt, i, j, aa, bb;
			i = floor(t);
			j = i + 1;
			t -= i;
			if( f != 0 )
			{
			    aa = (float cellnoise(i) - .5) * f;
			    bb = (float cellnoise(j) - .5) * f + 1;
			    t = (t - aa) / (bb - aa);
			}
			if( mod(i, 2) >= 1 )
			{
			    i += 1;
			    j -= 1;
			    t = 1 - t;
			}
			if( s < 0 )
			{
			    t = (t + s * t) / (1.0 + s * t);
			}
			else
			if(s > 0)
			{
			    t = t / (1.0 - s + s * t);
			}
			t = filterstep(.5, t);
			if( a != 0 )
			{
			    aa = (float cellnoise(i+2)) * a * .5;
			    bb = (float cellnoise(j+2)) * a * .5;
			    t = aa + t * (1.0 - aa - bb);
			}
			return t;
		    }
		    float
		    twave(float tt; float s; float f; float a)
		    {
			float t = tt, i, j, aa, bb;
			i = floor(t);
			j = i + 1;
			t -= i;
			if( f != 0 )
			{
			    aa = (float cellnoise(i) - .5) * f;
			    bb = (float cellnoise(j) - .5) * f + 1;
			    if(t < aa)
			    {
				i -= 1;
				j -= 1;
				t += 1;
				aa += 1;
				bb = aa;
				aa = (float cellnoise(i) - .5) * f;
			    }
			    else
			    if(t > bb)
			    {
				i += 1;
				j += 1;
				t -= 1;
				bb -= 1;
				aa = bb;
				bb = (float cellnoise(j) - .5) * f;
			    }
			    t = (t - aa) / (bb - aa);
			}
			if( mod(i, 2) >= 1 )
			{
			    i += 1;
			    j -= 1;
			    t = 1 - t;
			}
			if( s < 0 )
			{
			    t = (t + s * t) / (1.0 + s * t);
			}
			else
			if(s > 0)
			{
			    t = t / (1.0 - s + s * t);
			}
			if( a != 0 )
			{
			    aa = (float cellnoise(i+2)) * a * .5;
			    bb = (float cellnoise(j+2)) * a * .5;
			    t = aa + t * (1.0 - aa - bb);
			}
			return t;
		    }
		    float swave(float tt; float s; float f; float a)
		    {
			float t = tt, i, j, aa, bb;
			i = floor(t);
			j = i + 1;
			t -= i;
			if( f != 0 )
			{
			    aa = (float cellnoise(i) - .5) * f;
			    bb = (float cellnoise(j) - .5) * f + 1;
			    if(t < aa)
			    {
				i -= 1;
				j -= 1;
				t += 1;
				aa += 1;
				bb = aa;
				aa = (float cellnoise(i) - .5) * f;
			    }
			    else
			    if(t > bb)
			    {
				i += 1;
				j += 1;
				t -= 1;
				bb -= 1;
				aa = bb;
				bb = (float cellnoise(j) - .5) * f;
			    }
			    t = (t - aa) / (bb - aa);
			}
			if( mod(i, 2) >= 1 )
			{
			    i += 1;
			    j -= 1;
			    t = 1 - t;
			}
			if( s < 0 )
			{
			    t = (t + s * t) / (1.0 + s * t);
			}
			else
			if(s > 0)
			{
			    t = t / (1.0 - s + s * t);
			}
			t *= t * (3.0 - t - t);
			if( a != 0 )
			{
			    aa = (float cellnoise(i+2)) * a * .5;
			    bb = (float cellnoise(j+2)) * a * .5;
			    t = aa + t * (1.0 - aa - bb);
			}
			return t;
		    }
		    float
		    floatGain( float gg; float t; )
		    {
			float tg, gain;
			gain = clamp(gg, .0001, .999);
			if( t < .5 )
			{
			    tg = t / ((1/gain - 2) * (1 - 2*t) + 1);
			}
			else
			{
			    tg = ((1/gain - 2) * (1 - 2*t) - t) /
				    ((1/gain - 2) * (1 - 2*t) - 1);
			}
			return tg;
		    }
		    float t;
		    extern float time;
		    uniform float pi2 = PI * 2;
		    point PP = 2 * frequency * pt;
		    if(domain == 0)
			t = xcomp(PP);
		    else
		    if(domain == 1)
			t = ycomp(PP);
		    else
		    if(domain == 2)
			t = zcomp(PP);
		    else
		    if(domain == 3) /* radius */
			t = length( vector(PP) );
		    else
		    if(domain == 4) /* angle xy plane */
		    {
			t = 2 * frequency * 
			    (atan(ycomp(pt), xcomp(pt)) + PI) / pi2;
		    }
		    else
		    if(domain == 5) /* angle yz plane */
		    {
			t = 2 * frequency * 
			    (atan(zcomp(pt), ycomp(pt)) + PI) / pi2;
		    }
		    else
		    if(domain == 6) /* angle xz plane */
		    {
		    	t = 2 * frequency * 
			    (atan(zcomp(pt), xcomp(pt)) + PI) / pi2;
		    }
		    t = t - time * velocity;
		    if(shape == 0)
		    {
			result = rwave(t,shapeFactor,freqVariance,ampVariance);
		    }
		    else
		    if(shape == 1)
		    {
			result = twave(t,shapeFactor,freqVariance,ampVariance);
		    }
		    else
		    if(shape == 2)
		    {
			result = swave(t,shapeFactor,freqVariance,ampVariance);
		    }
		    else
		    if(shape == 3)
		    {
			result = noise(t);
			if( shapeFactor != 0 )
			{
			    result = floatGain(.5 * (1 + shapeFactor),result);
			}
		    }
		    else
		    if(shape == 4)
		    {
			result = cellnoise(t);
		    }
		    result = min + result * (max - min);
		}
	    

	   void
	   pxslMetal(color SurfaceColor;
		   color SurfaceOpacity;
		   float Ka;
		   float Kd;
		   float Ks;
		   float Roughness;
		   output color CI;
		   output color OI;
		   )
	   {
	       normal Nf;
	       extern normal N;
	       extern vector I;
	       Nf = faceforward( normalize(N), I );
	       OI = SurfaceOpacity;
	       CI = SurfaceOpacity * 
		       SurfaceColor *
			   (Ka*ambient() + Kd*diffuse(Nf) +
			    Ks * specular(Nf,-normalize(I),Roughness));
	   }
	

	   void
	   pxslCombineColors( float method; color f1; color f2; 
		    	       output color result;)
	   {
	       if (method == 0)
	       {
		   /* Intersection */
		   result = f1 * f2;
	       }
	       else
	       if (method == 1)
	       {
		   /* Union */
		   result = f1 + f2 - f1 * f2;
	       }
	       else
	       if (method == 2)
	       {
		   /* Difference */
		   result = f1 - f1 * f2;
	       }
	   }
       

		void
		pxslProjection( uniform float projection;
		    	    	uniform float imgcorrection;
				uniform float angle;
				uniform float repeatS; uniform float repeatT;
				uniform float offsetS; uniform float offsetT;
				point inQ;
				vector dinQu;
				vector dinQv;
				output point Q;
				output vector dQu;
				output vector dQv;
			      )
		{
		    float x, y;
		    uniform float pi2 = radians(360), pi = radians(180);
		    
		    if (projection == 0) /* planarx */
		    {
		    	if(imgcorrection == 0)
			{
			    x = zcomp(inQ);
			    y = ycomp(inQ);
			}
			else
			{
			    x = .5 - zcomp(inQ);
			    y = .5 - ycomp(inQ);/* 1-y-.5 */
    	    	    	}
			dQu = dinQu * vector(0,1,1);
			dQv = dinQv * vector(0,1,1);
		    }
		    else
		    if (projection == 1)  /* planary */
		    {
		    	if(imgcorrection == 0)
			{
			    x = xcomp(inQ);
			    y = zcomp(inQ);
			}
			else
			{
			    x = .5 - xcomp(inQ);
			    y = .5 - zcomp(inQ);
			}
			dQu = dinQu * vector(1,0,1);
			dQv = dinQv * vector(1,0,1);
		    }
		    else
		    if (projection == 2) /* planarz */
		    {
		    	if(imgcorrection == 0)
			{
			    x = xcomp(inQ);
			    y = ycomp(inQ);
			}
			else
			{
			    x = .5 - xcomp(inQ);
			    y = .5 - ycomp(inQ);
    	    	    	}
			dQu = dinQu * vector(1,1,0);
			dQv = dinQv * vector(1,1,0);
		    }
		    else
		    if (projection == 3) /* planarz-persp */
		    {
		    	float zinv = 1 / max(1e-6, zcomp(inQ));
			if(imgcorrection == 0)
			{
			    x = xcomp(inQ) * zinv;
			    y = ycomp(inQ) * zinv;
			}
			else
			{
			    x = (.5 - xcomp(inQ)) * zinv;
			    y = (.5 - ycomp(inQ)) * zinv;
    	    	    	}
			dQu = zinv * dinQu * vector(1,1,0);
			dQv = zinv * dinQv * vector(1,1,0);
		    }
		    else
		    if (projection == 4) /* autoplanar */
		    { 
			vector N = -normalize( calculatenormal(inQ) );
			x = N.vector (0,0,1);	/* x = cos of rotation */
			if (x < -.9998) /* if near 180 degrees */
			{	
			    /* just use z planar */
			    if(imgcorrection == 0)
			    {
			    	x = xcomp(inQ);
			    	y = ycomp(inQ);
			    }
			    else
			    {
			    	x = .5 - xcomp(inQ);
			    	y = .5 - ycomp(inQ);
    	    	    	    }
			    dQu = dinQu * vector(1,1,0);
			    dQv = dinQv * vector(1,1,0);
			}
			else 
			{
			    /* otherwise, rotate */
			    point QQ;
			    N = N^vector (0,0,1);
			    y = length (N); /* y = sin of rotation */
			    N = normalize (N);	/* N = rotation vector */
			    QQ = inQ*x + (vector(inQ).N)*N*(1-x) +
			    	 (N^vector(inQ))*y; /* rotate */
			    dQu = dinQu * x + (dinQu.N)*N*(1-x) +
			    	 (N^vector(dinQu))*y; /* rotate */
			    dQv = dinQv * x + (dinQv.N)*N*(1-x) +
			    	 (N^vector(dinQv))*y; /* rotate */
			    if(imgcorrection == 0)
			    {
			    	x = xcomp(QQ);
			    	y = ycomp(QQ);
			    }
			    else
			    {
    	    	    	    	x = .5 - xcomp(QQ);
				y = .5 - ycomp(QQ);
			    }
			}
		    }
		    else
		    if (projection == 5) /* box */
		    { 
			x = zcomp(inQ);
			y = ycomp(inQ); 
			if (abs (y) > abs (x))
			    x = y;
			y = xcomp(inQ);
			if (abs (y) > abs (x))
			    x = y;
			if (x == zcomp(inQ)) /* planar z */
			{
			    x = (-x < 0 ? -1 : 1) * xcomp(inQ);
			    y = -ycomp(inQ);
			}
			else
			if (x == xcomp(inQ)) /* planar x */
			{
			    x = (x < 0 ? -1 : 1) * zcomp(inQ);
			    y = -ycomp(inQ);
			}
			else
			if (x == ycomp(inQ)) /* planar y */
			{
			    x = xcomp(inQ);
			    y = (x < 0 ? -1 : 1) * zcomp(inQ);
			}
			x = x - .5;
			y = y - .5;
		    }
		    else
		    if (projection == 6) /* box spherical */
		    {
			point QQ;
			x = zcomp(inQ);
			y = ycomp(inQ);
			if (abs (y) > abs (x))
			    x = y;
			y = xcomp(inQ); 
			if (abs (y) > abs (x))
			    x = y;
			if (x == zcomp(inQ))
			{
			    QQ = point ( (-x < 0 ? -1 : 1) * xcomp(inQ), 
					ycomp(inQ), 
					(-x < 0 ? -1 : 1) * zcomp(inQ) );
			}
			else
			if (x == xcomp(inQ))
			{
			    QQ = point ( (x < 0 ? -1 : 1) * zcomp(inQ), 
					ycomp(inQ),
					(-x < 0 ? -1 : 1) * xcomp(inQ) );
			}
			else
			if (x == ycomp(inQ))
			{
			    QQ = point ( xcomp(inQ),
					(x < 0 ? -1 : 1) * zcomp(inQ),
					(-x < 0 ? -1 : 1) * ycomp(inQ) );
			}
			x = .5 + atan (xcomp(QQ), -zcomp(QQ)) / pi2;
			y = length (vector (xcomp(QQ), 0, zcomp(QQ)));
			y = .5 - atan (ycomp(QQ), y) / pi;
		    }
		    else
		    if (projection == 7) /* spherical */
		    {
		    	/* atan2: -pi->pi */
			x = .5 + atan(xcomp(inQ), -zcomp(inQ)) / pi2;  
			y = length( vector( xcomp(inQ), 0, zcomp(inQ) ));
			y = .5 - atan(ycomp(inQ), y) / pi;
		    }
		    else
		    if (projection == 8) /* cylindrical */
		    { 
		    	/* atan2: -pi->pi */
			x = .5 + atan(xcomp(inQ), -zcomp(inQ)) / pi2; 
			y = -ycomp(inQ);
			y = y - .5;
		    }
		    else    /* st */
		    {
    	    	    	extern float s, t;
			x = s;
			y = t;
		    }
		    setxcomp(Q, repeatS * x + offsetS);
		    setycomp(Q, repeatT * y + offsetT);
		    setzcomp(Q, 0);
		    if(angle != 0)
		    {
			Q = rotate(Q, radians(angle), point(0,0,0),
			    	    point(0,0,1)); 
		    }
		}
	    

#include "pxslRemap.h"
		void
		pxslColorToGray( color c;
			float conversion;
			float invert;
			float bias;
			float gain;
			output float result; )
		{
		    if(conversion == 0)
		    {
			result = comp(c,0);
		    }
		    else
		    if(conversion == 1)
		    {
			result = comp(c,1);
		    }
		    else
		    if(conversion == 2)
		    {
			result = comp(c,2);
		    }
		    else
		    if(conversion == 3)
		    {
			result = .3 * comp(c, 0) + .59 * comp(c, 1) + 
			    .11 * comp(c, 2);
		    }
		    else
		    if(conversion == 4)
		    {
			result = max( comp(c,0), comp(c,1), comp(c,2) );
		    }
		    else
		    if(conversion == 5)
		    {
			result = (comp(c,0) + comp(c,1) + comp(c,2)) / 3;
		    }
		    else
		    if(conversion == 6)
		    {
			result = min( comp(c,0), comp(c,1), comp(c,2) );
		    }
		    if(invert == 1)
			result = 1 - result;
		    result = pxslFloatBias(bias, result);
		    result = pxslFloatGain(gain, result);
		}
	    
/* end referenced functions ------------------------*/
  uniform color white = color(1,1,1);
  color cs = 0, os = 0;
  point tmp0;
  vector tmp1;
  vector tmp2;
  pxslST ( /* ST1 */
    30.00 /* Angle */,
    ST1_repeatS,
    ST1_repeatT,
    0 /* S Offset */,
    0 /* T Offset */,
    tmp0,
    tmp1,
    tmp2
    );
  point tmp3;
  vector tmp4;
  vector tmp5;
  pxslST ( /* ST2 */
    330.00 /* Angle */,
    ST2_repeatS,
    ST2_repeatT,
    0 /* S Offset */,
    0 /* T Offset */,
    tmp3,
    tmp4,
    tmp5
    );
  point tmp6;
  vector tmp7;
  vector tmp8;
  pxslProjection ( /* Projection0 */
    Projection0_projection,
    1 /* Planar for Textures */,
    0 /* Angle */,
    1.0 /* S Repeats */,
    1.0 /* T Repeats */,
    0 /* S Offset */,
    0 /* T Offset */,
    tmp0,
    tmp1,
    tmp2,
    tmp6,
    tmp7,
    tmp8
    );
  point tmp9;
  vector tmp10;
  vector tmp11;
  pxslProjection ( /* Projection1 */
    2 /* Projection */,
    1 /* Planar for Textures */,
    0 /* Angle */,
    1 /* S Repeats */,
    1 /* T Repeats */,
    0 /* S Offset */,
    0 /* T Offset */,
    tmp3,
    tmp4,
    tmp5,
    tmp9,
    tmp10,
    tmp11
    );
  float tmp12;
  pxslWaves1D ( /* Waves1D00 */
    0 /* Shape */,
    0 /* Shape Factor */,
    0 /* Frequency Variance */,
    1.00 /* Amplitude Variance */,
    0 /* Domain */,
    0.5 /* Min */,
    1 /* Max */,
    9.0 /* Frequency */,
    0 /* Velocity */,
    tmp6,
    tmp7,
    tmp8,
    tmp12
    );
  float tmp13;
  pxslWaves1D ( /* Waves1D0 */
    0 /* Shape */,
    0 /* Shape Factor */,
    0 /* Frequency Variance */,
    1.00 /* Amplitude Variance */,
    0 /* Domain */,
    0.5 /* Min */,
    1 /* Max */,
    9.0 /* Frequency */,
    0 /* Velocity */,
    tmp9,
    tmp10,
    tmp11,
    tmp13
    );
  color tmp14;
  pxslFloatToColor ( /* FloatToColor0 */
    tmp12,
    tmp14
    );
  color tmp15;
  pxslFloatToColor ( /* FloatToColor3 */
    tmp12,
    tmp15
    );
  color tmp16;
  pxslFloatToColor ( /* FloatToColor1 */
    tmp13,
    tmp16
    );
  color tmp17;
  pxslFloatToColor ( /* FloatToColor2 */
    tmp13,
    tmp17
    );
  color tmp18;
  pxslCombineColors ( /* color2 */
    0 /* Combine Method */,
    tmp15,
    color2_f2,
    tmp18
    );
  pxslCombineColors ( /* weaveBW */
    0 /* Combine Method */,
    tmp14,
    tmp16,
    tmp15
    );
  pxslCombineColors ( /* color1 */
    0 /* Combine Method */,
    tmp17,
    color1_f2,
    tmp14
    );
  pxslColorToGray ( /* correct */
    tmp15,
    3 /* Conversion */,
    0 /* Invert */,
    0.51 /* Bias */,
    0.52 /* Gain */,
    tmp12
    );
  pxslCombineColors ( /* CombineColors1 */
    1 /* Combine Method */,
    tmp14,
    tmp18,
    tmp16
    );
  pxslRemap ( /* Remap0 */
    tmp12,
    0 /* inputmin */,
    0.90 /* inputmax */,
    0 /* outputmin */,
    0.50 /* outputmax */,
    0.46 /* Bias */,
    0.06 /* Gain */,
    tmp13
    );
  pxslBlinn ( /* Blinn0 */
    tmp16,
    color(1,1,1) /* Opacity */,
    color(0,0,0) /* Ambient Color */,
    color(0,0,0) /* Incandescence */,
    0.64 /* Diffuse Coefficient */,
    0 /* Translucence Coefficient */,
    color(1,1,1) /* Specular Color */,
    0.67 /* Eccentricity */,
    0.03 /* Specular Rolloff */,
    1 /* Reflectivity */,
    tmp17,
    tmp15
    );
  pxslFloatToColor ( /* FloatToColor5 */
    tmp13,
    tmp14
    );
  pxslMetal ( /* Metal0 */
    Metal0_SurfaceColor,
    tmp14,
    0.00 /* Ka */,
    0.00 /* Kd */,
    0.81 /* Ks */,
    0.35 /* Roughness */,
    tmp18,
    tmp16
    );
  cs = tmp17 + (white - tmp15) * cs;
  os = tmp15 + (white - tmp15) * os;
  cs = tmp18 + (white - tmp16) * cs;
  os = tmp16 + (white - tmp16) * os;
  Ci = cs;
  Oi = os;
}

