/* $Id: //depot/branches/rmanprod/rat-6.0/ratdocs/education/RenderMan_Companion/tutorial/ch16/shaders/bulb.sl#1 $  (Pixar - RenderMan Division)  $Date: 2004/01/13 $ */
/*
** Copyright (c) 1998 PIXAR.  All rights reserved.  This program or
** documentation contains proprietary confidential information and trade
** secrets of PIXAR.  Reverse engineering of object code is prohibited.
** Use of copyright notice is precautionary and does not imply publication.
**
**                      RESTRICTED RIGHTS NOTICE
**
** Use, duplication, or disclosure by the Government is subject to the
** following restrictions:  For civilian agencies, subparagraphs (a) through
** (d) of the Commercial Computer Software--Restricted Rights clause at
** 52.227-19 of the FAR; and, for units of the Department of Defense, DoD
** Supplement to the FAR, clause 52.227-7013 (c)(1)(ii), Rights in
** Technical Data and Computer Software.
**
** Pixar
** 1001 West Cutting Blvd.
** Richmond, CA  94804
*/
surface
bulb(
    float Ks = 1.0,
	  Ka = 0.1,
	  Kd = 0.3,
	  Ksilh = 0.05,
	  roughness = 0.1,
	  silhrough = 0.55;
    color specularcolor = 1)

{
     normal Nf = faceforward(normalize(N), I);
     vector V = -normalize(I);

     Oi = Os;
     Ci = Oi*Cs*(Ka*ambient() + Kd*diffuse(Nf)) +
	  specularcolor*Ks*specular(Nf, V, roughness)
	  + specularcolor*Ksilh*(pow(1.0 - (V.Nf),1/silhrough));
}
