/* $Id: //depot/branches/rmanprod/rat-6.0/ratdocs/education/RenderMan_Companion/tutorial/ch16/shaders/checker.sl#1 $  (Pixar - RenderMan Division)  $Date: 2004/01/13 $ */
/*
** Copyright (c) 1998 PIXAR.  All rights reserved.  This program or
** documentation contains proprietary confidential information and trade
** secrets of PIXAR.  Reverse engineering of object code is prohibited.
** Use of copyright notice is precautionary and does not imply publication.
**
**                      RESTRICTED RIGHTS NOTICE
**
** Use, duplication, or disclosure by the Government is subject to the
** following restrictions:  For civilian agencies, subparagraphs (a) through
** (d) of the Commercial Computer Software--Restricted Rights clause at
** 52.227-19 of the FAR; and, for units of the Department of Defense, DoD
** Supplement to the FAR, clause 52.227-7013 (c)(1)(ii), Rights in
** Technical Data and Computer Software.
**
** Pixar
** 1001 West Cutting Blvd.
** Richmond, CA  94804
*/
/* Listing 16.12  Surface shader providing checkerboard pattern*/
/* 
 * checker(): surface shader for applying a checkerboard pattern.
 */
surface 
checker(
	float	Kd	  	= .5, 
		Ka	  	= .1, 
		frequency 	= 10;
	color	blackcolor	= color (0,0,0) )
{
	float	smod = mod(s*frequency,1),
		tmod = mod(t*frequency,1);

	if(smod < 0.5) {
	    if(tmod < 0.5) 
		Ci = Cs;
	    else
		Ci = blackcolor;
	} else {
	    if(tmod < 0.5) 
		Ci = blackcolor;
	    else
		Ci = Cs;
	}

	Oi = Os;
	Ci = Oi*Ci*(
		Ka*ambient() + 
		Kd*diffuse(faceforward(normalize(N),I)) );
}
