/* $Id: //depot/branches/rmanprod/rat-6.0/ratdocs/education/RenderMan_Companion/tutorial/ch16/shaders/droop.sl#1 $  (Pixar - RenderMan Division)  $Date: 2004/01/13 $ */
/*
** Copyright (c) 1998 PIXAR.  All rights reserved.  This program or
** documentation contains proprietary confidential information and trade
** secrets of PIXAR.  Reverse engineering of object code is prohibited.
** Use of copyright notice is precautionary and does not imply publication.
**
**                      RESTRICTED RIGHTS NOTICE
**
** Use, duplication, or disclosure by the Government is subject to the
** following restrictions:  For civilian agencies, subparagraphs (a) through
** (d) of the Commercial Computer Software--Restricted Rights clause at
** 52.227-19 of the FAR; and, for units of the Department of Defense, DoD
** Supplement to the FAR, clause 52.227-7013 (c)(1)(ii), Rights in
** Technical Data and Computer Software.
**
** Pixar
** 1001 West Cutting Blvd.
** Richmond, CA  94804
*/
/* Listing 16.27  Displacement shader with catenary droop in y*/
/*
 * droop(): a displacement shader for making a surface "sag" along t.
*/
#define M_E 2.7182818284590452354	/* e */

displacement 
droop ( 
	float	Km = 0.05 )
{
	float droop, yDel;
 
	droop = (t-.5)*2;	/* t in [0,1] goes to droop in [-1,1] */

	yDel = -Km * ( M_E + (1/M_E) - (exp(droop)+exp(-droop)) );
	setycomp(P, ycomp(P) + yDel);
	N = calculatenormal(P);
}
