/*
** Copyright (c) 1999 PIXAR.  All rights reserved.  This program or
** documentation contains proprietary confidential information and trade
** secrets of PIXAR.  Reverse engineering of object code is prohibited.
** Use of copyright notice is precautionary and does not imply
** publication.
**
**                      RESTRICTED RIGHTS NOTICE
**
** Use, duplication, or disclosure by the Government is subject to the
** following restrictions:  For civilian agencies, subparagraphs (a) through
** (d) of the Commercial Computer Software--Restricted Rights clause at
** 52.227-19 of the FAR; and, for units of the Department of Defense, DoD
** Supplement to the FAR, clause 52.227-7013 (c)(1)(ii), Rights in
** Technical Data and Computer Software.
**
** Pixar
** 1001 West Cutting Blvd.
** Richmond, CA  94804
**
** ----------------------------------------------------------------------------
*/
/* code generated by slim 1.0b3, RAT 4.0b3 (Jan 12 2000 01:59:37) */
/* for dsisson@glaw.rainsound.com at: Wed Jan 12 09:16:31 PST 2000 */
surface dusty_mirror (
  )
{
/* begin referenced functions ----------------------*/

	   void
	   pxslMetal(color SurfaceColor;
		   color SurfaceOpacity;
		   float Ka;
		   float Kd;
		   float Ks;
		   float Roughness;
		   output color CI;
		   output color OI;
		   )
	   {
	       normal Nf;
	       extern normal N;
	       extern vector I;
	       Nf = faceforward( normalize(N), I );
	       OI = SurfaceOpacity;
	       CI = SurfaceOpacity * 
		       SurfaceColor *
			   (Ka*ambient() + Kd*diffuse(Nf) +
			    Ks * specular(Nf,-normalize(I),Roughness));
	   }
	

#include "pxslUtil.h"
#include "noises.h"
	void
	pxslTurbulence (
	    uniform float baseFreq;
	    uniform float octaves, lacunarity, gain;
	    uniform float invert;
	    float fourthdimension;
	    point p;
	    vector dpu, dpv;
	    output float result;)
	{
	    uniform float amp = 1;
	    uniform float sum = 0;
	    varying point pp = baseFreq*p;
	    varying float fw = pxslFilterWidth(baseFreq*dpu, baseFreq*dpv);
	    uniform float i;
	    extern float du, dv; /* for filterwidth macro */
    	    result = 0;
	    for (i = 0;  i < octaves;  i += 1) {
	#pragma nolint
		float n = filteredsnoiset (pp, fw, fourthdimension);
		float dn = filterwidth(n);
		result += amp * filteredabs (n, dn);
		sum += amp;  amp *= gain;  pp *= lacunarity;  fw *= lacunarity;
	    }
	    result /= .5*sum;

	    if (invert != 0)
		result = 1-result;
	}
    

#include "pxslRemap.h"
		void 
		pxslRemapF(float f; 
			float inputmin, inputmax;
			float outputmin, outputmax;
			float disablegain;
			float bias, gain;
			output float result; )
		{
		    result = clamp(f, inputmin, inputmax);
		    result = outputmin + (outputmax - outputmin) * 
		    	(result - inputmin) / (inputmax - inputmin);
		    if (disablegain == 0)
		    {
		    	result = pxslFloatBias(bias, result);
		    	result = pxslFloatGain(gain, result);
		    }
		}
	    

	   void pxslFloatToColor(float fa; color ca; output color c;)
	   {
	       c = ca * color(fa,fa,fa);
	   }
       

	   void
	   pxslBlinn(color SurfaceColor;
		   color SurfaceOpacity;
		   color ambientColor;
		   color Incandescence;
		   float diffuseCoeff;
		   float translucenceCoeff;
		   color specularColor;
		   float eccentricity;
		   float specularRollOff;
		   float reflectivity;
		   output color CI;
		   output color OI; )
	   {
	       color
	       getTranslucence( normal Nf; float c; )
	       {
		   color C = 0;
		   extern point P;
		   extern color Cl;
		   float nondiff;

		   if( c != 0 )
		   {
		       illuminance(P, Nf, PI)
		       {
			   if( 0 == lightsource("__nondiffuse", nondiff) )
			       nondiff = 0;
			   C += (1 - nondiff) * Cl;
		       }
		       C *= c;
 		   }
		   return C;
	       }
	       color
	       getBlinn( normal Nf;
		       float eccentricity, specularRollOff;
		       output color Cr; )
	       {
		   float E;
		   color C = 0;
		   vector H, Ln, V, Nn;
		   float NH, NH2, NHSQ, Dd, Gg, VN, VH, LN, Ff, tmp;
		   float nondiff, nonspec;
		   extern point P;
		   extern vector L, I;
		   extern color Cl;

		   if(eccentricity != 1)
 			E = 1 / (eccentricity * eccentricity - 1);
		   else
			E = -1e5;
		   Cr = 0;
		   V = normalize(-I);
		   VN = V.Nf;
		   illuminance(P, Nf, 1.57079632679)
		   {
		       if( 0 == lightsource("__nonspecular", nonspec) )
			   nonspec = 0;
		       if( nonspec < 1 )
		       {
			   Ln = normalize(L);
			   H = normalize(Ln+V);
			   NH = Nf.H;
			   NHSQ = NH*NH;
			   NH2 = NH * 2;
			   Dd = (E+1) / (NHSQ + E);
			   Dd *= Dd;
			   VH = V.H;
			   LN = Ln.Nf;
			   if( VN < LN )
			   {
			       if( VN * NH2 < VH )
				   Gg = NH2 / VH;
			       else
				   Gg = 1 / VN;
			   }
			   else
			   {
			       if( LN * NH2 < VH )
				   Gg = (LN * NH2) / (VH * VN);
			       else
				   Gg = 1 / VN;
			   }
			   /* poor man's Fresnel */
			   tmp = pow((1 - VH), 3);
			   Ff = tmp + (1 - tmp) * specularRollOff;
			   C += Cl * Dd * Gg * Ff;

			   /* now look for environment reflections.  These
			       are indicated by lights which are specular AND
			       nondiffuse */
			   if( 0 != lightsource("__nondiffuse", nondiff) )
			   {
			       Cr += (1 - nonspec) * nondiff * Ff * Cl;
			   }
		       }
		   }
		   return C;
	       }
	       normal Nf;
	       vector R;
	       color Ia, Id, Itr, Is, Ir, Isr;
	       extern normal N;
	       extern vector I;
	       Nf = faceforward( normalize(N), I );
	       R = reflect(normalize(I), Nf);
	       Ia = ambientColor * ambient();
	       Id = diffuseCoeff*diffuse(Nf);
	       Itr = getTranslucence(Nf, translucenceCoeff);
	       Is = getBlinn(Nf, eccentricity, specularRollOff, Ir);
	       Ir = reflectivity * Ir;
	       Isr = specularColor * (Is + Ir);
	       OI = SurfaceOpacity;
	       CI = OI * SurfaceColor * (Ia + Id + Itr + Incandescence + Isr);
	   }
       

		void pxslST (
			  uniform float angle;
			  uniform float repeatS; uniform float repeatT;
			  uniform float offsetS; uniform float offsetT;
			  output point Q;
			  output vector dQu;
			  output vector dQv;
			  )
		{
		    extern float s, t, du, dv;

		    setxcomp(Q, repeatS * s + offsetS);
		    setycomp(Q, repeatT * t + offsetT);
		    setzcomp(Q, 0);

		    if(angle != 0)
			Q = rotate(Q, radians(angle), 
			    	    point(0,0,0), point(0,0,1)); 

		    dQu = vector Du(Q)*du;
		    dQv = vector Dv(Q)*dv;
		}
	    
/* end referenced functions ------------------------*/
  uniform color white = color(1,1,1);
  color cs = 0, os = 0;
  color tmp0;
  color tmp1;
  pxslMetal ( /* mirrorBase */
    color(0.499977111467,0.499977111467,0.499977111467) /* Surface Color */,
    color(1,1,1) /* Opacity */,
    0.01 /* Ka */,
    0.02 /* Kd */,
    1.15 /* Ks */,
    0.02 /* Roughness */,
    tmp0,
    tmp1
    );
  point tmp2;
  vector tmp3;
  vector tmp4;
  pxslST ( /* ST_21 */
    0 /* Angle */,
    1 /* S Repeats */,
    2.5 /* T Repeats */,
    0 /* S Offset */,
    0 /* T Offset */,
    tmp2,
    tmp3,
    tmp4
    );
  float tmp5;
  pxslTurbulence ( /* Turbulence_7 */
    1 /* Base Frequency */,
    7 /* octaves */,
    3.60 /* lacunarity */,
    0.65 /* gain */,
    0 /* invert */,
    0 /* Fourth Dimension */,
    tmp2,
    tmp3,
    tmp4,
    tmp5
    );
  float tmp6;
  pxslRemapF ( /* Remap_14 */
    tmp5,
    0 /* inputmin */,
    1 /* inputmax */,
    -0.19 /* outputmin */,
    0.80 /* outputmax */,
    0 /* Disable Bias/Gain */,
    0.62 /* Bias */,
    0.37 /* Gain */,
    tmp6
    );
  color tmp7;
  pxslFloatToColor ( /* FloatToColor_10 */
    tmp6,
    color(1,1,1) /* Coloration */,
    tmp7
    );
  color tmp8;
  color tmp9;
  pxslBlinn ( /* dust */
    color(0.541161211566,0.471641107805,0.292866407263) /* Surface Color */,
    tmp7,
    color(0,0,0) /* Ambient Color */,
    color(0,0,0) /* Incandescence */,
    .8 /* Diffuse Coefficient */,
    0 /* Translucence Coefficient */,
    color(1,1,1) /* Specular Color */,
    .5 /* Eccentricity */,
    .1 /* Specular Rolloff */,
    1 /* Reflectivity */,
    tmp8,
    tmp9
    );
  cs = tmp0 + (white - tmp1) * cs;
  os = tmp1 + (white - tmp1) * os;
  cs = tmp8 + (white - tmp9) * cs;
  os = tmp9 + (white - tmp9) * os;
  Ci = cs;
  Oi = os;
}

