/* $Id: //depot/branches/rmanprod/rat-6.0/ratdocs/education/RenderMan_Companion/tutorial/ch16/shaders/easysurface.sl#1 $  (Pixar - RenderMan Division)  $Date: 2004/01/13 $ */
/*
** Copyright (c) 1998 PIXAR.  All rights reserved.  This program or
** documentation contains proprietary confidential information and trade
** secrets of PIXAR.  Reverse engineering of object code is prohibited.
** Use of copyright notice is precautionary and does not imply publication.
**
**                      RESTRICTED RIGHTS NOTICE
**
** Use, duplication, or disclosure by the Government is subject to the
** following restrictions:  For civilian agencies, subparagraphs (a) through
** (d) of the Commercial Computer Software--Restricted Rights clause at
** 52.227-19 of the FAR; and, for units of the Department of Defense, DoD
** Supplement to the FAR, clause 52.227-7013 (c)(1)(ii), Rights in
** Technical Data and Computer Software.
**
** Pixar
** 1001 West Cutting Blvd.
** Richmond, CA  94804
*/
/* Listing 16.22  Surface shader for use without a light source*/
/*
 * easysurface(): orientation-sensitive surface shading without a light source
 */
surface
easysurface(
	float	Kd	= .8, 
		Ka	= .2, 
		falloff	= 2.0 )
{
	float diffuse ;
	vector II = normalize(I);
	normal NN = faceforward(normalize(N), I);

	diffuse = -II.NN;    /* faceforwarded N is opposite I, by definition*/
	diffuse = pow(diffuse, falloff);

	Ci = Cs * (Ka + Kd * diffuse ) ;
}
