/* $Id: //depot/branches/rmanprod/rat-6.0/ratdocs/education/RenderMan_Companion/tutorial/ch16/shaders/eroded.sl#1 $  (Pixar - RenderMan Division)  $Date: 2004/01/13 $ */
/*
** Copyright (c) 1998 PIXAR.  All rights reserved.  This program or
** documentation contains proprietary confidential information and trade
** secrets of PIXAR.  Reverse engineering of object code is prohibited.
** Use of copyright notice is precautionary and does not imply publication.
**
**                      RESTRICTED RIGHTS NOTICE
**
** Use, duplication, or disclosure by the Government is subject to the
** following restrictions:  For civilian agencies, subparagraphs (a) through
** (d) of the Commercial Computer Software--Restricted Rights clause at
** 52.227-19 of the FAR; and, for units of the Department of Defense, DoD
** Supplement to the FAR, clause 52.227-7013 (c)(1)(ii), Rights in
** Technical Data and Computer Software.
**
** Pixar
** 1001 West Cutting Blvd.
** Richmond, CA  94804
*/
/* Listing 16.17  Surface shader eroding the surface of an object*/
/*
 *  eroded(): Simulate a metallic surface eaten away with acid
 */
surface 
eroded(	
	float	Ks 		= .4, 
		Ka 		= .1, 
	      	Km 		= 0.3,
		roughness	= .25 )
{
	float	size		= 4.0, 
		magnitude	= 0.0, 
		i;
	normal Nf; 
	point W = transform("object", P);
	point x=(1,0,0);
	vector V = normalize(-I);

	for (i = 0; i < 6.0; i += 1.0) {
		/* Calculate a simple fractal 1/f noise function */
		magnitude += 4.0 * abs(.5 - noise( W*size )) / size;
		size *= 2.0;
	}

	/* sharpen peaks */
	magnitude = magnitude * magnitude * magnitude * Km; 

	N = calculatenormal( P-magnitude*normalize(N) );

	Nf = faceforward(normalize(N), I);
	Oi = smoothstep(0.0001, 0.003, magnitude);
	Ci = Oi * Cs * (Ka*ambient() + Ks*specular(Nf,V,roughness) ) ;
}
