/* $Id: //depot/branches/rmanprod/rat-6.0/ratdocs/education/RenderMan_Companion/tutorial/ch16/shaders/filament.sl#1 $  (Pixar - RenderMan Division)  $Date: 2004/01/13 $ */
/*
** Copyright (c) 1998 PIXAR.  All rights reserved.  This program or
** documentation contains proprietary confidential information and trade
** secrets of PIXAR.  Reverse engineering of object code is prohibited.
** Use of copyright notice is precautionary and does not imply publication.
**
**                      RESTRICTED RIGHTS NOTICE
**
** Use, duplication, or disclosure by the Government is subject to the
** following restrictions:  For civilian agencies, subparagraphs (a) through
** (d) of the Commercial Computer Software--Restricted Rights clause at
** 52.227-19 of the FAR; and, for units of the Department of Defense, DoD
** Supplement to the FAR, clause 52.227-7013 (c)(1)(ii), Rights in
** Technical Data and Computer Software.
**
** Pixar
** 1001 West Cutting Blvd.
** Richmond, CA  94804
*/
/* Listing 16.25  Surface shader to make a cylinder look like a filament*/
/*
 * filament(): map a filament-like spiral onto the surface of a cylinder.
 */
surface 
filament ( 
	float	frequency	= 5.0,
		phase 		= 0.0, 
		width		= 0.3 )
{
	/* Calculate the distance of (s,t) from a spiral as a fraction [0,1] */
	float offset = mod((t*frequency + s + phase), 1.0);

	/* Threshold the fraction against the fractional filament width */
	if (offset < width) {
		Ci = Cs;
		Oi = 1.0;
	} else {
		Ci = 0.0;
		Oi = 0.0;
	}
}

