/*
** Copyright (c) 1999 PIXAR.  All rights reserved.  This program or
** documentation contains proprietary confidential information and trade
** secrets of PIXAR.  Reverse engineering of object code is prohibited.
** Use of copyright notice is precautionary and does not imply
** publication.
**
**                      RESTRICTED RIGHTS NOTICE
**
** Use, duplication, or disclosure by the Government is subject to the
** following restrictions:  For civilian agencies, subparagraphs (a) through
** (d) of the Commercial Computer Software--Restricted Rights clause at
** 52.227-19 of the FAR; and, for units of the Department of Defense, DoD
** Supplement to the FAR, clause 52.227-7013 (c)(1)(ii), Rights in
** Technical Data and Computer Software.
**
** Pixar
** 1001 West Cutting Blvd.
** Richmond, CA  94804
**
** ----------------------------------------------------------------------------
*/
/* code generated by slim 1.0d01, RAT 4.0d01 (Sep 10 1999 12:08:24) */
/* for dsisson@glaw.rainsound.com at: Fri Sep 10 14:19:30 PDT 1999 */
surface floorTiler1 (
  float ST1_repeatS=10.0;
  float ST1_repeatT=10.0;
  color tile_SurfaceColor=color(0.499977111467,0.402929732204,0.249988555734);
  )
{
/* begin referenced functions ----------------------*/

	   void
	   pxslBlinn(color SurfaceColor;
		   color SurfaceOpacity;
		   color ambientColor;
		   color Incandescence;
		   float diffuseCoeff;
		   float translucenceCoeff;
		   color specularColor;
		   float eccentricity;
		   float specularRollOff;
		   float reflectivity;
		   output color CI;
		   output color OI; )
	   {
	       color
	       getTranslucence( normal Nf; float c; )
	       {
		   color C = 0;
		   extern point P;
		   extern color Cl;
		   float nondiff;

		   if( c != 0 )
		   {
		       illuminance(P, Nf, PI)
		       {
			   if( 0 == lightsource("__nondiffuse", nondiff) )
			       nondiff = 0;
			   C += (1 - nondiff) * Cl;
		       }
		       C *= c;
 		   }
		   return C;
	       }
	       color
	       getBlinn( normal Nf;
		       float eccentricity, specularRollOff;
		       output color Cr; )
	       {
		   float E = 1 / (eccentricity * eccentricity - 1);
		   color C = 0;
		   vector H, Ln, V, Nn;
		   float NH, NH2, NHSQ, Dd, Gg, VN, VH, LN, Ff, tmp;
		   float nondiff, nonspec;
		   extern point P;
		   extern vector L, I;
		   extern color Cl;

		   Cr = 0;
		   V = normalize(-I);
		   VN = V.Nf;
		   illuminance(P, Nf, 1.57079632679)
		   {
		       if( 0 == lightsource("__nonspecular", nonspec) )
			   nonspec = 0;
		       if( nonspec < 1 )
		       {
			   Ln = normalize(L);
			   H = normalize(Ln+V);
			   NH = Nf.H;
			   NHSQ = NH*NH;
			   NH2 = NH * 2;
			   Dd = (E+1) / (NHSQ + E);
			   Dd *= Dd;
			   VH = V.H;
			   LN = Ln.Nf;
			   if( VN < LN )
			   {
			       if( VN * NH2 < VH )
				   Gg = NH2 / VH;
			       else
				   Gg = 1 / VN;
			   }
			   else
			   {
			       if( LN * NH2 < VH )
				   Gg = (LN * NH2) / (VH * VN);
			       else
				   Gg = 1 / VN;
			   }
			   /* poor man's Fresnel */
			   tmp = pow((1 - VH), 3);
			   Ff = tmp + (1 - tmp) * specularRollOff;
			   C += Cl * Dd * Gg * Ff;

			   /* now look for environment reflections.  These
			       are indicated by lights which are specular AND
			       nondiffuse */
			   if( 0 != lightsource("__nondiffuse", nondiff) )
			   {
			       Cr += (1 - nonspec) * nondiff * Ff * Cl;
			   }
		       }
		   }
		   return C;
	       }
	       normal Nf;
	       vector R;
	       color Ia, Id, Itr, Is, Ir, Isr;
	       extern normal N;
	       extern vector I;
	       Nf = faceforward( normalize(N), I );
	       R = reflect(normalize(I), Nf);
	       Ia = ambientColor * ambient();
	       Id = diffuseCoeff*diffuse(Nf);
	       Itr = getTranslucence(Nf, translucenceCoeff);
	       Is = getBlinn(Nf, eccentricity, specularRollOff, Ir);
	       Ir = reflectivity * Ir;
	       Isr = specularColor * (Is + Ir);
	       OI = SurfaceOpacity;
	       CI = OI * SurfaceColor * (Ia + Id + Itr + Incandescence + Isr);
	   }
       

#include "pxslUtil.h"
	   void
	   pxslColorRamp( float RampType;
		 float tile;
		 float numKnots;
		 float k0; color c0; 
		 float k1; color c1; 
		 float k2; color c2;
		 float k3; color c3;
		 float k4; color c4;
		 float k5; color c5;
		 float k6; color c6;
		 float k7; color c7;
		 float k8; color c8;
		 float k9; color c9;
		 float k10; color c10;
		 float k11; color c11;
		 float k12; color c12;
		 float k13; color c13;
		 float k14; color c14;
		 float k15; color c15;
		 point Q;
		 vector dQu;
		 vector dQv;
		 output color result;
		)
	   {
	       float k, s, t;
	       if( RampType <= 1 ) /* uramp, vramp */
	       {
		   if( RampType == 0 )
		   {
		       s = xcomp(Q);
		       t = ycomp(Q);
		   }
		   else
		   {
		       s = ycomp(Q);
		       t = xcomp(Q);
		   }
		   if( tile == 1 )
		       s = s - floor(s);
		   k = float spline( "solvecatrom", s, 
			   k0, k1, k2, k3, k4, k5,
			   k6, k7, k8, k9, k10, k11,
			   k12, k13, k14, k15 );
		   result = color spline( "catrom", k, 
			   c0, c1, c2, c3, c4, c5, 
			   c6, c7, c8, c9, c10, c11,
			   c12, c13, c14, c15 );
	       }
	       else
	       {
		   uniform float pi2 = 2 * PI;
		   float ss, tt;
		   s = xcomp(Q);
		   t = ycomp(Q);
		   if( tile == 1 )
		   {
		       s = s - floor(s);
		       t = t - floor(t);
		   }
		   if(RampType == 2) /* diagonal */
		   {
		       ss = (s + t) / 2.0;
		   }
		   else
		   if(RampType == 3) /* radial */
		   {
		       ss = (atan(t-.5, s-.5) + PI) / pi2;
		   }
		   else
		   if(RampType == 4) /* circular */
		   {
		       ss = s - .5;
		       tt = t - .5;
		       ss = 1 - sqrt(2 * (ss * ss + tt * tt));
		   }
		   else 
		   if(RampType == 5) /* box */
		   {
		       ss = s - .5;
		       tt = t - .5;
		       if( abs(ss) < abs(tt) )
			   ss = tt;
		       ss = 1 - sqrt(2*(2*ss*ss));
		   }
		   if(RampType != 6)
		   {
		       k = float spline( "solvecatrom", ss, 
			   k0, k1, k2, k3, k4, k5,
			   k6, k7, k8, k9, k10, k11,
			   k12, k13, k14, k15 );
		       result = color spline( "catrom", k, 
			   c0, c1, c2, c3, c4, c5, 
			   c6, c7, c8, c9, c10, c11,
			   c12, c13, c14, c15 );
		   }
		   else  /* 4 corner */
		   {
		       /* collect samples at four "adjacent" points */
		       color C0, C1, C2, C3;
		       float f;
		       ss = s - .5;
		       tt = t - .5;
		       C0 = pxslBimix( c1, c2, c3, c4, ss + .5, tt + .5 );
		       C1 = pxslBimix( c1, c2, c3, c4, ss - .5, tt + .5 );
		       C2 = pxslBimix( c1, c2, c3, c4, ss + .5, tt - .5 );
		       C3 = pxslBimix( c1, c2, c3, c4, ss - .5, tt - .5 );

		       /* mix the corner pieces */
		       f = filterstep( .5, ss );
		       C0 = mix(C0, C1, f);
		       C1 = mix(C2, C3, f);
		       result = mix(C0, C1, filterstep(.5, tt));

		       /* final anti-aliasing */
		       f = smoothstep(.125, .5, area(point(ss,tt,0)));
		       result = mix(result, pxslBimix(c1,c2,c3,c4,.5,.5), f);
		   }
	       }
	       if( tile == 0 )
	       {
		   result = mix(result, color(0,0,0), filterstep(1, s));
		   result = mix(result, color(0,0,0), filterstep(1, t));
		   result = mix(result, color(0,0,0), 1 - filterstep(0, s));
		   result = mix(result, color(0,0,0), 1 - filterstep(0, t));
	       }
	   }
       

		/*  Worley noise -- 3-D, 2-feature version.*/
		void
		pxslWorley (float frequency;
		    	    uniform string distancemetric;
		    	    float jitter;
			    uniform float clamp;
		    	    float c1, c2;
			    point p;
			    vector dpdu;
			    vector dpdv;
			    output float g;
		    	    )
		{
    	    	    float f1,f2;
		    point pp = frequency * p;
		    point thiscell = point (floor(xcomp(pp))+0.5,
		     	    	    	    floor(ycomp(pp))+0.5,
					    floor(zcomp(pp))+0.5);
		    f1 = f2 = 1000;
		    uniform float i, j, k;
		    for (i = -1;  i <= 1;  i += 1) {
        		for (j = -1;  j <= 1;  j += 1) {
        		    for (k = -1;  k <= 1;  k += 1) {
				point testcell = thiscell + vector(i,j,k);
                		point pos = testcell + jitter * 
				    (vector cellnoise (testcell) - 0.5);
				vector offset = pos - pp;
                		float dist;
				if (distancemetric == "Euclidian")  	
				    dist = offset.offset;
				else
				{
				    dist =  abs(xcomp(offset)) +
				    	    abs(ycomp(offset)) +
					    abs(zcomp(offset));
				}
                		if (dist < f1) {
                		    f2 = f1;
                		    f1 = dist;
                		} else if (dist < f2) {
                		    f2 = dist;
				}
        		    }
			}
		    }
		    if (distancemetric == "Euclidian")  	
    	    	    {
		    	f1 = sqrt(f1);
		    	f2 = sqrt(f2);
		    }
		    g = f1 * c1 + f2 * c2;
		    if (clamp != 0)
		    {
		    	g = clamp(g, 0, 1);
		    }
		}
	    

	   void pxslFloatToColor(float ca; output color c;)
	   {
	       c = color(ca,ca,ca);
	   }
       

		void pxslST (
			  uniform float angle;
			  uniform float repeatS; uniform float repeatT;
			  uniform float offsetS; uniform float offsetT;
			  output point Q;
			  output vector dQu;
			  output vector dQv;
			  )
		{
		    extern float s, t, du, dv;
		    setxcomp(Q, repeatS * s + offsetS);
		    setycomp(Q, repeatT * t + offsetT);
		    setzcomp(Q, 0);
		    if(angle != 0)
		    {
			Q = rotate(Q, radians(angle), point(0,0,0),
			    	     point(0,0,1)); 
		    }
		    dQu = Du(Q) * du;
		    dQv = Dv(Q) * dv;
		}
	    

		void
		pxslTile(uniform point frequency; 
			uniform float tilesize;
			uniform float jitter; 
			uniform float rowoffset;
			uniform float randomz;
			point inQ;
			vector dinQu;
			vector dinQv;
			output point Q;
			output vector dQu;
			output vector dQv;
			)
		{
		    float x, y, z, xx, xOffset = 0;
		    point jitterPt;
		    
		    Q = inQ * frequency * tilesize;
		    jitterPt = inQ * frequency;
		    dQu = dinQu * frequency;
		    dQv = dinQv * frequency;
		    x = xcomp(Q);
		    y = ycomp(Q);
		    z = zcomp(Q);
		    if( rowoffset != 0 )
		    {
			if( mod(y, 2*tilesize) > tilesize ||
			    mod(z, 2*tilesize) > tilesize )
			{
			    xOffset = .5 * tilesize;
			    setxcomp(jitterPt, xcomp(jitterPt) + xOffset);
			}
		    }
		    Q += jitter * (tilesize - 1) * 
			    (vector(.5,.5,.5) - vector cellnoise(jitterPt));
		    x = xcomp(Q);
		    y = ycomp(Q);
		    z = zcomp(Q);
		    xx = .5 * (tilesize - 1);
		    x -= xx;
		    y -= xx;
		    z -= xx;
		    x = mod(x + xOffset, tilesize);
		    y = mod(y, tilesize);
		    z = mod(z, tilesize);
		    if( randomz != 0 )
		    {
			z = float cellnoise(jitterPt);
		    }
		    Q = point(x, y, z);
		}
	    

#include "pxslUtil.h"
#include "noises.h"
	void
	pxslTurbulence (uniform float octaves, lacunarity, gain;
	    float fourthdimension;
	    point p;
	    vector dpu, dpv;
	    output float result;)
	{
	    uniform float amp = 1;
	    varying point pp = p;
	    varying float fw = pxslFilterWidth(dpu, dpv);
	    uniform float i;
	    extern float du, dv; /* for filterwidth macro */
    	    result = 0;
	    for (i = 0;  i < octaves;  i += 1) {
	#pragma nolint
		float n = filteredsnoiset (pp, fw, fourthdimension);
		float dn = filterwidth(n);
		result += amp * filteredabs (n, dn);
		amp *= gain;  pp *= lacunarity;  fw *= lacunarity;
	    }
	}
    
/* end referenced functions ------------------------*/
  uniform color white = color(1,1,1);
  color cs = 0, os = 0;
  point tmp0;
  vector tmp1;
  vector tmp2;
  pxslST ( /* ST0 */
    0 /* Angle */,
    4.7 /* S Repeats */,
    4.3 /* T Repeats */,
    0 /* S Offset */,
    0 /* T Offset */,
    tmp0,
    tmp1,
    tmp2
    );
  point tmp3;
  vector tmp4;
  vector tmp5;
  pxslST ( /* ST1 */
    0 /* Angle */,
    ST1_repeatS,
    ST1_repeatT,
    0 /* S Offset */,
    0 /* T Offset */,
    tmp3,
    tmp4,
    tmp5
    );
  point tmp6;
  vector tmp7;
  vector tmp8;
  pxslTile ( /* Tile_0 */
    point(2.00,2.00,2.00) /* Frequency */,
    1 /* Tile Size */,
    0 /* Jitter */,
    0 /* Row Offset */,
    0 /* Random Z */,
    tmp0,
    tmp1,
    tmp2,
    tmp6,
    tmp7,
    tmp8
    );
  point tmp9;
  vector tmp10;
  vector tmp11;
  pxslTile ( /* Tile_0 */
    point(2.00,2.00,2.00) /* Frequency */,
    1 /* Tile Size */,
    0 /* Jitter */,
    0 /* Row Offset */,
    0 /* Random Z */,
    tmp3,
    tmp4,
    tmp5,
    tmp9,
    tmp10,
    tmp11
    );
  float tmp12;
  pxslTurbulence ( /* Turbulence0 */
    8 /* octaves */,
    1.53 /* lacunarity */,
    0.89 /* gain */,
    0 /* Fourth Dimension */,
    tmp9,
    tmp10,
    tmp11,
    tmp12
    );
  color tmp13;
  pxslColorRamp ( /* ColorRamp1 */
    5 /* RampType */,
    1 /* Tile */,
    6 /* numKnots */,
    0 /* k0 */,
    color(0,0,0) /* c0 */,
    0 /* k1 */,
    color(0,0,0) /* c1 */,
    0.0428571428571 /* k2 */,
    color(0.0,0.0,0.0) /* c2 */,
    0.0642857142857 /* k3 */,
    color(1.0,1.0,1.0) /* c3 */,
    1 /* k4 */,
    color(1,1,1) /* c4 */,
    1 /* k5 */,
    color(1,1,1) /* c5 */,
    0 /* k6 */,
    color(0,0,0) /* c6 */,
    0 /* k7 */,
    color(0,0,0) /* c7 */,
    0 /* k8 */,
    color(0,0,0) /* c8 */,
    0 /* k9 */,
    color(0,0,0) /* c9 */,
    0 /* k10 */,
    color(0,0,0) /* c10 */,
    0 /* k11 */,
    color(0,0,0) /* c11 */,
    0 /* k12 */,
    color(0,0,0) /* c12 */,
    0 /* k13 */,
    color(0,0,0) /* c13 */,
    0 /* k14 */,
    color(0,0,0) /* c14 */,
    0 /* k15 */,
    color(0,0,0) /* c15 */,
    tmp9,
    tmp10,
    tmp11,
    tmp13
    );
  float tmp14;
  pxslWorley ( /* Worley0 */
    59.7 /* frequency */,
    "Euclidian" /* distancemetric */,
    .75 /* jitter */,
    1 /* clamp */,
    0.19 /* c1 */,
    -0.06 /* c2 */,
    tmp9,
    tmp10,
    tmp11,
    tmp14
    );
  color tmp15;
  pxslFloatToColor ( /* FloatToColor0 */
    tmp12,
    tmp15
    );
  color tmp16;
  pxslFloatToColor ( /* FloatToColor1 */
    tmp14,
    tmp16
    );
  color tmp17;
  color tmp18;
  pxslBlinn ( /* tile */
    tile_SurfaceColor,
    tmp13,
    color(0,0,0) /* Ambient Color */,
    color(0,0,0) /* Incandescence */,
    0.44 /* Diffuse Coefficient */,
    0 /* Translucence Coefficient */,
    tmp15,
    0.47 /* Eccentricity */,
    0.65 /* Specular Rolloff */,
    1 /* Reflectivity */,
    tmp17,
    tmp18
    );
  pxslBlinn ( /* motor */
    tmp16,
    color(1,1,1) /* Opacity */,
    color(0,0,0) /* Ambient Color */,
    color(0,0,0) /* Incandescence */,
    .8 /* Diffuse Coefficient */,
    0 /* Translucence Coefficient */,
    color(1,1,1) /* Specular Color */,
    .5 /* Eccentricity */,
    .1 /* Specular Rolloff */,
    1 /* Reflectivity */,
    tmp13,
    tmp15
    );
  cs = tmp13 + (white - tmp15) * cs;
  os = tmp15 + (white - tmp15) * os;
  cs = tmp17 + (white - tmp18) * cs;
  os = tmp18 + (white - tmp18) * os;
  Ci = cs;
  Oi = os;
}

