/*
** Copyright (c) 1999 PIXAR.  All rights reserved.  This program or
** documentation contains proprietary confidential information and trade
** secrets of PIXAR.  Reverse engineering of object code is prohibited.
** Use of copyright notice is precautionary and does not imply
** publication.
**
**                      RESTRICTED RIGHTS NOTICE
**
** Use, duplication, or disclosure by the Government is subject to the
** following restrictions:  For civilian agencies, subparagraphs (a) through
** (d) of the Commercial Computer Software--Restricted Rights clause at
** 52.227-19 of the FAR; and, for units of the Department of Defense, DoD
** Supplement to the FAR, clause 52.227-7013 (c)(1)(ii), Rights in
** Technical Data and Computer Software.
**
** Pixar
** 1001 West Cutting Blvd.
** Richmond, CA  94804
**
** ----------------------------------------------------------------------------
*/
/* code generated by slim 1.0d01, RAT 4.0d01 (Sep 10 1999 12:08:24) */
/* for dsisson@glaw.rainsound.com at: Fri Sep 10 15:01:15 PDT 1999 */
displacement floorTilerBump1 (
  float ST1_repeatS=10.0;
  float ST1_repeatT=10.0;
  float DoDisplacement=0;
  float Kb=1;
  float Kb2=.1;
  )
{
/* begin referenced functions ----------------------*/

#include "pxslUtil.h"
	   void
	   pxslColorRamp( float RampType;
		 float tile;
		 float numKnots;
		 float k0; color c0; 
		 float k1; color c1; 
		 float k2; color c2;
		 float k3; color c3;
		 float k4; color c4;
		 float k5; color c5;
		 float k6; color c6;
		 float k7; color c7;
		 float k8; color c8;
		 float k9; color c9;
		 float k10; color c10;
		 float k11; color c11;
		 float k12; color c12;
		 float k13; color c13;
		 float k14; color c14;
		 float k15; color c15;
		 point Q;
		 vector dQu;
		 vector dQv;
		 output color result;
		)
	   {
	       float k, s, t;
	       if( RampType <= 1 ) /* uramp, vramp */
	       {
		   if( RampType == 0 )
		   {
		       s = xcomp(Q);
		       t = ycomp(Q);
		   }
		   else
		   {
		       s = ycomp(Q);
		       t = xcomp(Q);
		   }
		   if( tile == 1 )
		       s = s - floor(s);
		   k = float spline( "solvecatrom", s, 
			   k0, k1, k2, k3, k4, k5,
			   k6, k7, k8, k9, k10, k11,
			   k12, k13, k14, k15 );
		   result = color spline( "catrom", k, 
			   c0, c1, c2, c3, c4, c5, 
			   c6, c7, c8, c9, c10, c11,
			   c12, c13, c14, c15 );
	       }
	       else
	       {
		   uniform float pi2 = 2 * PI;
		   float ss, tt;
		   s = xcomp(Q);
		   t = ycomp(Q);
		   if( tile == 1 )
		   {
		       s = s - floor(s);
		       t = t - floor(t);
		   }
		   if(RampType == 2) /* diagonal */
		   {
		       ss = (s + t) / 2.0;
		   }
		   else
		   if(RampType == 3) /* radial */
		   {
		       ss = (atan(t-.5, s-.5) + PI) / pi2;
		   }
		   else
		   if(RampType == 4) /* circular */
		   {
		       ss = s - .5;
		       tt = t - .5;
		       ss = 1 - sqrt(2 * (ss * ss + tt * tt));
		   }
		   else 
		   if(RampType == 5) /* box */
		   {
		       ss = s - .5;
		       tt = t - .5;
		       if( abs(ss) < abs(tt) )
			   ss = tt;
		       ss = 1 - sqrt(2*(2*ss*ss));
		   }
		   if(RampType != 6)
		   {
		       k = float spline( "solvecatrom", ss, 
			   k0, k1, k2, k3, k4, k5,
			   k6, k7, k8, k9, k10, k11,
			   k12, k13, k14, k15 );
		       result = color spline( "catrom", k, 
			   c0, c1, c2, c3, c4, c5, 
			   c6, c7, c8, c9, c10, c11,
			   c12, c13, c14, c15 );
		   }
		   else  /* 4 corner */
		   {
		       /* collect samples at four "adjacent" points */
		       color C0, C1, C2, C3;
		       float f;
		       ss = s - .5;
		       tt = t - .5;
		       C0 = pxslBimix( c1, c2, c3, c4, ss + .5, tt + .5 );
		       C1 = pxslBimix( c1, c2, c3, c4, ss - .5, tt + .5 );
		       C2 = pxslBimix( c1, c2, c3, c4, ss + .5, tt - .5 );
		       C3 = pxslBimix( c1, c2, c3, c4, ss - .5, tt - .5 );

		       /* mix the corner pieces */
		       f = filterstep( .5, ss );
		       C0 = mix(C0, C1, f);
		       C1 = mix(C2, C3, f);
		       result = mix(C0, C1, filterstep(.5, tt));

		       /* final anti-aliasing */
		       f = smoothstep(.125, .5, area(point(ss,tt,0)));
		       result = mix(result, pxslBimix(c1,c2,c3,c4,.5,.5), f);
		   }
	       }
	       if( tile == 0 )
	       {
		   result = mix(result, color(0,0,0), filterstep(1, s));
		   result = mix(result, color(0,0,0), filterstep(1, t));
		   result = mix(result, color(0,0,0), 1 - filterstep(0, s));
		   result = mix(result, color(0,0,0), 1 - filterstep(0, t));
	       }
	   }
       

		void pxslST (
			  uniform float angle;
			  uniform float repeatS; uniform float repeatT;
			  uniform float offsetS; uniform float offsetT;
			  output point Q;
			  output vector dQu;
			  output vector dQv;
			  )
		{
		    extern float s, t, du, dv;
		    setxcomp(Q, repeatS * s + offsetS);
		    setycomp(Q, repeatT * t + offsetT);
		    setzcomp(Q, 0);
		    if(angle != 0)
		    {
			Q = rotate(Q, radians(angle), point(0,0,0),
			    	     point(0,0,1)); 
		    }
		    dQu = Du(Q) * du;
		    dQv = Dv(Q) * dv;
		}
	    

#include "pxslRemap.h"
		void
		pxslColorToGray( color c;
			float conversion;
			float invert;
			float bias;
			float gain;
			output float result; )
		{
		    if(conversion == 0)
		    {
			result = comp(c,0);
		    }
		    else
		    if(conversion == 1)
		    {
			result = comp(c,1);
		    }
		    else
		    if(conversion == 2)
		    {
			result = comp(c,2);
		    }
		    else
		    if(conversion == 3)
		    {
			result = .3 * comp(c, 0) + .59 * comp(c, 1) + 
			    .11 * comp(c, 2);
		    }
		    else
		    if(conversion == 4)
		    {
			result = max( comp(c,0), comp(c,1), comp(c,2) );
		    }
		    else
		    if(conversion == 5)
		    {
			result = (comp(c,0) + comp(c,1) + comp(c,2)) / 3;
		    }
		    else
		    if(conversion == 6)
		    {
			result = min( comp(c,0), comp(c,1), comp(c,2) );
		    }
		    if(invert == 1)
			result = 1 - result;
		    result = pxslFloatBias(bias, result);
		    result = pxslFloatGain(gain, result);
		}
	    
/* end referenced functions ------------------------*/
  normal Nf;
  point PP = transform("shader", P);
  float disptotal;
  point tmp0;
  vector tmp1;
  vector tmp2;
  pxslST ( /* ST1 */
    0 /* Angle */,
    ST1_repeatS,
    ST1_repeatT,
    0 /* S Offset */,
    0 /* T Offset */,
    tmp0,
    tmp1,
    tmp2
    );
  color tmp3;
  pxslColorRamp ( /* ColorRamp10 */
    5 /* RampType */,
    1 /* Tile */,
    8 /* numKnots */,
    0 /* k0 */,
    color(0,0,0) /* c0 */,
    0 /* k1 */,
    color(0,0,0) /* c1 */,
    0.0214285714286 /* k2 */,
    color(0.0,0.0,0.0) /* c2 */,
    0.2 /* k3 */,
    color(0.929411764706,0.929411764706,0.929411764706) /* c3 */,
    0.382142857143 /* k4 */,
    color(1.0,1.0,1.0) /* c4 */,
    0.467857142857 /* k5 */,
    color(1.0,1.0,1.0) /* c5 */,
    1 /* k6 */,
    color(1,1,1) /* c6 */,
    1 /* k7 */,
    color(1,1,1) /* c7 */,
    0 /* k8 */,
    color(0,0,0) /* c8 */,
    0 /* k9 */,
    color(0,0,0) /* c9 */,
    0 /* k10 */,
    color(0,0,0) /* c10 */,
    0 /* k11 */,
    color(0,0,0) /* c11 */,
    0 /* k12 */,
    color(0,0,0) /* c12 */,
    0 /* k13 */,
    color(0,0,0) /* c13 */,
    0 /* k14 */,
    color(0,0,0) /* c14 */,
    0 /* k15 */,
    color(0,0,0) /* c15 */,
    tmp0,
    tmp1,
    tmp2,
    tmp3
    );
  float tmp4;
  pxslColorToGray ( /* ColorToGray0 */
    tmp3,
    3 /* Conversion */,
    0 /* Invert */,
    .5 /* Bias */,
    .5 /* Gain */,
    tmp4
    );
  if(0 == 0) /* add */
      disptotal = 0;
  else
  if(0 == 1) /* multiply */
     disptotal = 1;
  Nf = normalize( ntransform("shader", N) );
  if(0 == 0) /* add */
      disptotal += Kb2 * tmp4;
  else /* multiply */
      disptotal *= Kb2 * tmp4;
  PP += Kb * disptotal * Nf;
  PP = transform("shader", "current", PP);
  N = calculatenormal(PP);
  if( DoDisplacement != 0 )
       P = PP;
}

