/* $Id: //depot/branches/rmanprod/rat-6.0/ratdocs/education/RenderMan_Companion/tutorial/ch16/shaders/glow.sl#1 $  (Pixar - RenderMan Division)  $Date: 2004/01/13 $ */
/*
** Copyright (c) 1998 PIXAR.  All rights reserved.  This program or
** documentation contains proprietary confidential information and trade
** secrets of PIXAR.  Reverse engineering of object code is prohibited.
** Use of copyright notice is precautionary and does not imply publication.
**
**                      RESTRICTED RIGHTS NOTICE
**
** Use, duplication, or disclosure by the Government is subject to the
** following restrictions:  For civilian agencies, subparagraphs (a) through
** (d) of the Commercial Computer Software--Restricted Rights clause at
** 52.227-19 of the FAR; and, for units of the Department of Defense, DoD
** Supplement to the FAR, clause 52.227-7013 (c)(1)(ii), Rights in
** Technical Data and Computer Software.
**
** Pixar
** 1001 West Cutting Blvd.
** Richmond, CA  94804
*/
/* Listing 16.26  Shader mapping object-space coordinates to colors*/
/*
 * glow(): a shader for providing a centered "glow" in a sphere 
 */
surface
glow( float	attenuation = 2 )
{
	normal NN = normalize(N);
	vector II = normalize(I);
	float falloff = II.NN;	/* Direct incidence has cosine closer to 1.*/

	if (falloff < 0) {  		/* Back of sphere only */
		/* Normalize falloff by lengths of I and N */
		falloff = falloff * falloff / (II.II * NN.NN) ;
		falloff = pow(falloff, attenuation);
		Ci = Cs * falloff;
		Oi = falloff;
	} else
		Oi = 0;
}
