/* $Id: //depot/branches/rmanprod/rat-6.0/ratdocs/education/RenderMan_Companion/tutorial/ch16/shaders/gouge.sl#1 $  (Pixar - RenderMan Division)  $Date: 2004/01/13 $ */
/*
** Copyright (c) 1998 PIXAR.  All rights reserved.  This program or
** documentation contains proprietary confidential information and trade
** secrets of PIXAR.  Reverse engineering of object code is prohibited.
** Use of copyright notice is precautionary and does not imply publication.
**
**                      RESTRICTED RIGHTS NOTICE
**
** Use, duplication, or disclosure by the Government is subject to the
** following restrictions:  For civilian agencies, subparagraphs (a) through
** (d) of the Commercial Computer Software--Restricted Rights clause at
** 52.227-19 of the FAR; and, for units of the Department of Defense, DoD
** Supplement to the FAR, clause 52.227-7013 (c)(1)(ii), Rights in
** Technical Data and Computer Software.
**
** Pixar
** 1001 West Cutting Blvd.
** Richmond, CA  94804
*/
/*
 * gouge(): Use a texture map to displace a surface.
 */
displacement
gouge(
	float	Km	= 0.03,
		spin	= 0.0;		/* each pin gets its texture spun */
	string	texturename = "marks.txt")
{
	float	y = ycomp(transform("object",P));						/* convert to object space	 */

/* Use the same texture map that the surface shader uses. Spin it a different
 *  amount for each pin so that similarity is not detected.  The texture 
 *  determines the size of the gouge. Multiply by the Km factor, then 
 *  displace the surface point inwards by that amount. */
	P += (-Km * texture(texturename,s+spin,y/15.0)) * normalize(N);
	N = calculatenormal(P);
}
