/*
** Copyright (c) 2000 PIXAR.  All rights reserved.  This program or
** documentation contains proprietary confidential information and trade
** secrets of PIXAR.  Reverse engineering of object code is prohibited.
** Use of copyright notice is precautionary and does not imply
** publication.
**
**                      RESTRICTED RIGHTS NOTICE
**
** Use, duplication, or disclosure by the Government is subject to the
** following restrictions:  For civilian agencies, subparagraphs (a) through
** (d) of the Commercial Computer Software--Restricted Rights clause at
** 52.227-19 of the FAR; and, for units of the Department of Defense, DoD
** Supplement to the FAR, clause 52.227-7013 (c)(1)(ii), Rights in
** Technical Data and Computer Software.
**
** Pixar
** 1001 West Cutting Blvd.
** Richmond, CA  94804
**
** ----------------------------------------------------------------------------
*/
/* code generated by slim 1.1b2, RAT 4.1b2 (May 20 2000 02:01:34) */
/* for dsisson@glaw.rainsound.com at: Mon May 22 12:05:32 PDT 2000 */
surface mirrorWood_0 (
  string SurfacePoint_0_Space="object";
  varying point __Pref=point(-1e10,-1e10,-1e10);
  color mirrorWood_0_SurfaceColor=color(0.278431372549,0.171606214804,0.134302191465);
  )
{
/* begin referenced functions ----------------------*/

	   void pxslFloatToColor(float fa; color ca; output color c;)
	   {
	       c = ca * color(fa,fa,fa);
	   }
       

#include "noises.h"
      void
      pxslOakGrain (float ringfreq, ringunevenness, grainfreq;
		  float ringnoise, ringnoisefreq;
		  float trunkwobble, trunkwobblefreq;
		  float angularwobble, angularwobblefreq;
		  float ringy, grainy;
		  point Pshad;
		  vector dPshadU;
		  vector dPshadV;
		  output float result;)
      {
	  /* We shade based on Pshad, but we add several layers of warping: */
	  /* Some general warping of the domain */
	  float dPshad = length(dPshadU^dPshadV);
	  vector offset = vfBm(Pshad*ringnoisefreq,
	    	    	      dPshad*ringnoisefreq, 2, 4, 0.5);
	  point Pring = Pshad + ringnoise*offset;
	  /* The trunk isn't totally steady xy as you go up in z */
	  Pring += trunkwobble * 
        	     vsnoise(zcomp(Pshad)*trunkwobblefreq) * vector(1,1,0);

	  /* Calculate the radius from the center. */
	  float r2 = sqr(xcomp(Pring)) + sqr(ycomp(Pring));
	  float r = sqrt(r2) * ringfreq;
	  /* Add some noise around the trunk */
	  r += angularwobble * smoothstep(0,5,r)
		 * snoise (angularwobblefreq*(Pring)*vector(1,1,0.1));

	  /* Now add some noise so all rings are not equal width */
	  extern float du, dv;
	  float dr = filterwidth(r);
	  r += ringunevenness*filteredsnoise(r,dr);

	  float inring = smoothpulsetrain (.1, .55, .7, .95, 1, r);

	  point Pgrain = Pshad*grainfreq*vector(1,1,.05);
	  float dPgrain = filterwidthp(Pgrain);
	  float grain = 0;
	  float i, amp=1;
	  for (i = 0;  i < 2;  i += 1) {
	      float grain1valid = 1-smoothstep(.2,.6,dPgrain);
	      if (grain1valid > 0) {
		  float g = grain1valid * snoise (Pgrain);
		  g *= (0.3 + 0.7*inring);
		  g = pow(clamp(0.8 - (g),0,1),2);
		  g = grainy * smoothstep (0.5, 1, g);
		  if (i == 0)
		      inring *= (1-0.4*grain1valid);
		  grain = max (grain, g);
	      }
	      Pgrain *= 2;
	      dPgrain *= 2;
	      amp *= 0.5;
	  }
	  result = mix (inring*ringy, 1, grain);
      }
    

#include "pxslRemap.h"
		void 
		pxslRemapF(float f; 
			float inputmin, inputmax;
			float outputmin, outputmax;
			float disablegain;
			float bias, gain;
			output float result; )
		{
		    result = clamp(f, inputmin, inputmax);
		    result = outputmin + (outputmax - outputmin) * 
		    	(result - inputmin) / (inputmax - inputmin);
		    if (disablegain == 0)
		    {
		    	result = pxslFloatBias(bias, result);
		    	result = pxslFloatGain(gain, result);
		    }
		}
	    

		void pxslSurfacePoint (
		    uniform string coordsys;
		    uniform float frequency;
		    uniform float ignorePref;
		    output point Q; 
		    output vector dQu;
		    output vector dQv;
		) 
		{
		    extern point P;
		    extern vector dPdu, dPdv;
		    extern point __Pref;
		    extern float du, dv;
		    uniform string sys;

		    if(coordsys == "")
		    	sys = "shader";
		    else
		    	sys = coordsys;

		    if (xcomp(__Pref) == -1e10 || ignorePref != 0)
		    {
		    	Q = transform (sys, frequency*P);
		    	dQu = vtransform (sys, dPdu*du*frequency);
		    	dQv = vtransform (sys, dPdv*dv*frequency);
		    }
		    else 
		    {
			Q = frequency * transform (sys, __Pref);
			dQu = vector Du(Q)*du;
		        dQv = vector Dv(Q)*dv;
		    }
		}
	    

	   void
	   pxslPlastic(color SurfaceColor;
		   color SurfaceOpacity;
		   float Ka;
		   float Kd;
		   float Ks;
		   float Roughness;
		   color SpecularColor;
		   output color CI;
		   output color OI;
		   )
	   {
	       normal Nf;
	       vector V;
	       extern normal N;
	       extern vector I;
	       Nf = faceforward( normalize(N), I );
	       V = -normalize(I);
	       OI = SurfaceOpacity;
	       CI = SurfaceOpacity * 
		       (SurfaceColor *
		    	   (Ka*ambient() + Kd*diffuse(Nf)) +
			   SpecularColor * Ks * specular(Nf,V,Roughness));
	   }
       
/* end referenced functions ------------------------*/
  point tmp0;
  vector tmp1;
  vector tmp2;
  pxslSurfacePoint ( /* SurfacePoint_0 */
    SurfacePoint_0_Space,
    1 /* Frequency */,
    0 /* IgnorePref */,
    tmp0,
    tmp1,
    tmp2
    );
  float tmp3;
  pxslOakGrain ( /* OakGrain_Wood */
    20.00 /* ringfreq */,
    .5 /* rignunevenness */,
    25 /* grainfreq */,
    0.08 /* ringnoise */,
    1 /* ringnoisefreq */,
    4.00 /* trunkwobble */,
    .025 /* trunkwobblefreq */,
    1 /* angularwobble */,
    1.5 /* angularwobblefreq */,
    0.80 /* ringy */,
    0.40 /* grainy */,
    tmp0,
    tmp1,
    tmp2,
    tmp3
    );
  float tmp4;
  pxslRemapF ( /* Remap_Wood */
    tmp3,
    0 /* inputmin */,
    1 /* inputmax */,
    0.60 /* outputmin */,
    1 /* outputmax */,
    0 /* Disable Bias/Gain */,
    .5 /* Bias */,
    .5 /* Gain */,
    tmp4
    );
  color tmp5;
  pxslFloatToColor ( /* FloatToColor_wood */
    tmp3,
    color(1,1,1) /* Coloration */,
    tmp5
    );
  color tmp6;
  color tmp7;
  pxslPlastic ( /* mirrorWood_0 */
    mirrorWood_0_SurfaceColor,
    color(1,1,1) /* Opacity */,
    tmp3,
    tmp4,
    0.25 /* Ks */,
    0.15 /* Roughness */,
    tmp5,
    tmp6,
    tmp7
    );
  Ci = tmp6;
  Oi = tmp7;
}

