/* $Id: //depot/branches/rmanprod/rat-6.0/ratdocs/education/RenderMan_Companion/tutorial/ch16/shaders/pits.sl#1 $  (Pixar - RenderMan Division)  $Date: 2004/01/13 $ */
/*
** Copyright (c) 1998 PIXAR.  All rights reserved.  This program or
** documentation contains proprietary confidential information and trade
** secrets of PIXAR.  Reverse engineering of object code is prohibited.
** Use of copyright notice is precautionary and does not imply publication.
**
**                      RESTRICTED RIGHTS NOTICE
**
** Use, duplication, or disclosure by the Government is subject to the
** following restrictions:  For civilian agencies, subparagraphs (a) through
** (d) of the Commercial Computer Software--Restricted Rights clause at
** 52.227-19 of the FAR; and, for units of the Department of Defense, DoD
** Supplement to the FAR, clause 52.227-7013 (c)(1)(ii), Rights in
** Technical Data and Computer Software.
**
** Pixar
** 1001 West Cutting Blvd.
** Richmond, CA  94804
*/
/* Listing 16.30  Displacement shader using a texture for pits and gouges*/
/* 
 *  pits(): use a texture map to apply pits to a surface 
 */
displacement
pits( 
	float Km = 0.03; 
	string marks = "" )
{
	float magnitude;
 
	/* Get the displacement, if any, from the texture map. */
	if(marks != "")
	    magnitude = float texture(marks);	/* Use s, t */
	else
	    magnitude = 0;

/* The texture determines the size of the gouge, scaled by Km. */
	P += -Km * magnitude * normalize(N);
	N = calculatenormal(P);
}
