/*
** Copyright (c) 1999 PIXAR.  All rights reserved.  This program or
** documentation contains proprietary confidential information and trade
** secrets of PIXAR.  Reverse engineering of object code is prohibited.
** Use of copyright notice is precautionary and does not imply
** publication.
**
**                      RESTRICTED RIGHTS NOTICE
**
** Use, duplication, or disclosure by the Government is subject to the
** following restrictions:  For civilian agencies, subparagraphs (a) through
** (d) of the Commercial Computer Software--Restricted Rights clause at
** 52.227-19 of the FAR; and, for units of the Department of Defense, DoD
** Supplement to the FAR, clause 52.227-7013 (c)(1)(ii), Rights in
** Technical Data and Computer Software.
**
** Pixar
** 1001 West Cutting Blvd.
** Richmond, CA  94804
**
** ----------------------------------------------------------------------------
*/
/* code generated by slim 1.0b3, RAT 4.0b3 (Jan 12 2000 01:59:37) */
/* for dsisson@glaw.rainsound.com at: Wed Jan 12 09:49:36 PST 2000 */
surface rocked_0 (
  string SurfacePoint_Space="";
  varying point __Pref=point(-1e10,-1e10,-1e10);
  float hue2_HueOffset=0;
  float hue2_SatOffset=0;
  float hue2_LumOffset=0.00;
  color hue2_Center=color(.5,.5,.5);
  float hue2_HueRange=1;
  float hue2_SatRange=1;
  float hue2_LumRange=1.60;
  float Hue1_HueOffset=0.400;
  float Hue1_SatOffset=0.00;
  float Hue1_LumOffset=0.08;
  color Hue1_Center=color(.5,.5,.5);
  float Hue1_HueRange=0.12;
  float Hue1_SatRange=0.07;
  float Hue1_LumRange=1.13;
  )
{
/* begin referenced functions ----------------------*/

	   void pxslFloatToColor(float fa; color ca; output color c;)
	   {
	       c = ca * color(fa,fa,fa);
	   }
       

#include "pxslUtil.h"
#include "noises.h"
	void
	pxslBrownian ( 
	     uniform float baseFreq;
	     uniform float octaves, lacunarity, gain;
	     uniform float rescale;
	     float fourthdimension;
	     point p;
	     vector dpu, dpv;
	     output float result;)
	{
	    uniform float amp = 1;
	    varying point pp = baseFreq * p;
	    varying float fw = pxslFilterWidth(baseFreq*dpu, baseFreq*dpv);
	    uniform float i;
    	    result = 0;
	    for (i = 0; i < octaves; i += 1) {
#pragma nolint
		result += amp * filteredsnoiset(pp, fw, fourthdimension);
		amp *= gain;  pp *= lacunarity;  fw *= lacunarity;
	    }
	    if (rescale != 0)
	    {
	    	result = .5 * (1 + result);
	    	if (rescale == 2)
		{
		    result = clamp(result, 0, 1);
		}
	    }
	}
    

	   void
	   pxslCombineColors( float method; color f1; color f2; 
		    	       output color result;)
	   {
	       if (method == 0)
	       {
		   /* Intersection */
		   result = f1 * f2;
	       }
	       else
	       if (method == 1)
	       {
		   /* Union */
		   result = f1 + f2 - f1 * f2;
	       }
	       else
	       if (method == 2)
	       {
		   /* Difference */
		   result = f1 - f1 * f2;
	       }
	   }
       

#include "pxslUtil.h"
#include "noises.h"
	void
	pxslVBrownian (
	    uniform float baseFreq;
	    uniform float octaves, lacunarity, gain; float fourthdimension;
	    point p;
	    vector dpu, dpv;
	    output vector result;)
	{
	    uniform float amp = 1;
	    uniform float sum = 0;
	    varying point pp = baseFreq * p;
	    varying float fw = pxslFilterWidth(baseFreq*dpu, baseFreq*dpv);
	    uniform float i;
    	    result = 0;
	    for (i = 0;  i < octaves;  i += 1) {
#pragma nolint
		result += amp * filteredvsnoiset(pp, fw, fourthdimension);
		sum += amp;  amp *= gain;  pp *= lacunarity;  fw *= lacunarity;
	    }
	    result /= sum;
	}
    

#include "pxslUtil.h"
#include "noises.h"
	void
	pxslTurbulence (
	    uniform float baseFreq;
	    uniform float octaves, lacunarity, gain;
	    uniform float invert;
	    float fourthdimension;
	    point p;
	    vector dpu, dpv;
	    output float result;)
	{
	    uniform float amp = 1;
	    uniform float sum = 0;
	    varying point pp = baseFreq*p;
	    varying float fw = pxslFilterWidth(baseFreq*dpu, baseFreq*dpv);
	    uniform float i;
	    extern float du, dv; /* for filterwidth macro */
    	    result = 0;
	    for (i = 0;  i < octaves;  i += 1) {
	#pragma nolint
		float n = filteredsnoiset (pp, fw, fourthdimension);
		float dn = filterwidth(n);
		result += amp * filteredabs (n, dn);
		sum += amp;  amp *= gain;  pp *= lacunarity;  fw *= lacunarity;
	    }
	    result /= .5*sum;

	    if (invert != 0)
		result = 1-result;
	}
    

	   void
	   pxslMarble(
		   color cs;
		   float veining;
		   point Pt;
		   vector dPdu;
		   vector dPdv;
		   output color Cmarble;)
	   {
	       float pixelsize, twice, scale, weight, turbulence, sat, val;
	       color cshsv, csrgb;
	       point PP = Pt;

    	       /* frequency adjustment (S-shaped curve) */
	       PP = PP * veining / 2; 
	       pixelsize = sqrt(area(PP)); 
	       twice = 2 * pixelsize;

	       /* compute turbulence */
	       turbulence = 0;
	       for (scale = 1; scale > twice; scale /= 2) {
		   turbulence += scale * abs(noise(PP/scale)-0.5);
	       }
	       /* gradual fade out of highest freq component near
		    visibility limit */
	       if (scale > pixelsize) {
		   weight = (scale / pixelsize) - 1;
		   weight = clamp(weight, 0, 1);
		   turbulence += weight * scale * abs(noise(PP/scale)-0.5);
	       }

	       /*
		* Assuming that Cs is in RGB space, convert to HSV space so
		* that we can modulate saturation and value without
		* changing hue.
		*/
	       cshsv = ctransform("hsv", cs);

	       /*
		* Now we have Cs in hue,sat,val (HSV) form.  Proceed to
		* modulate saturation and value based on the turbulence
		* computed earlier. Value is blended between the value of
		* Cs and white (value = 1). So a "black" marble has black
		* veins and a "white" marble has white veins outlined in
		* dark gray.
		*/
	       sat = comp(cshsv, 1);
	       val = comp(cshsv, 2);
	       sat *= float spline(turbulence,
		       0.999, 0.999, 0.200, 0.060, 0.030, 0.020,
		       0.010, 0.010, 0.000);
	       val *=  float spline(turbulence,
		       0.999, 0.999, 0.400, 0.000,
		       0.000, 0.000, 0.000,
		       0.000, 0.000, 0.000, 0.000
		       ) + float spline(turbulence,
		       0.000, 0.000, 0.000, 0.800,
		       0.800, 0.800, 0.800,
		       0.999, 0.999, 0.999, 0.999);
	       setcomp(cshsv, 1, sat);
	       setcomp(cshsv, 2, val);
	       Cmarble = ctransform("hsv", "rgb", cshsv);
	   }
       

		void 
		pxslWarp( 
		    vector warpFunc;
		    uniform vector Kw;
		    point Qin;
		    vector dQuin;
		    vector dQvin;
		    output point Q;
		    output vector dQu;
		    output vector dQv;
		    )
		{
		    extern float du, dv;
		    Q = Qin + Kw * warpFunc;
		    dQu = vector Du(Q)*du;
		    dQv = vector Dv(Q)*dv;
		}
	    

	    void 
	    pxslColorCorrect (
		color	C; 
		float	HueOffset,
			SatOffset,
			LumOffset;
		color	Cavg;
		float	HueRange,
			SatRange,
			LumRange;

		output color	Cresult;
	    )
	    {
		color	Cavghsy;

		Cresult = ctransform ("RGB", "HSY", C);
		Cavghsy = ctransform ("RGB", "HSY", Cavg);

		Cresult -= Cavghsy;
		Cresult *= color (HueRange, SatRange, LumRange);
		Cresult += Cavghsy;

		Cresult += color (HueOffset, SatOffset, LumOffset);
	
		Cresult = ctransform ("HSY", "RGB", Cresult);
	    }
	

	   void
	   pxslMetal(color SurfaceColor;
		   color SurfaceOpacity;
		   float Ka;
		   float Kd;
		   float Ks;
		   float Roughness;
		   output color CI;
		   output color OI;
		   )
	   {
	       normal Nf;
	       extern normal N;
	       extern vector I;
	       Nf = faceforward( normalize(N), I );
	       OI = SurfaceOpacity;
	       CI = SurfaceOpacity * 
		       SurfaceColor *
			   (Ka*ambient() + Kd*diffuse(Nf) +
			    Ks * specular(Nf,-normalize(I),Roughness));
	   }
	

		void
		pxslCombine( float method; float f1; float f2;
			output float result; )
		{
		    if (method == 0)
		    {
			/* Intersection */
			result = f1 * f2;
		    }
		    else
		    if (method == 1)
		    {
			/* Union */
			result = f1 + f2 - f1 * f2;
		    }
		    else
		    if (method == 2)
		    {
			/* Difference */
			result = f1 - f1 * f2;
		    }
		}
	    

		void pxslSurfacePoint (
		    uniform string coordsys;
		    uniform float frequency;
		    uniform float ignorePref;
		    output point Q; 
		    output vector dQu;
		    output vector dQv;
		) 
		{
		    extern point P;
		    extern vector dPdu, dPdv;
		    extern point __Pref;
		    extern float du, dv;
		    uniform string sys;

		    if(coordsys == "")
		    	sys = "shader";
		    else
		    	sys = coordsys;

		    if (xcomp(__Pref) == -1e10 || ignorePref != 0)
		    {
		    	Q = transform (sys, frequency*P);
		    	dQu = vtransform (sys, dPdu*du*frequency);
		    	dQv = vtransform (sys, dPdv*dv*frequency);
		    }
		    else 
		    {
			Q = frequency * transform (sys, __Pref);
			dQu = vector Du(Q)*du;
		        dQv = vector Dv(Q)*dv;
		    }
		}
	    

	    	void pxslC_Fractal (
		    float	Layers;
		    float	Frequency;
		    float	Lacunarity;
		    float	Dimension;
		    float	Erosion;
		    float	Measure;
		    float	Variation;
		    point	Q;
		    vector	duQ;
		    vector	dvQ;
		    output color	result;
		)
		{
		    color Noise (point Q)
		    {
			extern float	Variation;
			color	C;
			
			C = color noise (Q, Variation);
			C = color (
			    smoothstep (.2, .8, comp (C, 0)),
			    smoothstep (.2, .8, comp (C, 1)),
			    smoothstep (.2, .8, comp (C, 2))
			);
			return (C);
		    }
		    
		    float
		    Distance (float type; color C)
		    {
			float	result;

			if (type == 1)	/* Saturation */
			    result = comp (ctransform ("RGB", "HSY", C), 1);

			else if (type == 2)	/* Luminance */
			    result = comp (ctransform ("RGB", "HSY", C), 2);

			else	/* Gray */
			    result = length (vector (C - color .5)) + .319;
			
			return (result);
		    }
		    
		    uniform float	i;
		    float	sum, mag, f, offset;
		    float	dQ;
		    
		    dQ = max (
			max (
			    abs(xcomp(duQ)) + abs(xcomp(dvQ)),
			    abs(ycomp(duQ)) + abs(ycomp(dvQ))
			),
			abs(zcomp(duQ)) + abs(zcomp(dvQ))
		    );

		    f = Frequency;
		    result = mix (Noise (f*Q), color .5, smoothstep (.25, 1, f*dQ));
		    sum = 1;

		    for (i=1; i < Layers; i+=1) {
			f *= Lacunarity;
			offset = mix (-Erosion, Erosion,
			    Distance (Measure, result/sum)
			);
			mag = 1/pow (f, 3-2*Dimension + offset);
			result += mag*mix (Noise (f*Q), color .5, smoothstep (.25, 1, f*dQ));
			sum += mag;
		    }

		    result /= sum;
		}
	    

		void pxslST (
			  uniform float angle;
			  uniform float repeatS; uniform float repeatT;
			  uniform float offsetS; uniform float offsetT;
			  output point Q;
			  output vector dQu;
			  output vector dQv;
			  )
		{
		    extern float s, t, du, dv;

		    setxcomp(Q, repeatS * s + offsetS);
		    setycomp(Q, repeatT * t + offsetT);
		    setzcomp(Q, 0);

		    if(angle != 0)
			Q = rotate(Q, radians(angle), 
			    	    point(0,0,0), point(0,0,1)); 

		    dQu = vector Du(Q)*du;
		    dQv = vector Dv(Q)*dv;
		}
	    
/* end referenced functions ------------------------*/
  uniform color white = color(1,1,1);
  color cs = 0, os = 0;
  point tmp0;
  vector tmp1;
  vector tmp2;
  pxslSurfacePoint ( /* SurfacePoint */
    SurfacePoint_Space,
    1 /* Frequency */,
    0 /* IgnorePref */,
    tmp0,
    tmp1,
    tmp2
    );
  point tmp3;
  vector tmp4;
  vector tmp5;
  pxslST ( /* ST */
    0 /* Angle */,
    1 /* S Repeats */,
    1 /* T Repeats */,
    0 /* S Offset */,
    0 /* T Offset */,
    tmp3,
    tmp4,
    tmp5
    );
  color tmp6;
  pxslC_Fractal ( /* Fractal_1 */
    6 /* Layers */,
    1 /* Frequency */,
    2 /* Lacunarity */,
    1 /* Dimension */,
    0 /* Erosion */,
    0 /* Erosion Measure */,
    0 /* Variation */,
    tmp0,
    tmp1,
    tmp2,
    tmp6
    );
  float tmp7;
  pxslTurbulence ( /* Turbulence_0 */
    1 /* Base Frequency */,
    4 /* octaves */,
    2 /* lacunarity */,
    .5 /* gain */,
    0 /* invert */,
    0 /* Fourth Dimension */,
    tmp0,
    tmp1,
    tmp2,
    tmp7
    );
  float tmp8;
  pxslBrownian ( /* Brownian_1 */
    1 /* Base Frequency */,
    4 /* octaves */,
    2 /* lacunarity */,
    .5 /* gain */,
    1 /* rescale */,
    0 /* Fourth Dimension */,
    tmp0,
    tmp1,
    tmp2,
    tmp8
    );
  vector tmp9;
  pxslVBrownian ( /* Brownian */
    1 /* Base Frequency */,
    4 /* octaves */,
    2 /* lacunarity */,
    .5 /* gain */,
    0 /* Fourth Dimension */,
    tmp0,
    tmp1,
    tmp2,
    tmp9
    );
  float tmp10;
  pxslCombine ( /* Combine_0 */
    2 /* Combine Method */,
    tmp8,
    tmp7,
    tmp10
    );
  point tmp11;
  vector tmp12;
  vector tmp13;
  pxslWarp ( /* Warp_0 */
    tmp9,
    vector(0.30,0.30,0.30) /* Kw */,
    tmp3,
    tmp4,
    tmp5,
    tmp11,
    tmp12,
    tmp13
    );
  color tmp14;
  pxslFloatToColor ( /* FloatToColor_4 */
    tmp10,
    color(1,1,1) /* Coloration */,
    tmp14
    );
  color tmp15;
  pxslMarble ( /* Marble_0 */
    color(0.803921568627,0.628672230138,0.472895040369) /* MarbleColor */,
    2.05 /* MarbleVeining */,
    tmp11,
    tmp12,
    tmp13,
    tmp15
    );
  color tmp16;
  pxslColorCorrect ( /* hue2 */
    tmp14,
    hue2_HueOffset,
    hue2_SatOffset,
    hue2_LumOffset,
    hue2_Center,
    hue2_HueRange,
    hue2_SatRange,
    hue2_LumRange,
    tmp16
    );
  pxslCombineColors ( /* CombineColors_2 */
    0 /* Combine Method */,
    tmp15,
    tmp6,
    tmp14
    );
  pxslMetal ( /* Metal_3 */
    color(0.474998092622,0.499992370489,0.374990463111) /* Surface Color */,
    tmp16,
    0.78 /* Ka */,
    0.84 /* Kd */,
    0.10 /* Ks */,
    0.36 /* Roughness */,
    tmp15,
    tmp6
    );
  pxslColorCorrect ( /* Hue1 */
    tmp14,
    Hue1_HueOffset,
    Hue1_SatOffset,
    Hue1_LumOffset,
    Hue1_Center,
    Hue1_HueRange,
    Hue1_SatRange,
    Hue1_LumRange,
    tmp16
    );
  color tmp17;
  pxslMetal ( /* Metal_2 */
    tmp16,
    color(1,1,1) /* Opacity */,
    0.82 /* Ka */,
    0.78 /* Kd */,
    0.22 /* Ks */,
    0.28 /* Roughness */,
    tmp14,
    tmp17
    );
  cs = tmp14 + (white - tmp17) * cs;
  os = tmp17 + (white - tmp17) * os;
  cs = tmp15 + (white - tmp6) * cs;
  os = tmp6 + (white - tmp6) * os;
  Ci = cs;
  Oi = os;
}

