/* $Id: //depot/branches/rmanprod/rat-6.0/ratdocs/education/RenderMan_Companion/tutorial/ch16/shaders/rubber.sl#1 $  (Pixar - RenderMan Division)  $Date: 2004/01/13 $ */
/*
** Copyright (c) 1998 PIXAR.  All rights reserved.  This program or
** documentation contains proprietary confidential information and trade
** secrets of PIXAR.  Reverse engineering of object code is prohibited.
** Use of copyright notice is precautionary and does not imply publication.
**
**                      RESTRICTED RIGHTS NOTICE
**
** Use, duplication, or disclosure by the Government is subject to the
** following restrictions:  For civilian agencies, subparagraphs (a) through
** (d) of the Commercial Computer Software--Restricted Rights clause at
** 52.227-19 of the FAR; and, for units of the Department of Defense, DoD
** Supplement to the FAR, clause 52.227-7013 (c)(1)(ii), Rights in
** Technical Data and Computer Software.
**
** Pixar
** 1001 West Cutting Blvd.
** Richmond, CA  94804
*/
/* Listing 16.38  Rubber surface shader*/

/*
 * rubber(): This shader generates a rubber surface. It is a matte shader that
 * adds in a little white dust to mimic the dust on a new eraser.
 */
surface
rubber( 
	float	Ka		= 1.0, 
		Kd		= 1.0, 
		txtscale	= 1.5 )
{
	normal	Nf = faceforward(normalize(N),I);
	point	Ploc = transform("shader", P);  /* Move to shader space */
	color	cout, white=1;

	/* Mix in some white dust. */
	cout = mix(Cs, white, .05* (float noise(txtscale*Ploc)));

	/* Compute a matte surface. */
	Oi = Os;
	Ci = Os * cout * ( Ka*ambient() + Kd*diffuse(Nf) ) ;
}
