/* $Id: //depot/branches/rmanprod/rat-6.0/ratdocs/education/RenderMan_Companion/tutorial/ch16/shaders/sdixon.sl#1 $  (Pixar - RenderMan Division)  $Date: 2004/01/13 $ */
/*
** Copyright (c) 1998 PIXAR.  All rights reserved.  This program or
** documentation contains proprietary confidential information and trade
** secrets of PIXAR.  Reverse engineering of object code is prohibited.
** Use of copyright notice is precautionary and does not imply publication.
**
**                      RESTRICTED RIGHTS NOTICE
**
** Use, duplication, or disclosure by the Government is subject to the
** following restrictions:  For civilian agencies, subparagraphs (a) through
** (d) of the Commercial Computer Software--Restricted Rights clause at
** 52.227-19 of the FAR; and, for units of the Department of Defense, DoD
** Supplement to the FAR, clause 52.227-7013 (c)(1)(ii), Rights in
** Technical Data and Computer Software.
**
** Pixar
** 1001 West Cutting Blvd.
** Richmond, CA  94804
*/
/* Listing 16.37  Pencil-labeling surface shader*/
/*
 * sdixon(): Paint the body of a pencil.
 */
surface
sdixon(
	float	Ka		= 1.0, 
		Kd		= 1.0, 
		Ks		= 1.0,
	 	roughness 	= .25;
	color	green 		= color(0, .2, 0), 
		yellow 		= color(.56, .23, 0);
	string	texturename	= "dixon.tx")
{
	normal Nf = faceforward(normalize(N),I);
	vector V = normalize(-I);
	float ink;
	color cout;

	/* This shader uses a single-channel texture map to apply a 
	 *   metallic-green ink to a matte-yellow background. */

	/* Get the amount of ink from texture file. */
	ink = texture(texturename, s, t);

 	/* Use ink to mix yellow and green */
	cout = mix(yellow, green, ink); 					 

	/* Compute the output color. Notice that as ink goes from zero to
	   one, the diffuse component goes to zero and the specular 
	   component is increased. This has the effect of transitioning
	   from a matte surface to a metallic one as ink is added. */
	Oi = Os;
	Ci = Os * cout * ( Ka*ambient() + (1-ink)*Kd*diffuse(Nf) +
					ink*Ks*specular(Nf,V,roughness) ) ;
}
