/* $Id: //depot/branches/rmanprod/rat-6.0/ratdocs/education/RenderMan_Companion/tutorial/ch12/shiny.sl#1 $  (Pixar - RenderMan Division)  $Date: 2004/01/13 $ */
/*
** Copyright (c) 1998 PIXAR.  All rights reserved.  This program or
** documentation contains proprietary confidential information and trade
** secrets of PIXAR.  Reverse engineering of object code is prohibited.
** Use of copyright notice is precautionary and does not imply publication.
**
**                      RESTRICTED RIGHTS NOTICE
**
** Use, duplication, or disclosure by the Government is subject to the
** following restrictions:  For civilian agencies, subparagraphs (a) through
** (d) of the Commercial Computer Software--Restricted Rights clause at
** 52.227-19 of the FAR; and, for units of the Department of Defense, DoD
** Supplement to the FAR, clause 52.227-7013 (c)(1)(ii), Rights in
** Technical Data and Computer Software.
**
** Pixar
** 1001 West Cutting Blvd.
** Richmond, CA  94804
*/
/* Listing 16.34  Metal shader with optional environment map*/
surface
shiny(
    float    Ka        = .3,
             Ks        = .8,
             roughness = .05;
    string   mapname = "" )
{
    color ev;
    vector D;
    normal Nf = faceforward(normalize(N), I);
    vector NI = normalize(I);

    if( mapname != "" ) {
        /* compute the environment index direction, D */
        D = reflect(NI, Nf);
        /* convert D to environment space. */
        D = vtransform("world", D);
        ev = color environment(mapname, D);
    } else
        ev = 0;

    Oi = Os;
    Ci = Oi * (Ka * ambient() +
        Ks * (ev + specular(Nf, -NI, roughness)));
}
