/* $Id: //depot/branches/rmanprod/rat-6.0/ratdocs/education/RenderMan_Companion/tutorial/ch16/shaders/show_xyz.sl#1 $  (Pixar - RenderMan Division)  $Date: 2004/01/13 $ */
/*
** Copyright (c) 1998 PIXAR.  All rights reserved.  This program or
** documentation contains proprietary confidential information and trade
** secrets of PIXAR.  Reverse engineering of object code is prohibited.
** Use of copyright notice is precautionary and does not imply publication.
**
**                      RESTRICTED RIGHTS NOTICE
**
** Use, duplication, or disclosure by the Government is subject to the
** following restrictions:  For civilian agencies, subparagraphs (a) through
** (d) of the Commercial Computer Software--Restricted Rights clause at
** 52.227-19 of the FAR; and, for units of the Department of Defense, DoD
** Supplement to the FAR, clause 52.227-7013 (c)(1)(ii), Rights in
** Technical Data and Computer Software.
**
** Pixar
** 1001 West Cutting Blvd.
** Richmond, CA  94804
*/
/* Listing 16.13  Shader mapping shader-space coordinates to colors*/
/* 
 * show_xyz(): Color a surface point according to its xyz coordinates 
 * 	within a bounding box.
 */

surface 
show_xyz( 
	float	xmin	= -1, 
		ymin	= -1, 
		zmin	= -1,
 		xmax	=  1, 
		ymax	=  1,
		zmax	=  1 )
{
	uniform point scale, zero;
	point objP;
	vector cubeP;

	/* Check for zero scale components. */
	if(xmax==xmin || ymax==ymin || zmax==zmin) {
		print( "bad bounding box %f %f %f %f %f %f in show_xyz()",
				xmin, xmax, ymin, ymax, zmin, zmax );
	} else {
		scale = point (1/(xmax-xmin), 1/(ymax-ymin), 1/(zmax-zmin));
		zero = point (xmin, ymin, zmin);

		objP = transform("shader", P);
		cubeP = (objP - zero) * scale;
		Ci = color (xcomp(cubeP), ycomp(cubeP), zcomp(cubeP));
	}
}
