/*
** Copyright (c) 2000 PIXAR.  All rights reserved.  This program or
** documentation contains proprietary confidential information and trade
** secrets of PIXAR.  Reverse engineering of object code is prohibited.
** Use of copyright notice is precautionary and does not imply
** publication.
**
**                      RESTRICTED RIGHTS NOTICE
**
** Use, duplication, or disclosure by the Government is subject to the
** following restrictions:  For civilian agencies, subparagraphs (a) through
** (d) of the Commercial Computer Software--Restricted Rights clause at
** 52.227-19 of the FAR; and, for units of the Department of Defense, DoD
** Supplement to the FAR, clause 52.227-7013 (c)(1)(ii), Rights in
** Technical Data and Computer Software.
**
** Pixar
** 1001 West Cutting Blvd.
** Richmond, CA  94804
**
** ----------------------------------------------------------------------------
*/
/* code generated by slim 1.1b2, RAT 4.1b2 (May 20 2000 02:01:34) */
/* for dsisson@glaw.rainsound.com at: Mon May 22 12:06:30 PDT 2000 */
surface tableWood2_0 (
  string SurfacePoint_Space="";
  varying point __Pref=point(-1e10,-1e10,-1e10);
  color tableWood2_0_SurfaceColor=color(0.278431372549,0.171606214804,0.134302191465);
  float tableWood2_0_Ks=0.25;
  float tableWood2_0_Roughness=0.15;
  )
{
/* begin referenced functions ----------------------*/

	   void pxslFloatToColor(float fa; color ca; output color c;)
	   {
	       c = ca * color(fa,fa,fa);
	   }
       

		void
		pxslProjection( uniform float projection;
		    	    	uniform float imgcorrection;
				uniform float angle;
				uniform float repeatS; uniform float repeatT;
				uniform float offsetS; uniform float offsetT;
				point Qin;
				vector dQuin;
				vector dQvin;
				output point Q;
				output vector dQu;
				output vector dQv;
			      )
		{
		    float x, y;
		    uniform float pi2 = radians(360), pi = radians(180);
		    
		    if (projection == 0) /* planarx */
		    {
			Q = point (zcomp(Qin), ycomp(Qin), 0);
			dQu = vector (zcomp(dQuin), ycomp(dQuin), 0);
			dQv = vector (zcomp(dQvin), ycomp(dQvin), 0);

		    	if (imgcorrection != 0)
			    Q = .5 - Q;
		    }
		    else
		    if (projection == 1)  /* planary */
		    {
			Q = point (xcomp(Qin), zcomp(Qin), 0);
			dQu = vector (xcomp(dQuin), zcomp(dQuin), 0);
			dQv = vector (xcomp(dQvin), zcomp(dQvin), 0);

		    	if (imgcorrection != 0)
			    Q = .5 - Q;
		    }
		    else
		    if (projection == 2) /* planarz */
		    {
			Q = Qin;
			dQu = dQuin;
			dQv = dQvin;

		    	if (imgcorrection != 0)
			    Q = .5 - Q;
		    }
		    else
		    if (projection == 3) /* planarz-persp */
		    {
		    	float zinv;

			zinv = 1 / max(1e-6, abs(zcomp(Qin)));
			if (zcomp(Qin) < 0) zinv = -zinv;

			Q = Qin*zinv;
			dQu = dQuin*zinv;
			dQv = dQvin*zinv;

		    	if (imgcorrection != 0)
			    Q = .5 - Q;
		    }
		    else
		    if (projection == 4) /* autoplanar */
		    { 
			vector N = -normalize( calculatenormal(Qin) );
			x = N.vector (0,0,1);	/* x = cos of rotation */
			if (x < -.9998) /* if near 180 degrees */
			{	
			    /* just use z planar */
			    Q = Qin;
			    dQu = dQuin;
			    dQv = dQvin;
			}
			else 
			{
			    /* otherwise, rotate */
			    point QQ;
			    N = N^vector (0,0,1);
			    y = length (N); /* y = sin of rotation */
			    N = normalize (N);	/* N = rotation vector */

			    Q = Qin*x + (vector(Qin).N)*N*(1-x) +
			    	 (N^vector(Qin))*y; /* rotate */
			    dQu = dQuin*x + (dQuin.N)*N*(1-x) +
			    	 (N^vector(dQuin))*y; /* rotate */
			    dQv = dQvin*x + (dQvin.N)*N*(1-x) +
			    	 (N^vector(dQvin))*y; /* rotate */
			}

			if (imgcorrection != 0)
			    Q = .5 - Q;
		    }
		    else
		    if (projection == 5) /* box */
		    { 
			float	flip;

			x = zcomp(Qin);
			y = ycomp(Qin); 
			if (abs (y) > abs (x))
			    x = y;

			y = xcomp(Qin);
			if (abs (y) > abs (x))
			    x = y;

			if (x == zcomp(Qin)) /* planar z */
			{
			    flip = (-x < 0 ? -1 : 1);

			    Q = point (flip*xcomp(Qin), -ycomp(Qin), 0);
			    dQu = point (flip*xcomp(dQuin), -ycomp(dQuin), 0);
			    dQv = point (flip*xcomp(dQvin), -ycomp(dQvin), 0);
			}
			else
			if (x == xcomp(Qin)) /* planar x */
			{
			    flip = (-x < 0 ? -1 : 1);

			    Q = point (flip*zcomp(Qin), -ycomp(Qin), 0);
			    dQu = vector (flip*zcomp(dQuin), -ycomp(dQuin), 0);
			    dQv = vector (flip*zcomp(dQvin), -ycomp(dQvin), 0);
			}
			else
			if (x == ycomp(Qin)) /* planar y */
			{
			    x = xcomp(Qin);
			    flip = (-x < 0 ? -1 : 1);

			    Q = point (xcomp(Qin), flip*zcomp(Qin), 0);
			    dQu = vector (xcomp(dQuin), flip*zcomp(dQuin), 0);
			    dQv = vector (xcomp(dQvin), flip*zcomp(dQvin), 0);
			}

			Q -= .5;
		    }
		    else
		    if (projection == 6) /* box spherical */
		    {
			point	QQ;
			float	flip;

			x = zcomp(Qin);
			y = ycomp(Qin);
			if (abs (y) > abs (x))
			    x = y;

			y = xcomp(Qin); 
			if (abs (y) > abs (x))
			    x = y;

			if (x == zcomp(Qin))
			{
			    flip = (-x < 0 ? -1 : 1);
			    QQ = point (flip*xcomp(Qin), ycomp(Qin), flip*zcomp(Qin));
			}
			else
			if (x == xcomp(Qin))
			{
			    flip = (x < 0 ? -1 : 1);
			    QQ = point (flip*zcomp(Qin), ycomp(Qin), -flip*xcomp(Qin));
			}
			else
			if (x == ycomp(Qin))
			{
			    flip = (x < 0 ? -1 : 1);
			    QQ = point (xcomp(Qin), flip*zcomp(Qin), -flip*ycomp(Qin));
			}

			Q = point (
			    .5 + atan(xcomp(QQ), -zcomp(QQ)) / pi2,
			    .5 - atan(ycomp(QQ), length(vector(xcomp(QQ), 0, zcomp(QQ)))) / pi,
			    0
			);

			varying vector	QN, X, Y;
			varying float	circum;

			QN = normalize (vector Qin);

			X = normalize (vector (zcomp(Qin), 0, xcomp(Qin)));
			circum = pi2 * length (vector (zcomp(Qin), 0, xcomp(Qin)));
			circum = max (circum, 1e-10);

			Y = normalize (QN^normalize (QN^vector(0,1,0)));

			dQu = vector (dQuin.X / circum, dQuin.Y / pi, 0);
			dQv = vector (dQvin.X / circum, dQvin.Y / pi, 0);
		    }
		    else
		    if (projection == 7) /* spherical */
		    {
			varying vector	QN, X, Y;
			varying float	circum;

			Q = point (
			    .5 + atan(xcomp(Qin), -zcomp(Qin)) / pi2,
			    .5 - atan(ycomp(Qin), length(vector(xcomp(Qin), 0, zcomp(Qin)))) / pi,
			    0
			);

			QN = normalize (vector Qin);

			X = normalize (vector (zcomp(Qin), 0, xcomp(Qin)));
			circum = pi2 * length (vector (zcomp(Qin), 0, xcomp(Qin)));
			circum = max (circum, 1e-10);

			Y = normalize (QN^normalize (QN^vector(0,1,0)));

			dQu = vector (dQuin.X / circum, dQuin.Y / pi, 0);
			dQv = vector (dQvin.X / circum, dQvin.Y / pi, 0);
		    }
		    else
		    if (projection == 8) /* cylindrical */
		    { 
			varying vector	X;

			Q = point (
			    .5 + atan(xcomp(Qin), -zcomp(Qin)) / pi2,
			    -ycomp(Qin) + .5,
			    0
			);

			X = normalize (vector (zcomp(Qin), 0, xcomp(Qin)));

			dQu = vector (dQuin.X / pi2, ycomp(dQuin), 0);
			dQv = vector (dQvin.X / pi2, ycomp(dQvin), 0);
		    }

		    /* ST futzing and guarantees z is always 0 */
		    Q *= point(repeatS, repeatT, 0);
		    Q += point (offsetS, offsetT, 0);
		    dQu *= vector(repeatS, repeatT, 0);
		    dQv *= vector(repeatS, repeatT, 0);

		    if(angle != 0) {
			Q = rotate(Q, radians(angle), point(0,0,0), point(0,0,1)); 
			dQu = rotate(dQu, radians(angle), point(0,0,0), point(0,0,1)); 
			dQv = rotate(dQv, radians(angle), point(0,0,0), point(0,0,1)); 
		    }
		}
	    

		void pxslSurfacePoint (
		    uniform string coordsys;
		    uniform float frequency;
		    uniform float ignorePref;
		    output point Q; 
		    output vector dQu;
		    output vector dQv;
		) 
		{
		    extern point P;
		    extern vector dPdu, dPdv;
		    extern point __Pref;
		    extern float du, dv;
		    uniform string sys;

		    if(coordsys == "")
		    	sys = "shader";
		    else
		    	sys = coordsys;

		    if (xcomp(__Pref) == -1e10 || ignorePref != 0)
		    {
		    	Q = transform (sys, frequency*P);
		    	dQu = vtransform (sys, dPdu*du*frequency);
		    	dQv = vtransform (sys, dPdv*dv*frequency);
		    }
		    else 
		    {
			Q = frequency * transform (sys, __Pref);
			dQu = vector Du(Q)*du;
		        dQv = vector Dv(Q)*dv;
		    }
		}
	    

#include "pxslRemap.h"
		void 
		pxslRemapF(float f; 
			float inputmin, inputmax;
			float outputmin, outputmax;
			float disablegain;
			float bias, gain;
			output float result; )
		{
		    result = clamp(f, inputmin, inputmax);
		    result = outputmin + (outputmax - outputmin) * 
		    	(result - inputmin) / (inputmax - inputmin);
		    if (disablegain == 0)
		    {
		    	result = pxslFloatBias(bias, result);
		    	result = pxslFloatGain(gain, result);
		    }
		}
	    

#include "noises.h"
      void
      pxslOakGrain (float ringfreq, ringunevenness, grainfreq;
		  float ringnoise, ringnoisefreq;
		  float trunkwobble, trunkwobblefreq;
		  float angularwobble, angularwobblefreq;
		  float ringy, grainy;
		  point Pshad;
		  vector dPshadU;
		  vector dPshadV;
		  output float result;)
      {
	  /* We shade based on Pshad, but we add several layers of warping: */
	  /* Some general warping of the domain */
	  float dPshad = length(dPshadU^dPshadV);
	  vector offset = vfBm(Pshad*ringnoisefreq,
	    	    	      dPshad*ringnoisefreq, 2, 4, 0.5);
	  point Pring = Pshad + ringnoise*offset;
	  /* The trunk isn't totally steady xy as you go up in z */
	  Pring += trunkwobble * 
        	     vsnoise(zcomp(Pshad)*trunkwobblefreq) * vector(1,1,0);

	  /* Calculate the radius from the center. */
	  float r2 = sqr(xcomp(Pring)) + sqr(ycomp(Pring));
	  float r = sqrt(r2) * ringfreq;
	  /* Add some noise around the trunk */
	  r += angularwobble * smoothstep(0,5,r)
		 * snoise (angularwobblefreq*(Pring)*vector(1,1,0.1));

	  /* Now add some noise so all rings are not equal width */
	  extern float du, dv;
	  float dr = filterwidth(r);
	  r += ringunevenness*filteredsnoise(r,dr);

	  float inring = smoothpulsetrain (.1, .55, .7, .95, 1, r);

	  point Pgrain = Pshad*grainfreq*vector(1,1,.05);
	  float dPgrain = filterwidthp(Pgrain);
	  float grain = 0;
	  float i, amp=1;
	  for (i = 0;  i < 2;  i += 1) {
	      float grain1valid = 1-smoothstep(.2,.6,dPgrain);
	      if (grain1valid > 0) {
		  float g = grain1valid * snoise (Pgrain);
		  g *= (0.3 + 0.7*inring);
		  g = pow(clamp(0.8 - (g),0,1),2);
		  g = grainy * smoothstep (0.5, 1, g);
		  if (i == 0)
		      inring *= (1-0.4*grain1valid);
		  grain = max (grain, g);
	      }
	      Pgrain *= 2;
	      dPgrain *= 2;
	      amp *= 0.5;
	  }
	  result = mix (inring*ringy, 1, grain);
      }
    

	   void
	   pxslPlastic(color SurfaceColor;
		   color SurfaceOpacity;
		   float Ka;
		   float Kd;
		   float Ks;
		   float Roughness;
		   color SpecularColor;
		   output color CI;
		   output color OI;
		   )
	   {
	       normal Nf;
	       vector V;
	       extern normal N;
	       extern vector I;
	       Nf = faceforward( normalize(N), I );
	       V = -normalize(I);
	       OI = SurfaceOpacity;
	       CI = SurfaceOpacity * 
		       (SurfaceColor *
		    	   (Ka*ambient() + Kd*diffuse(Nf)) +
			   SpecularColor * Ks * specular(Nf,V,Roughness));
	   }
       
/* end referenced functions ------------------------*/
  point tmp0;
  vector tmp1;
  vector tmp2;
  pxslSurfacePoint ( /* SurfacePoint */
    SurfacePoint_Space,
    1 /* Frequency */,
    0 /* IgnorePref */,
    tmp0,
    tmp1,
    tmp2
    );
  point tmp3;
  vector tmp4;
  vector tmp5;
  pxslProjection ( /* Projection_0 */
    8 /* Projection */,
    1 /* Planar for Textures */,
    0 /* Angle */,
    1 /* S Repeats */,
    1 /* T Repeats */,
    0 /* S Offset */,
    0 /* T Offset */,
    tmp0,
    tmp1,
    tmp2,
    tmp3,
    tmp4,
    tmp5
    );
  float tmp6;
  pxslOakGrain ( /* OakGrain_Wood_Wood2 */
    20.00 /* ringfreq */,
    .5 /* rignunevenness */,
    25 /* grainfreq */,
    0.08 /* ringnoise */,
    1 /* ringnoisefreq */,
    4.00 /* trunkwobble */,
    .025 /* trunkwobblefreq */,
    1 /* angularwobble */,
    1.5 /* angularwobblefreq */,
    0.80 /* ringy */,
    0.80 /* grainy */,
    tmp3,
    tmp4,
    tmp5,
    tmp6
    );
  color tmp7;
  pxslFloatToColor ( /* FloatToColor_wood_Wood2 */
    tmp6,
    color(1,1,1) /* Coloration */,
    tmp7
    );
  float tmp8;
  pxslRemapF ( /* Remap_Wood_Wood2 */
    tmp6,
    0 /* inputmin */,
    1 /* inputmax */,
    0.60 /* outputmin */,
    1 /* outputmax */,
    0 /* Disable Bias/Gain */,
    .5 /* Bias */,
    .5 /* Gain */,
    tmp8
    );
  color tmp9;
  color tmp10;
  pxslPlastic ( /* tableWood2_0 */
    tableWood2_0_SurfaceColor,
    color(1,1,1) /* Opacity */,
    tmp6,
    tmp8,
    tableWood2_0_Ks,
    tableWood2_0_Roughness,
    tmp7,
    tmp9,
    tmp10
    );
  Ci = tmp9;
  Oi = tmp10;
}

