slim 1 appearance slim {
  function shadingmodel "Blinn_0" "pixar,Blinn#1" {
    identity 1000_rN0L8410000
    templatehints shadingmodels.slim 
    description {Mimics the Maya Blinn shader.}
    master {$::torShaders/$::INSTANCENAME}
    mastermtime 1108672852
    previewinfo {
      shadingrate 5
      objectsize 1
      objectshape Sphere
      frame 1
    }
    parameter color SurfaceColor {
      default {0 .25 1}
      provider constant
      detail varying {}
      label {Surface Color}
    }
    parameter color SurfaceOpacity {
      default {1 1 1}
      provider constant
      detail varying {}
      label Opacity
    }
    parameter color ambientColor {
      default {1 1 1}
      provider constant
      detail varying {}
      label {Ambient Color}
      description {The color of the surface as seen by ambient lights with a directional component.}
    }
    parameter color Incandescence {
      default {0 0 0}
      provider constant
      detail varying {}
      description {The color of light emitted from the surface. Note that this is just used to compute the surface itself; this has no effect on other objects in the scene.}
    }
    parameter float diffuseCoeff {
      default .8
      range {0 1}
      provider constant
      subtype slider
      detail varying {}
      label {Diffuse Coefficient}
      description {Controls the flat shading. This is the lambertian or non-specular contribution to the shading of the surface.}
    }
    parameter float translucenceCoeff {
      default 0
      range {0 1}
      provider constant
      subtype slider
      detail varying {}
      label {Translucence Coefficient}
      description {The degree to which light from front or back is scattered at this surface.}
    }
    parameter color SpecularColor {
      default {1 1 1}
      provider constant
      detail varying {}
      label {Specular Color}
      description {Filters light coming from the specular direction}
    }
    parameter float eccentricity {
      default .5
      range {0 .999}
      provider constant
      subtype slider
      detail varying {}
      label Eccentricity
      description {Controls the spread of the specular highlight}
    }
    parameter float specularRollOff {
      default .1
      range {0 1}
      provider constant
      subtype slider
      detail varying {}
      label {Specular Rolloff}
      description {Controls the intensity profile of the specular highlight. Note that this also has an affect on reflection light.}
    }
    parameter float reflectivity {
      default 1
      range {0 1}
      provider constant
      subtype slider
      detail varying {}
      label Reflectivity
      description {Controls the intensity of reflected light. Note that the Specular Rolloff parameter affects the reflectivity of the surface as well. Typically surfaces are more reflective s the reflection angle increases.}
    }
    collection shadingmodel {shadingmodel} {
      drawmode all
      provider constant
      access output
      display hidden
      parameter color CI {
        default {1 1 .25}
        provider constant
        detail varying {}
        access output
      }
      parameter color OI {
        default {1 1 1}
        provider constant
        detail varying {}
        access output
      }
    }
  }
}

