/*
** Copyright (c) 2000 PIXAR.  All rights reserved.  This program or
** documentation contains proprietary confidential information and trade
** secrets of PIXAR.  Reverse engineering of object code is prohibited.
** Use of copyright notice is precautionary and does not imply
** publication.
**
**                      RESTRICTED RIGHTS NOTICE
**
** Use, duplication, or disclosure by the Government is subject to the
** following restrictions:  For civilian agencies, subparagraphs (a) through
** (d) of the Commercial Computer Software--Restricted Rights clause at
** 52.227-19 of the FAR; and, for units of the Department of Defense, DoD
** Supplement to the FAR, clause 52.227-7013 (c)(1)(ii), Rights in
** Technical Data and Computer Software.
**
** Pixar
** 1001 West Cutting Blvd.
** Richmond, CA  94804
**
** ----------------------------------------------------------------------------
*/
/* code generated by slim 1.1b0, RAT 4.1b0 (Apr 21 2000 13:02:16) */
/* for dsisson@glaw.rainsound.com at: Fri Apr 21 16:32:31 PDT 2000 */
displacement tile_bump_0 (
  float TileST_repeatS=10.000;
  float TileST_repeatT=10.000;
  )
{
/* begin referenced functions ----------------------*/

		void
		pxslShapes (
		    float	shape;
		    float	fuzziness;
		    float	invert; 
		    point	Q;
		    vector	duQ;
		    vector	dvQ;
		    output float	result;
		)
		{
		    uniform float	size = .45;

		    if(shape == 1) /* star */
		    {
			varying float	x, y;

			/* from peachey */
			uniform float starangle = 2*PI / 5;
			uniform float rmin = .14;
			uniform float rmax = .4;
			uniform point p0 = rmax * (cos(0), sin(0), 0);
			uniform point p1 = rmin * 
			    (cos(starangle/2), sin(starangle/2), 0);
			uniform vector	d0 = p1 - p0;
			vector d1;
			float r, a, angle;

			varying point	Qr;

			angle = 2*PI/5*zcomp(Q);
			Qr = rotate (Q-.5, angle, point(0,0,0), point(0,0,1));
			x = xcomp(Qr);
			y = ycomp(Qr);

			angle = atan(x, y) + PI;
			r = sqrt(x*x + y*y);
			a = mod(angle, starangle) / starangle;
			if( a >= .5 )
			    a = 1 - a;

			d1 = r * (cos(a), sin(a), 0) - p0;

			result = (1 - filterstep(rmax, r,
				"width", 1+4*fuzziness, "filter", "gaussian")) *
				 filterstep (0, zcomp(d0^d1), 
			    	"width", 1+4*fuzziness, "filter", "gaussian");
		    }
		    else
		    if(shape == 2) /* circle */
		    {
			varying float	x, y;
			varying float	r, dr;

			x = xcomp(Q)-.5;
			y = ycomp(Q)-.5;
			r = sqrt(x*x + y*y);
			
			x = xcomp(duQ) + xcomp(dvQ);
			y = ycomp(duQ) + ycomp(dvQ);
			dr = max (.5*fuzziness, sqrt (x*x + y*y));

			result = 1 - filterstep (size, r, r+dr);
		    }
		    else
		    if(shape == 3) /* square */
		    {
			varying float	x, y;
			varying float	dx, dy;

			x = xcomp(Q)-.5;
			y = ycomp(Q)-.5;
			dx = max (.5*fuzziness, abs(xcomp(duQ)) +
			    	 abs(xcomp(dvQ)));
			dy = max (.5*fuzziness, abs(ycomp(duQ)) +
			    	 abs(ycomp(dvQ)));

			result = filterstep (-size, x, x+dx) - 
			    	filterstep (size, x, x+dx);
			result *= filterstep (-size, y, y+dy) - 
			    	filterstep (size, y, y+dy);
		    }
		    else
		    if(shape == 4) /* diamond */
		    {
			uniform float	w = size / sqrt(2.0);
			varying float	angle = radians(45) + PI/2*zcomp(Q);

			varying point	Qr;
			varying vector	duQr, dvQr;
			varying float	x, y;
			varying float	dx, dy;

			Qr = rotate (Q-.5, angle, point(0,0,0), point(0,0,1)); 
			duQr = rotate (duQ, angle, point(0,0,0), point(0,0,1)); 
			dvQr = rotate (dvQ, angle, point(0,0,0), point(0,0,1)); 

			x = xcomp(Qr);
			y = ycomp(Qr);
			dx = max (.5*fuzziness, abs(xcomp(duQr)) +
			    	 abs(xcomp(dvQr)));
			dy = max (.5*fuzziness, abs(ycomp(duQr)) +
			    	 abs(ycomp(dvQr)));

			result = filterstep (-w, x, x+dx) - 
			    	filterstep (w, x, x+dx);
			result *= filterstep (-w, y, y+dy) - 
			    	filterstep (w, y, y+dy);
		    }
		    else
		    if(shape == 5) /* checker-like thingy */
		    {
			varying float	x, y;
			varying float	dx, dy;

			x = mod (xcomp(Q)-.5, 1);
			y = mod (ycomp(Q)-.5, 1);
			dx = max (.5*fuzziness, abs(xcomp(duQ)) +
			    	     abs(xcomp(dvQ)));
			dy = max (.5*fuzziness, abs(ycomp(duQ)) +
			    	 abs(ycomp(dvQ)));

			x = filterstep(.5, x, x+dx);
			y = filterstep(.5, y, y+dy);
			result = mix (x, (1-x), y);
		    }
		    else
		    if(shape == 6) /* x ramp */
		    {
			varying float	x, dx;

			x = xcomp(Q)-.5;
			dx = max (.5*fuzziness, abs(xcomp(duQ)) +
			    	 abs(xcomp(dvQ)));

			result = mix (x+1, x, filterstep (0, x, x+dx));
		    }
		    else
		    if(shape == 7) /* y ramp */
		    {
			varying float	y, dy;

			y = ycomp(Q)-.5;
			dy = max (.5*fuzziness, abs(ycomp(duQ)) +
			    	 abs(ycomp(dvQ)));

			result = mix (y+1, y, filterstep (0, y, y+dy));
		    }
		    else
		    if(shape == 8) /* xy ramp */
		    {
			varying float	x, y;
			varying float	dx, dy;

			x = xcomp(Q)-.5;
			y = ycomp(Q)-.5;
			dx = max (.5*fuzziness, abs(xcomp(duQ)) +
			    	 abs(xcomp(dvQ)));
			dy = max (.5*fuzziness, abs(ycomp(duQ)) +
			    	 abs(ycomp(dvQ)));

			result = mix (x+1, x, filterstep (0, x, x+dx));
			result += mix (y+1, y, filterstep (0, y, y+dy));
			result *= .5;
		    }
		    else
		    if(shape == 9) /* squiggles */
		    {
			varying float	x, y;
			varying float	r, dr;

			x = xcomp(duQ) + xcomp(dvQ);
			y = ycomp(duQ) + ycomp(dvQ);
			dr = max (.5*fuzziness, sqrt (x*x + y*y));

			if (zcomp(Q) < .5)
			    x = 1-xcomp(Q);
			else
			    x = xcomp(Q);

			x = x;
			y = ycomp(Q);

			r = sqrt(x*x + y*y);
			result = filterstep (.4, r, r+dr) - 
			    	    filterstep (.6, r, r+dr);

			x = 1-x;
			y = 1-y;

			r = sqrt(x*x + y*y);
			result = max (result, filterstep (.4, r, r+dr) -
			    	     filterstep (.6, r, r+dr));
		    }

		    if (invert != 0)
			result = 1 - result;    
		}
	    

		void pxslST (
			  uniform float angle;
			  uniform float repeatS; uniform float repeatT;
			  uniform float offsetS; uniform float offsetT;
			  output point Q;
			  output vector dQu;
			  output vector dQv;
			  )
		{
		    extern float s, t, du, dv;

		    setxcomp(Q, repeatS * s + offsetS);
		    setycomp(Q, repeatT * t + offsetT);
		    setzcomp(Q, 0);

		    if(angle != 0)
			Q = rotate(Q, radians(angle), 
			    	    point(0,0,0), point(0,0,1)); 

		    dQu = vector Du(Q)*du;
		    dQv = vector Dv(Q)*dv;
		}
	    

		void
		pxslTile (
		    uniform point frequency; 
		    uniform float tilesize;
		    uniform float jitter; 
		    uniform float rowoffset;
		    uniform float randomz;
		    point Qin;
		    vector dQuin;
		    vector dQvin;
		    output point Q;
		    output vector dQu;
		    output vector dQv;
		)
		{
		    float x, y, xOffset = 0;
		    point jitterPt;
		    
		    dQu = dQuin * frequency * tilesize;
		    dQv = dQvin * frequency * tilesize;

		    Q = Qin * frequency;
		    x = xcomp(Q);
		    y = ycomp(Q);

		    if ((rowoffset != 0) && (abs (mod (y, 2)) < 1))
			    x += .5;

		    jitterPt = point (x, y, 0);

		    x = mod (x, 1);
		    y = mod (y, 1);
		    Q = tilesize*(point (x, y, .5) - vector .5) + vector .5;

		    Q += jitter*(tilesize-1) * 
		    	    (vector .5 - vector cellnoise (jitterPt));

		    if (randomz != 0)
			setzcomp (Q, float cellnoise (jitterPt));
		    else
			setzcomp (Q, 0);
		}
	    
/* end referenced functions ------------------------*/
  normal Nf;
  point PP = transform("shader", P);
  point tmp0;
  vector tmp1;
  vector tmp2;
  pxslST ( /* TileST */
    0 /* Angle */,
    TileST_repeatS,
    TileST_repeatT,
    0 /* S Offset */,
    0 /* T Offset */,
    tmp0,
    tmp1,
    tmp2
    );
  point tmp3;
  vector tmp4;
  vector tmp5;
  pxslTile ( /* Tile_Tile */
    point(3.00,3.00,3.00) /* Frequency */,
    1 /* Tile Size */,
    0 /* Jitter */,
    0 /* Row Offset */,
    0 /* Random Z */,
    tmp0,
    tmp1,
    tmp2,
    tmp3,
    tmp4,
    tmp5
    );
  point tmp6;
  vector tmp7;
  vector tmp8;
  pxslTile ( /* Tile_Bump_Tile */
    point(1.00,1.00,1.00) /* Frequency */,
    1.03 /* Tile Size */,
    0.08 /* Jitter */,
    0 /* Row Offset */,
    0 /* Random Z */,
    tmp3,
    tmp4,
    tmp5,
    tmp6,
    tmp7,
    tmp8
    );
  float tmp9;
  pxslShapes ( /* TileShapes */
    3 /* Shape */,
    0.28 /* Fuzziness */,
    0 /* Invert */,
    tmp6,
    tmp7,
    tmp8,
    tmp9
    );
  Nf = normalize( ntransform("shader", N) );
  PP += 0.100 * tmp9*Nf;
  PP = transform("shader", "current", PP);
  if(0 != 0) { 
      normal deltaN = normalize(N) - normalize(Ng);
      N = normalize(calculatenormal(PP)) + deltaN;
  } else {
      N = calculatenormal(PP);
  }
  if(0 != 0)
      P = PP;
}

