/* $Id: //depot/branches/rmanprod/rat-6.0/ratdocs/education/RenderMan_Companion/tutorial/ch16/shaders/txtplastic.sl#1 $  (Pixar - RenderMan Division)  $Date: 2004/01/13 $ */
/*
** Copyright (c) 1998 PIXAR.  All rights reserved.  This program or
** documentation contains proprietary confidential information and trade
** secrets of PIXAR.  Reverse engineering of object code is prohibited.
** Use of copyright notice is precautionary and does not imply publication.
**
**                      RESTRICTED RIGHTS NOTICE
**
** Use, duplication, or disclosure by the Government is subject to the
** following restrictions:  For civilian agencies, subparagraphs (a) through
** (d) of the Commercial Computer Software--Restricted Rights clause at
** 52.227-19 of the FAR; and, for units of the Department of Defense, DoD
** Supplement to the FAR, clause 52.227-7013 (c)(1)(ii), Rights in
** Technical Data and Computer Software.
**
** Pixar
** 1001 West Cutting Blvd.
** Richmond, CA  94804
*/
/* Listing 16.29  Plastic surface shader using a texture map*/
/*
 *  txtplastic(): version of plastic() shader using an optional texture map
 */
surface
txtplastic(
	float	Ks		= .5,
		Kd		= .5,
		Ka		=  1,
		roughness	= .1;
	color 	specularcolor = 1;
	string	mapname = "")
{
	normal	Nf = faceforward( normalize(N), I );
	vector V = normalize(-I);

	if( mapname != "" )
		Ci = color texture( mapname );						/* Use s and t */
	else
		Ci = Cs;
	Oi = Os;
	Ci = Os * ( Ci * (Ka*ambient() + Kd*diffuse(Nf))
	 	+ specularcolor * Ks * specular(Nf, V, roughness) );
}

