#include "hyperManSL.h"
#include "hyperManFuncs.h"
#include "./RenderManSL/shaders/material.h"
#include "hyperMan_Outputs.h"

surface hyperAnisotropic
(
string ColorMap = "";
	float UseColorMap = 0;
	float ColorMapBlur = 1;
	float ColorMapPlacement = 0;

string TransparencyMap = "";
	float UseTransparencyMap = 0;
	float TransparencyMapBlur = 1;
	color DefaultTransparency = 0;
	float TransparencyMapPlacement = 0;
	
string AmbientColorMap = "";
	float UseAmbientColorMap = 0;
	float AmbientColorMapBlur = 1;
	color DefaultAmbientColor = 0;
	float AmbientColorMapPlacement = 0;

string IncandescenceMap = "";
	float UseIncandescenceMap = 0;
	float IncandescenceMapBlur = 1;
	color DefaultIncandescence = 0;
	float IncandescenceMapPlacement = 0;	
	
string BumpMap = "";
	float UseBumpMap = 0;	
	float BumpMapBlur = 1;
	float DefaultBump = 1;
	float DoDisplacement = 0;
    float BumpMag = 0.0;
	float BumpMapPlacement = 0;	
	
string DiffuseMap = "";
	float UseDiffuseMap = 0;
	float DiffuseMapBlur = 1;
	float DefaultDiffuse = 0.8;
	float DiffuseMapPlacement = 0; 
	
string TranslucenceMap = "";
	float UseTranslucenceMap = 0;
	float TranslucenceMapBlur = 1;
	float DefaultTranslucence = 0;
	float TranslucenceMapPlacement = 0; 
	
string TranslucenceDepthMap = "";
	float UseTranslucenceDepthMap = 0;
	float TranslucenceDepthMapBlur = 1;
	float DefaultTranslucenceDepth = 0.5;
	float TranslucenceDepthMapPlacement = 0; 
	
string TranslucenceFocusMap = "";
	float UseTranslucenceFocusMap = 0;
	float TranslucenceFocusMapBlur = 1;
	float DefaultTranslucenceFocus = 0.5;
	float TranslucenceFocusMapPlacement = 0; 
	
string GlowintensityMap = "";
	float UseGlowintensityMap = 0;
	float GlowintensityMapBlur = 1;
	float DefaultGlowintensity = 0;
	float GlowintensityMapPlacement = 0; 
	
string MatteOpacityMode = "";
string MatteOpacityMap = "";
	float UseMatteOpacityMap = 0;
	float MatteOpacityMapBlur = 1;
	float DefaultMatteOpacity = 1;
	float MatteOpacityMapPlacement = 0; 
		
string FresnelIndexMap = ""; 
	float UseFresnelIndexMap = 0;
	float FresnelIndexMapBlur = 1;
	float DefaultFresnelIndex = 6;
	float FresnelIndexMapPlacement = 0; 
	
string AngleMap = ""; 
	float UseAngleMap = 0;
	float AngleMapBlur = 1;
	float DefaultAngle = 0;
	float AngleMapPlacement = 0; 
	
string SpreadXMap = ""; 
	float UseSpreadXMap = 0;
	float SpreadXMapBlur = 1;
	float DefaultSpreadX = 13;
	float SpreadXMapPlacement = 0; 
	
string SpreadYMap = ""; 
	float UseSpreadYMap = 0;
	float SpreadYMapBlur = 1;
	float DefaultSpreadY = 3;
	float SpreadYMapPlacement = 0; 
	
string RoughnessMap = ""; 
	float UseRoughnessMap = 0;
	float RoughnessMapBlur = 1;
	float DefaultRoughness = 0.7;
	float RoughnessMapPlacement = 0; 
	
string SpecularColorMap = ""; 
	float UseSpecularColorMap = 0;
	float SpecularColorMapBlur = 1;
	color DefaultSpecularColor = 0.5;
	float SpecularColorMapPlacement = 0; 

string ReflectivityMap = ""; 
	float UseReflectivityMap = 0;
	float ReflectivityMapBlur = 1;
	float DefaultReflectivity = 0.5;
	float ReflectivityMapPlacement = 0; 
	
string ReflectedColorMap = ""; 
	float UseReflectedColorMap = 0;
	float ReflectedColorMapBlur = 1;
	color DefaultReflectedColor = 0;
	float ReflectedColorMapPlacement = 0;
	
string occfilename = "";
	float occsamples = 0;
	float raymaxdist = 10;
	float cachemode = 0;
	float occflag = 0;
	float occpass = 0;
	
string irradfilename = "";
	float irradsamples = 0;
	float irradflag = 0;
	float irradpass = 0;
	
string ibifilename = "";
	string ibiImage = "";
	float ibisamples = 0;
	float ibiflag = 0;
	float ibipass = 0;
	
float cacheAnim = 0;
	
string RefMap = "";

ALLOUT;	
)
{
	normal Nf = faceforward( normalize(N), I );
	vector V = -normalize(I), dir = normalize(Du(P));
	point PP = 0;
	color surfC = 0, surfT = DefaultTransparency, incC = DefaultIncandescence, c=0;
	color Ia = 0, Id = 0, Itr = 0, Is = 0, Ir =0, Isr = 0;
	color ambC = DefaultAmbientColor;

	color reflcC = DefaultReflectedColor, speccC = DefaultSpecularColor; 
    float roughness = 0, diffC = DefaultTranslucenceDepth, transC = DefaultTranslucence, transDC = DefaultTranslucenceDepth; 
    float transFC = DefaultTranslucenceFocus, glowiC = DefaultGlowintensity, mattoC = DefaultMatteOpacity;
    float bmp = DefaultBump, roughN = DefaultRoughness;
    float angle = DefaultAngle, reflC = DefaultReflectivity, sprdX = DefaultSpreadX, sprdY = DefaultSpreadY, fresI = DefaultFresnelIndex;
    normal bumpVal = 0;

	if(cacheAnim != 1){
		
		point STMatrix0 = point "shader" (0,-1,1);
		point STMatrix1 = point "shader" (1,0,0);

		float ss = vector(s, t, 1) . vector(transform("shader", STMatrix0));
		float tt = vector(s, t, 1) . vector(transform("shader", STMatrix1));

		vector Rcurrent = reflect(I, Nf);
		vector Rworld = vtransform("world", Rcurrent);
		normal newNf = 0;
		newNf = doDisplace(BumpMap, UseBumpMap, BumpMapPlacement, BumpMapBlur, DefaultBump, DoDisplacement, ss, tt, Rworld, newNf);

	/*Common Material Attributes */
		surfC = doColor(ColorMap, UseColorMap, ColorMapPlacement, ColorMapBlur, ss, tt, Rworld, surfC);
		surfT = doTransparency(TransparencyMap, UseTransparencyMap, TransparencyMapPlacement, TransparencyMapBlur, ss, tt, Rworld, surfT);
		ambC = doAmbient(AmbientColorMap, UseAmbientColorMap, AmbientColorMapPlacement, AmbientColorMapBlur, ss, tt, Rworld, DefaultAmbientColor, ambC);
		incC = doIncandescence(IncandescenceMap, UseIncandescenceMap, IncandescenceMapPlacement, IncandescenceMapBlur, ss, tt, Rworld, DefaultIncandescence, incC);
		diffC = doDiffuse(DiffuseMap, UseDiffuseMap, DiffuseMapPlacement,	DiffuseMapBlur, DefaultDiffuse, ss, tt, Rworld, diffC);
		transC = doTranslucence(TranslucenceMap, UseTranslucenceMap, TranslucenceMapPlacement,	TranslucenceMapBlur, DefaultTranslucence, ss, tt, Rworld, transC);
		transDC = doTranslucenceDepth(TranslucenceDepthMap, UseTranslucenceDepthMap, TranslucenceDepthMapPlacement,	TranslucenceDepthMapBlur, DefaultTranslucenceDepth, ss, tt, Rworld, transDC);
		transFC = doTranslucenceFocus(TranslucenceFocusMap, UseTranslucenceFocusMap, TranslucenceFocusMapPlacement,	TranslucenceFocusMapBlur, DefaultTranslucenceFocus, ss, tt, Rworld, transFC);

	/*Special Effects*/	
		glowiC = doGlowintensity(GlowintensityMap, UseGlowintensityMap, GlowintensityMapPlacement,	GlowintensityMapBlur, DefaultGlowintensity, ss, tt, Rworld, glowiC);

	/*Matte Opacity*/	
		mattoC = doMatteOpacity(MatteOpacityMap, UseMatteOpacityMap, MatteOpacityMapPlacement,	MatteOpacityMapBlur, DefaultMatteOpacity, ss, tt, Rworld, mattoC);

	 /* Specular Shading */
		angle = doAngle(AngleMap, UseAngleMap, AngleMapPlacement, AngleMapBlur, DefaultAngle, ss, tt, Rworld, angle);
		sprdX = doSpreadX(SpreadXMap, UseSpreadXMap, SpreadXMapPlacement, SpreadXMapBlur, DefaultSpreadX, ss, tt, Rworld, sprdX);
		sprdY = doSpreadY(SpreadYMap, UseSpreadYMap, SpreadYMapPlacement, SpreadYMapBlur, DefaultSpreadY, ss, tt, Rworld, sprdY);
		fresI = doFresnelIndex(FresnelIndexMap, UseFresnelIndexMap, FresnelIndexMapPlacement, FresnelIndexMapBlur, DefaultFresnelIndex, ss, tt, Rworld, fresI);
		roughN = doRoughness(RoughnessMap, UseRoughnessMap, RoughnessMapPlacement, RoughnessMapBlur, DefaultRoughness, ss, tt, Rworld, roughN);
		speccC = doSpecularColor(SpecularColorMap, UseSpecularColorMap, SpecularColorMapPlacement, SpecularColorMapBlur, ss, tt, Rworld, DefaultSpecularColor, speccC);
		reflC = doReflectivity(ReflectivityMap, UseReflectivityMap, ReflectivityMapPlacement, ReflectivityMapBlur, DefaultReflectivity, ss, tt, Rworld, reflC);	
		reflcC =  doReflectedColor(ReflectedColorMap, UseReflectedColorMap, ReflectedColorMapPlacement, ReflectedColorMapBlur, ss, tt, Rworld, DefaultReflectedColor, reflcC);	

	/* Bump Mapping */
	color temp2 = 0;
		temp2 = doBump(BumpMap,UseBumpMap, BumpMapPlacement, BumpMapBlur, ss, tt, Rworld, speccC, temp2);


		vector R = reflect(normalize(I), bumpVal);	
		vector dirt = (-5,0,2);
		dirt = vtransform("camera", dirt);
		float ourX = xcomp(vector dirt);
		float ourY = ycomp(vector dirt);
		float ourZ = zcomp(vector dirt);
		float sp = comp(Is, 0);
		float am = comp(Ia, 0);
		float temp = 0;

		angle = (angle/ 2);
		float tempX = (ourX*(cos(angle))) - (ourY*(sin(angle))); 
		float tempY = (ourX*(sin(angle))) + (ourY*(cos(angle))); 
		float tempZ = ourZ;

		vector new = (abs(tempX), abs(tempY), abs(tempZ));

		color spec = MaterialBrushedMetal(bumpVal, Cs, 0.1, 1, 50, new, 0, 0);
		Ia = hyperManSLAmbient(bumpVal, ambC);
		Id = diffC * diffuse(normalize(bumpVal)); 
		Itr = hyperManSLTranslucence(bumpVal,transC,transFC, transDC);
		Is = spec * specular(bumpVal,V,roughness);
		Ir = reflC * Ir *reflcC * reflector(RefMap, Ir);
		Isr = (speccC+0.3) * ( Is + Ir  );   

		Oamb += Cs * Ia;
		Odiff += Cs * Id;
		Ospec += Cs * Is * (speccC+0.3);
		Oalpha = mattoC * surfT;
		Orefl = Ir;

		if(occflag == 1){
		Oocc = occsurf(occfilename, occsamples, raymaxdist, cachemode);}
		if(irradflag == 1){
		Oirrad = irradsurf(irradfilename, irradsamples, raymaxdist, cachemode);}
		if(ibiflag == 1){
		Oibi = ibisurf(ibifilename, ibiImage, ibisamples, raymaxdist, cachemode);}

		color raytrace = Oocc * Oirrad * Oibi;

		if((occflag == 1)||(irradflag == 1)||(ibiflag == 1)){
			Oi = surfT;
			Ci = surfT * surfC * raytrace * (Ia + Id + Itr + incC + Isr);}
		else {
			Oi = surfT;
			Ci = surfT * surfC * (Ia + Id + Itr + incC + Isr);}
	   	
	}
	else if(cacheAnim == 1){
			if(occflag == 1){
			Oocc = occsurf(occfilename, occsamples, raymaxdist, cachemode);}
			if(irradflag == 1){
			Oirrad = irradsurf(irradfilename, irradsamples, raymaxdist, cachemode);}
			if(ibiflag == 1){
			Oibi = ibisurf(ibifilename, ibiImage, ibisamples, raymaxdist, cachemode);}
	}
    
}

    