#include "hyperMan_Outputs.h"
#ifndef _H_hyperManFuncs
#define _H_hyperManFuncs

/* ---------------------------------- * ---------------------------------- *
hyperManFunc.h author  Avinash Sunnasy (c)

This file contains several functions which are used in the hyperMan system

* ---------------------------------- * ---------------------------------- */



/* Color & Opacity Calculations */
	color doColor(string ColorMap; float UseColorMap, ColorMapPlacement, ColorMapBlur, ss, tt; vector Rworld; output color surfC)
	{
		if((ColorMap != "")&&(UseColorMap == 1)&&(ColorMapPlacement == 2))
		{
			surfC = color texture(ColorMap, ss, tt,
								  "swidth", ColorMapBlur,
								  "twidth", ColorMapBlur );
		}
		else if((ColorMap != "")&&(UseColorMap == 1)&&(ColorMapPlacement == 3))
		{
			surfC = color environment(ColorMap, Rworld);
		}
		else if((ColorMapPlacement != 2) || (ColorMapPlacement != 3)&&(ColorMap == ""))
		{
			surfC = Cs;
		}
	return surfC;
	}

/* Transparency Calcualtions */
	color doTransparency(string TransparencyMap; float UseTransparencyMap, TransparencyMapPlacement,
	TransparencyMapMapBlur, ss, tt; vector Rworld; output color surfT)
	{
		if((TransparencyMap != "")&&(UseTransparencyMap != 0)&&(TransparencyMapPlacement == 2))
		{
			surfT = color texture(TransparencyMap, ss, tt,
								  "swidth", TransparencyMapMapBlur,
								  "twidth", TransparencyMapMapBlur );
		}
		else if((TransparencyMap != "")&&(UseTransparencyMap != 0)&&(TransparencyMapPlacement == 3))
		{
			surfT = color environment(TransparencyMap,  Rworld);
		}
		else if((TransparencyMapPlacement != 2) || (TransparencyMapPlacement != 3)&&(TransparencyMap == ""))
		{
			surfT = Os;
		}
	return surfT;
	}

/* Ambient Calculations */
	color doAmbient(string AmbientColorMap; uniform float UseAmbientColorMap, AmbientColorMapPlacement,
	AmbientColorMapBlur; varying float ss, tt; varying vector Rworld; color DefaultAmbientColor; output color ambC)
	{
		if((AmbientColorMap != "")&&(UseAmbientColorMap != 0)&&(AmbientColorMapPlacement == 2))
		{
			ambC = float texture(AmbientColorMap, ss, tt,
								"swidth", AmbientColorMapBlur,
								"twidth", AmbientColorMapBlur );
		}
		else if((AmbientColorMap != "")&&(UseAmbientColorMap != 0)&&(AmbientColorMapPlacement == 3))
		{
			ambC = float environment(AmbientColorMap,  Rworld);
		}
		else if((AmbientColorMapPlacement != 2) || (AmbientColorMapPlacement != 3)&&(AmbientColorMap == ""))
		{
			ambC = DefaultAmbientColor;
		}
	return ambC;
	}

/* Incandescence Calculations */
	color doIncandescence(string IncandescenceMap; uniform float UseIncandescenceMap, IncandescenceMapPlacement,
	IncandescenceMapBlur; varying float ss, tt; varying vector Rworld; color DefaultIncandescence; output color incC)
	{
		if((IncandescenceMap != "")&&(UseIncandescenceMap != 0)&&(IncandescenceMapPlacement == 2))
		{
			incC = float texture(IncandescenceMap, ss, tt,
								"swidth", IncandescenceMapBlur,
								"twidth", IncandescenceMapBlur );
		}
		else if((IncandescenceMap != "")&&(UseIncandescenceMap != 0)&&(IncandescenceMapPlacement == 3))
		{
			incC = float environment(IncandescenceMap,  Rworld);
		}
		else if((IncandescenceMapPlacement != 2) || (IncandescenceMapPlacement != 3)&&(IncandescenceMap == ""))
		{
			incC = DefaultIncandescence;
		}
	return incC;
	}

/* Bump Calculations */
	color doBump(string BumpMap; uniform float UseBumpMap, BumpMapPlacement,
	BumpMapBlur; varying float ss, tt; varying vector Rworld;varying color DefaultBump; output varying color incC)
	{
		if((BumpMap != "")&&(UseBumpMap != 0)&&(BumpMapPlacement == 2))
		{
			incC = float texture(BumpMap, ss, tt,
								"swidth", BumpMapBlur,
								"twidth", BumpMapBlur );
		}
		else if((BumpMap != "")&&(UseBumpMap != 0)&&(BumpMapPlacement == 3))
		{
			incC = float environment(BumpMap,  Rworld);
		}
		else if((BumpMapPlacement != 2) || (BumpMapPlacement != 3)&&(BumpMap == ""))
		{
			incC = DefaultBump;
		}
	return incC;
	}
/* Diffuse Calculations */
	float doDiffuse(string DiffuseMap; uniform float UseDiffuseMap, DiffuseMapPlacement,
	DiffuseMapBlur, DefaultDiffuse ;varying float ss, tt; varying vector Rworld; output float diffC)
	{
		if((DiffuseMap != "")&&(UseDiffuseMap != 0)&&(DiffuseMapPlacement == 2))
		{
			diffC = float texture(DiffuseMap, ss, tt,
								"swidth", DiffuseMapBlur,
								"twidth", DiffuseMapBlur );
		}
		else if((DiffuseMap != "")&&(UseDiffuseMap != 0)&&(DiffuseMapPlacement == 3))
		{
			diffC = float environment(DiffuseMap,  Rworld);
		}
		else if((DiffuseMapPlacement != 2) || (DiffuseMapPlacement != 3)&&(DiffuseMap == ""))
		{
			diffC = DefaultDiffuse;
		}
	return diffC;
	}

/* Translucence Calculations */
	float doTranslucence(string TranslucenceMap; uniform float UseTranslucenceMap, TranslucenceMapPlacement,
	TranslucenceMapBlur, DefaultTranslucence ;varying float ss, tt; varying vector Rworld; output float transC)
	{
		if((TranslucenceMap != "")&&(UseTranslucenceMap != 0)&&(TranslucenceMapPlacement == 2))
		{
			transC = float texture(TranslucenceMap, ss, tt,
								"swidth", TranslucenceMapBlur,
								"twidth", TranslucenceMapBlur );
		}
		else if((TranslucenceMap != "")&&(UseTranslucenceMap != 0)&&(TranslucenceMapPlacement == 3))
		{
			transC = float environment(TranslucenceMap,  Rworld);
		}
		else if((TranslucenceMapPlacement != 2) || (TranslucenceMapPlacement != 3)&&(TranslucenceMap == ""))
		{
			transC = DefaultTranslucence;
		}
	return transC;
	}

/* TranslucenceDepth Calculations */
	float doTranslucenceDepth(string TranslucenceDepthMap; uniform float UseTranslucenceDepthMap,
	TranslucenceDepthMapBlur, DefaultTranslucenceDepth, TranslucenceDepthMapPlacement ;varying float ss, tt; varying vector Rworld; output float transDC)
	{
		if((TranslucenceDepthMap != "")&&(UseTranslucenceDepthMap != 0)&&(TranslucenceDepthMapPlacement == 2))
		{
			transDC = float texture(TranslucenceDepthMap, ss, tt,
								"swidth", TranslucenceDepthMapBlur,
								"twidth", TranslucenceDepthMapBlur );
		}
		else if((TranslucenceDepthMap != "")&&(UseTranslucenceDepthMap != 0)&&(TranslucenceDepthMapPlacement == 3))
		{
			transDC = float environment(TranslucenceDepthMap,  Rworld);
		}
		else if((TranslucenceDepthMapPlacement != 2) || (TranslucenceDepthMapPlacement != 3)&&(TranslucenceDepthMap == ""))
		{
			transDC = DefaultTranslucenceDepth;
		}
	return transDC;
	}

/* TranslucenceFocus Calculations */



	float doTranslucenceFocus(string TranslucenceFocusMap; uniform float UseTranslucenceFocusMap, TranslucenceFocusMapPlacement,
	TranslucenceFocusMapBlur, DefaultTranslucenceFocus ;varying float ss, tt; varying vector Rworld; output float transFC)
	{
		if((TranslucenceFocusMap != "")&&(UseTranslucenceFocusMap != 0)&&(TranslucenceFocusMapPlacement == 2))
		{
			transFC = float texture(TranslucenceFocusMap, ss, tt,
								"swidth", TranslucenceFocusMapBlur,
								"twidth", TranslucenceFocusMapBlur );
		}
		else if((TranslucenceFocusMap != "")&&(UseTranslucenceFocusMap != 0)&&(TranslucenceFocusMapPlacement == 3))
		{
			transFC = float environment(TranslucenceFocusMap,  Rworld);
		}
		else if((TranslucenceFocusMapPlacement != 2) || (TranslucenceFocusMapPlacement != 3)&&(TranslucenceFocusMap == ""))
		{
			transFC = DefaultTranslucenceFocus;
		}
	return transFC;
	}




/* Glowintensity Calculations */
	float doGlowintensity(string GlowintensityMap; uniform float UseGlowintensityMap, GlowintensityMapPlacement,
	GlowintensityMapBlur, DefaultGlowintensity ;varying float ss, tt; varying vector Rworld; output float glowiC)
	{
		if((GlowintensityMap != "")&&(UseGlowintensityMap != 0)&&(GlowintensityMapPlacement == 2))
		{
			glowiC = float texture(GlowintensityMap, ss, tt,
								"swidth", GlowintensityMapBlur,
								"twidth", GlowintensityMapBlur );
		}
		else if((GlowintensityMap != "")&&(UseGlowintensityMap != 0)&&(GlowintensityMapPlacement == 3))
		{
			glowiC = float environment(GlowintensityMap,  Rworld);
		}
		else if((GlowintensityMapPlacement != 2) || (GlowintensityMapPlacement != 3)&&(GlowintensityMap == ""))
		{
			glowiC = DefaultGlowintensity;
		}
	return glowiC;
	}

/* MatteOpacity Calculations */
	float doMatteOpacity(string MatteOpacityMap; uniform float UseMatteOpacityMap, MatteOpacityMapPlacement,
	MatteOpacityMapBlur, DefaultMatteOpacity ;varying float ss, tt; varying vector Rworld; output float mattoC)
	{
		if((MatteOpacityMap != "")&&(UseMatteOpacityMap != 0)&&(MatteOpacityMapPlacement == 2))
		{
			mattoC = float texture(MatteOpacityMap, ss, tt,
								"swidth", MatteOpacityMapBlur,
								"twidth", MatteOpacityMapBlur );
		}
		else if((MatteOpacityMap != "")&&(UseMatteOpacityMap != 0)&&(MatteOpacityMapPlacement == 3))
		{
			mattoC = float environment(MatteOpacityMap,  Rworld);
		}
		else if((MatteOpacityMapPlacement != 2) || (MatteOpacityMapPlacement != 3)&&(MatteOpacityMap == ""))
		{
			mattoC = DefaultMatteOpacity;
		}
	return mattoC;
	}



/* refractiveIndex Calculations */
	float dorefractiveIndex(string refractiveIndexMap; uniform float UserefractiveIndexMap, refractiveIndexMapPlacement,
	refractiveIndexMapBlur, DefaultrefractiveIndex ;varying float ss, tt; varying vector Rworld; output float refriC)
	{
		if((refractiveIndexMap != "")&&(UserefractiveIndexMap != 0)&&(refractiveIndexMapPlacement == 2))
		{
			refriC = float texture(refractiveIndexMap, ss, tt,
								"swidth", refractiveIndexMapBlur,
								"twidth", refractiveIndexMapBlur );
		}
		else if((refractiveIndexMap != "")&&(UserefractiveIndexMap != 0)&&(refractiveIndexMapPlacement == 3))
		{
			refriC = float environment(refractiveIndexMap, Rworld);
		}
		else if((refractiveIndexMapPlacement != 2) || (refractiveIndexMapPlacement != 3)&&(refractiveIndexMap == ""))
		{
			refriC = DefaultrefractiveIndex;
		}
	return refriC;
	}

/* RefractionLimit Calculations */
	float doRefractionLimit(string RefractionLimitMap; uniform float UseRefractionLimitMap, RefractionLimitMapPlacement,
	RefractionLimitMapBlur, DefaultRefractionLimit ;varying float ss, tt; varying vector Rworld; output float refrlC)
	{
		if((RefractionLimitMap != "")&&(UseRefractionLimitMap != 0)&&(RefractionLimitMapPlacement == 2))
		{
			refrlC = float texture(RefractionLimitMap, ss, tt,
								"swidth", RefractionLimitMapBlur,
								"twidth", RefractionLimitMapBlur );
		}
		else if((RefractionLimitMap != "")&&(UseRefractionLimitMap != 0)&&(RefractionLimitMapPlacement == 3))
		{
			refrlC = float environment(RefractionLimitMap,  Rworld);
		}
		else if((RefractionLimitMapPlacement != 2) || (RefractionLimitMapPlacement != 3)&&(RefractionLimitMap == ""))
		{
			refrlC = DefaultRefractionLimit;
		}
	return refrlC;
	}

/* LightAbsorbance Calculations */
	float doLightAbsorbance(string LightAbsorbanceMap; uniform float UseLightAbsorbanceMap, LightAbsorbanceMapPlacement,
	LightAbsorbanceMapBlur, DefaultLightAbsorbance ;varying float ss, tt; varying vector Rworld; output float lightaC)
	{
		if((LightAbsorbanceMap != "")&&(UseLightAbsorbanceMap != 0)&&(LightAbsorbanceMapPlacement == 2))
		{
			lightaC = float texture(LightAbsorbanceMap, ss, tt,
								"swidth", LightAbsorbanceMapBlur,
								"twidth", LightAbsorbanceMapBlur );
		}
		else if((LightAbsorbanceMap != "")&&(UseLightAbsorbanceMap != 0)&&(LightAbsorbanceMapPlacement == 3))
		{
			lightaC = float environment(LightAbsorbanceMap,  Rworld);
		}
		else if((LightAbsorbanceMapPlacement != 2) || (LightAbsorbanceMapPlacement != 3)&&(LightAbsorbanceMap == ""))
		{
			lightaC = DefaultLightAbsorbance;
		}
	return lightaC;
	}

/* SurfaceThickness Calculations */
	float doSurfaceThickness(string SurfaceThicknessMap; uniform float UseSurfaceThicknessMap, SurfaceThicknessMapPlacement,
	SurfaceThicknessMapBlur, DefaultSurfaceThickness ;varying float ss, tt; varying vector Rworld; output float surfTC)
	{
		if((SurfaceThicknessMap != "")&&(UseSurfaceThicknessMap != 0)&&(SurfaceThicknessMapPlacement == 2))
		{
			surfTC = float texture(SurfaceThicknessMap, ss, tt,
								"swidth", SurfaceThicknessMapBlur,
								"twidth", SurfaceThicknessMapBlur );
		}
		else if((SurfaceThicknessMap != "")&&(UseSurfaceThicknessMap != 0)&&(SurfaceThicknessMapPlacement == 3))
		{
			surfTC = float environment(SurfaceThicknessMap,  Rworld);
		}
		else if((SurfaceThicknessMapPlacement != 2) || (SurfaceThicknessMapPlacement != 3)&&(SurfaceThicknessMap == ""))
		{
			surfTC = DefaultSurfaceThickness;
		}
	return surfTC;
	}

/* ShadowAttenuation Calculations */
	float doShadowAttenuation(string ShadowAttenuationMap; uniform float UseShadowAttenuationMap, ShadowAttenuationMapPlacement,
	ShadowAttenuationMapBlur, DefaultShadowAttenuation ;varying float ss, tt; varying vector Rworld; output float shadaC)
	{
		if((ShadowAttenuationMap != "")&&(UseShadowAttenuationMap != 0)&&(ShadowAttenuationMapPlacement == 2))
		{
			shadaC = float texture(ShadowAttenuationMap, ss, tt,
								"swidth", ShadowAttenuationMapBlur,
								"twidth", ShadowAttenuationMapBlur );
		}
		else if((ShadowAttenuationMap != "")&&(UseShadowAttenuationMap != 0)&&(ShadowAttenuationMapPlacement == 3))
		{
			shadaC = float environment(ShadowAttenuationMap,  Rworld);
		}
		else if((ShadowAttenuationMapPlacement != 2) || (ShadowAttenuationMapPlacement != 3)&&(ShadowAttenuationMap == ""))
		{
			shadaC = DefaultShadowAttenuation;
		}
	return shadaC;
	}

/* MiRefractionBlur Calculations */
	float doMiRefractionBlur(string MiRefractionBlurMap; uniform float UseMiRefractionBlurMap, MiRefractionBlurMapPlacement,
	MiRefractionBlurMapBlur, DefaultMiRefractionBlur ;varying float ss, tt; varying vector Rworld; output float miRefBC)
	{
		if((MiRefractionBlurMap != "")&&(UseMiRefractionBlurMap != 0)&&(MiRefractionBlurMapPlacement == 2))
		{
			miRefBC = float texture(MiRefractionBlurMap, ss, tt,
								"swidth", MiRefractionBlurMapBlur,
								"twidth", MiRefractionBlurMapBlur );
		}
		else if((MiRefractionBlurMap != "")&&(UseMiRefractionBlurMap != 0)&&(MiRefractionBlurMapPlacement == 3))
		{
			miRefBC = float environment(MiRefractionBlurMap,  Rworld);
		}
		else if((MiRefractionBlurMapPlacement != 2) || (MiRefractionBlurMapPlacement != 3)&&(MiRefractionBlurMap == ""))
		{
			miRefBC = DefaultMiRefractionBlur;
		}
	return miRefBC;
	}

/* MiRefractionRays Calculations */
	float doMiRefractionRays(string MiRefractionRaysMap; uniform float UseMiRefractionRaysMap, MiRefractionRaysMapPlacement,
	MiRefractionRaysMapBlur, DefaultMiRefractionRays ;varying float ss, tt; varying vector Rworld; output float miRefRC)
	{
		if((MiRefractionRaysMap != "")&&(UseMiRefractionRaysMap != 0)&&(MiRefractionRaysMapPlacement == 2))
		{
			miRefRC = float texture(MiRefractionRaysMap, ss, tt,
								"swidth", MiRefractionRaysMapBlur,
								"twidth", MiRefractionRaysMapBlur );
		}
		else if((MiRefractionRaysMap != "")&&(UseMiRefractionRaysMap != 0)&&(MiRefractionRaysMapPlacement == 3))
		{
			miRefRC = float environment(MiRefractionRaysMap,  Rworld);
		}
		else if((MiRefractionRaysMapPlacement != 2) || (MiRefractionRaysMapPlacement != 3)&&(MiRefractionRaysMap == ""))
		{
			miRefRC = DefaultMiRefractionRays;
	    }
	return miRefRC;
	}

/* MiIrradiance Calculations */
	color doMiIrradiance(string MiIrradianceMap; float UseMiIrradianceMap, MiIrradianceMapPlacement, MiIrradianceMapBlur,
	ss, tt; vector Rworld; color DefaultMiIrradiance; output color miIC)
	{
		if((MiIrradianceMap != "")&&(UseMiIrradianceMap != 0)&&(MiIrradianceMapPlacement == 2))
		{
			miIC = float texture(MiIrradianceMap, ss, tt,
								"swidth", MiIrradianceMapBlur,
								"twidth", MiIrradianceMapBlur );
		}
		else if((MiIrradianceMap != "")&&(UseMiIrradianceMap != 0)&&(MiIrradianceMapPlacement == 3))
		{
			miIC = float environment(MiIrradianceMap,  Rworld);
		}
		else if((MiIrradianceMapPlacement != 2) || (MiIrradianceMapPlacement != 3)&&(MiIrradianceMap == ""))
		{
			miIC = DefaultMiIrradiance;
		}
	return miIC;
	}

/* MiIrradianceColor Calculations */
	color doMiIrradianceColor(string MiIrradianceColorMap; float UseMiIrradianceColorMap, MiIrradianceColorMapPlacement, MiIrradianceColorMapBlur,
	ss, tt; vector Rworld; color DefaultMiIrradianceColor; output color miicC)
	{
		if((MiIrradianceColorMap != "")&&(UseMiIrradianceColorMap != 0)&&(MiIrradianceColorMapPlacement == 2))
		{
			miicC = color texture(MiIrradianceColorMap, ss, tt,
								"swidth", MiIrradianceColorMapBlur,
								"twidth", MiIrradianceColorMapBlur );
		}
		else if((MiIrradianceColorMap != "")&&(UseMiIrradianceColorMap != 0)&&(MiIrradianceColorMapPlacement == 3))
		{
			miicC = color environment(MiIrradianceColorMap,  Rworld);
		}
		else if((MiIrradianceColorMapPlacement != 2) || (MiIrradianceColorMapPlacement != 3)&&(MiIrradianceColorMap == ""))
		{
			miicC = DefaultMiIrradianceColor;
		}
	return miicC;
	}

/* Eccentricity Calculations */
	float doEccentricity(string EccentricityMap; uniform float UseEccentricityMap, EccentricityMapPlacement,
	EccentricityMapBlur, DefaultEccentricity ;varying float ss, tt; varying vector Rworld; output float eccC)
	{
		if((EccentricityMap != "")&&(UseEccentricityMap != 0)&&(EccentricityMapPlacement == 2))
		{
			eccC = float texture(EccentricityMap, ss, tt,
								"swidth", EccentricityMapBlur,
								"twidth", EccentricityMapBlur );
		}
		else if((EccentricityMap != "")&&(UseEccentricityMap != 0)&&(EccentricityMapPlacement == 3))
		{
			eccC = float environment(EccentricityMap,  Rworld);
		}
		else if((EccentricityMapPlacement != 2) || (EccentricityMapPlacement != 3)&&(EccentricityMap == ""))
		{
			eccC = DefaultEccentricity;
		}
	return eccC;
	}

/* SpecularRollOff Calculations */
	float doSpecularRollOff(string SpecularRollOffMap; uniform float UseSpecularRollOffMap, SpecularRollOffMapPlacement,
	SpecularRollOffMapBlur, DefaultSpecularRollOff ;varying float ss, tt; varying vector Rworld; output float specroC)
	{
		if((SpecularRollOffMap != "")&&(UseSpecularRollOffMap != 0)&&(SpecularRollOffMapPlacement == 2))
		{
			specroC = float texture(SpecularRollOffMap, ss, tt,
								"swidth", SpecularRollOffMapBlur,
								"twidth", SpecularRollOffMapBlur );
		}
		else if((SpecularRollOffMap != "")&&(UseSpecularRollOffMap != 0)&&(SpecularRollOffMapPlacement == 3))
		{
			specroC = float environment(SpecularRollOffMap,  Rworld);
		}
		else if((SpecularRollOffMapPlacement != 2) || (SpecularRollOffMapPlacement != 3)&&(SpecularRollOffMap == ""))
		{
			specroC = DefaultSpecularRollOff;
		}
	return specroC;
	}

/* SpecularColor Calculations */
	color doSpecularColor(string SpecularColorMap; float UseSpecularColorMap, SpecularColorMapPlacement, SpecularColorMapBlur,
	ss, tt; vector Rworld; color DefaultSpecularColor; output color speccC)
	{
		if((SpecularColorMap != "")&&(UseSpecularColorMap != 0)&&(SpecularColorMapPlacement == 2))
		{
			speccC = color texture(SpecularColorMap, ss, tt,
								"swidth", SpecularColorMapBlur,
								"twidth", SpecularColorMapBlur );
		}
		else if((SpecularColorMap != "")&&(UseSpecularColorMap != 0)&&(SpecularColorMapPlacement == 3))
		{
			speccC = color environment(SpecularColorMap,  Rworld);
		}
		else if((SpecularColorMapPlacement != 2) || (SpecularColorMapPlacement != 3)&&(SpecularColorMap == ""))
		{
			speccC = DefaultSpecularColor;
		}
	return  speccC;
	}

/* Reflectivity Calculations */
	float doReflectivity(string ReflectivityMap; uniform float UseReflectivityMap, ReflectivityMapPlacement,
	ReflectivityMapBlur, DefaultReflectivity ;varying float ss, tt; varying vector Rworld; output float reflC)
	{
		if((ReflectivityMap != "")&&(UseReflectivityMap != 0)&&(ReflectivityMapPlacement == 2))
		{
			reflC = float texture(ReflectivityMap, ss, tt,
								"swidth", ReflectivityMapBlur,
								"twidth", ReflectivityMapBlur );
		}
		else if((ReflectivityMap != "")&&(UseReflectivityMap != 0)&&(ReflectivityMapPlacement == 3))
		{
			reflC = float environment(ReflectivityMap,  Rworld);
		}
		else if((ReflectivityMapPlacement != 2) || (ReflectivityMapPlacement != 3)&&(ReflectivityMap == ""))
		{
			reflC = DefaultReflectivity;
		}
	return reflC;
	}

/* ReflectedColor Calculations */
	color doReflectedColor(string ReflectedColorMap; float UseReflectedColorMap, ReflectedColorMapPlacement, ReflectedColorMapBlur,
	ss, tt; vector Rworld; color DefaultReflectedColor; output color reflcC)
	{
		if((ReflectedColorMap != "")&&(UseReflectedColorMap != 0)&&(ReflectedColorMapPlacement == 2))
		{
			reflcC = color texture(ReflectedColorMap, ss, tt,
								"swidth", ReflectedColorMapBlur,
								"twidth", ReflectedColorMapBlur );
		}
		else if((ReflectedColorMap != "")&&(UseReflectedColorMap != 0)&&(ReflectedColorMapPlacement == 3))
		{
			reflcC = color environment(ReflectedColorMap,  Rworld);
		}
		else if((ReflectedColorMapPlacement != 2) || (ReflectedColorMapPlacement != 3)&&(ReflectedColorMap == ""))
		{
			reflcC = DefaultReflectedColor;
		}
	return reflcC;
	}

/* CosinePower Calculations */
	float doCosinePower(string CosinePowerMap; uniform float UseCosinePowerMap, CosinePowerMapPlacement,
	CosinePowerMapBlur, DefaultCosinePower ;varying float ss, tt; varying vector Rworld; output float cosPC)
	{
		if((CosinePowerMap != "")&&(UseCosinePowerMap != 0)&&(CosinePowerMapPlacement == 2))
		{
			cosPC = float texture(CosinePowerMap, ss, tt,
								"swidth", CosinePowerMapBlur,
								"twidth", CosinePowerMapBlur );
		}
		else if((CosinePowerMap != "")&&(UseCosinePowerMap != 0)&&(CosinePowerMapPlacement == 3))
		{
			cosPC = float environment(CosinePowerMap,  Rworld);
		}
		else if((CosinePowerMapPlacement != 2) || (CosinePowerMapPlacement != 3)&&(CosinePowerMap == ""))
		{
			cosPC = DefaultCosinePower;
		}
	return cosPC;
	}

/* Roughness Calculations */
	float doRoughness(string RoughnessMap; uniform float UseRoughnessMap, RoughnessMapPlacement,
	RoughnessMapBlur, DefaultRoughness ;varying float ss, tt; varying vector Rworld; output float roughN)
	{
		if((RoughnessMap != "")&&(UseRoughnessMap != 0)&&(RoughnessMapPlacement == 2))
		{
			roughN = float texture(RoughnessMap, ss, tt,
								"swidth", RoughnessMapBlur,
								"twidth", RoughnessMapBlur );
		}
		else if((RoughnessMap != "")&&(UseRoughnessMap != 0)&&(RoughnessMapPlacement == 3))
		{
			roughN = float environment(RoughnessMap,  Rworld);
		}
		else if((RoughnessMapPlacement != 2) || (RoughnessMapPlacement != 3)&&(RoughnessMap == ""))
		{
			roughN = DefaultRoughness;
		}
	return roughN;
	}

/* HighlightSize Calculations */
	float doHighlightSize(string HighlightSizeMap; uniform float UseHighlightSizeMap, HighlightSizeMapPlacement,
	HighlightSizeMapBlur, DefaultHighlightSize ;varying float ss, tt; varying vector Rworld; output float highS)
	{
		if((HighlightSizeMap != "")&&(UseHighlightSizeMap != 0)&&(HighlightSizeMapPlacement == 2))
		{
			highS = float texture(HighlightSizeMap, ss, tt,
								"swidth", HighlightSizeMapBlur,
								"twidth", HighlightSizeMapBlur );
		}
		else if((HighlightSizeMap != "")&&(UseHighlightSizeMap != 0)&&(HighlightSizeMapPlacement == 3))
		{
			highS = float environment(HighlightSizeMap,  Rworld);
		}
		else if((HighlightSizeMapPlacement != 2) || (HighlightSizeMapPlacement != 3)&&(HighlightSizeMap == ""))
		{
			highS = DefaultHighlightSize;
		}
	return highS;
	}

/* Whiteness Calculations */
	color doWhiteness(string WhitenessMap; float UseWhitenessMap, WhitenessMapPlacement, WhitenessMapBlur,
	ss, tt; vector Rworld; color DefaultWhiteness; output color whitN)
	{
		if((WhitenessMap != "")&&(UseWhitenessMap != 0)&&(WhitenessMapPlacement == 2))
		{
			whitN = color texture(WhitenessMap, ss, tt,
								"swidth", WhitenessMapBlur,
								"twidth", WhitenessMapBlur );
		}
		else if((WhitenessMap != "")&&(UseWhitenessMap != 0)&&(WhitenessMapPlacement == 3))
		{
			whitN = color environment(WhitenessMap,  Rworld);
		}
		else if((WhitenessMapPlacement != 2) || (WhitenessMapPlacement != 3)&&(WhitenessMap == ""))
		{
			whitN = DefaultWhiteness;
		}
	return whitN;
	}

/* FresnelIndex Calculations */
	float doFresnelIndex(string FresnelIndexMap; uniform float UseFresnelIndexMap, FresnelIndexMapPlacement,
	FresnelIndexMapBlur, DefaultFresnelIndex ;varying float ss, tt; varying vector Rworld; output float fresI)
	{
		if((FresnelIndexMap != "")&&(UseFresnelIndexMap != 0)&&(FresnelIndexMapPlacement == 2))
		{
			fresI = float texture(FresnelIndexMap, ss, tt,
								"swidth", FresnelIndexMapBlur,
								"twidth", FresnelIndexMapBlur );
		}
		else if((FresnelIndexMap != "")&&(UseFresnelIndexMap != 0)&&(FresnelIndexMapPlacement == 3))
		{
			fresI = float environment(FresnelIndexMap,  Rworld);
		}
		else if((FresnelIndexMapPlacement != 2) || (FresnelIndexMapPlacement != 3)&&(FresnelIndexMap == ""))
		{
			fresI = DefaultFresnelIndex;
		}
	return fresI;
	}

/* Angle Calculations */
	float doAngle(string AngleMap; uniform float UseAngleMap, AngleMapPlacement,
	AngleMapBlur, DefaultAngle ;varying float ss, tt; varying vector Rworld; output float angle)
	{
		if((AngleMap != "")&&(UseAngleMap != 0)&&(AngleMapPlacement == 2))
		{
			angle = float texture(AngleMap, ss, tt,
								"swidth", AngleMapBlur,
								"twidth", AngleMapBlur );
		}
		else if((AngleMap != "")&&(UseAngleMap != 0)&&(AngleMapPlacement == 3))
		{
			angle = float environment(AngleMap,  Rworld);
		}
		else if((AngleMapPlacement != 2) || (AngleMapPlacement != 3)&&(AngleMap == ""))
		{
			angle = DefaultAngle;
		}
	return angle;
	}

/* SpreadX Calculations */
	float doSpreadX(string SpreadXMap; uniform float UseSpreadXMap, SpreadXMapPlacement,
	SpreadXMapBlur, DefaultSpreadX ;varying float ss, tt; varying vector Rworld; output float sprdX)
	{
		if((SpreadXMap != "")&&(UseSpreadXMap != 0)&&(SpreadXMapPlacement == 2))
		{
			sprdX = float texture(SpreadXMap, ss, tt,
								"swidth", SpreadXMapBlur,
								"twidth", SpreadXMapBlur );
		}
		else if((SpreadXMap != "")&&(UseSpreadXMap != 0)&&(SpreadXMapPlacement == 3))
		{
			sprdX = float environment(SpreadXMap,  Rworld);
		}
		else if((SpreadXMapPlacement != 2) || (SpreadXMapPlacement != 3)&&(SpreadXMap == ""))
		{
			sprdX = DefaultSpreadX;
		}
	return sprdX;
	}

/* SpreadY Calculations */
	float doSpreadY(string SpreadYMap; uniform float UseSpreadYMap, SpreadYMapPlacement,
	SpreadYMapBlur, DefaultSpreadY ;varying float ss, tt; varying vector Rworld; output float sprdY)
	{
		if((SpreadYMap != "")&&(UseSpreadYMap != 0)&&(SpreadYMapPlacement == 2))
		{
			sprdY = float texture(SpreadYMap, ss, tt,
								"swidth", SpreadYMapBlur,
								"twidth", SpreadYMapBlur );
		}
		else if((SpreadYMap != "")&&(UseSpreadYMap != 0)&&(SpreadYMapPlacement == 3))
		{
			sprdY = float environment(SpreadYMap,  Rworld);
		}
		else if((SpreadYMapPlacement != 2) || (SpreadYMapPlacement != 3)&&(SpreadYMap == ""))
		{
			sprdY = DefaultSpreadY;
		}
	return sprdY;
	}


	color dolightColor(string lightColorMap; float UselightColorMap, lightColorMapPlacement, lightColorMapBlur, ss, tt; vector Rworld; output color colL)
	{
		if((lightColorMap != "")&&(UselightColorMap == 1)&&(lightColorMapPlacement == 2))
		{
			colL = color texture(lightColorMap, ss, tt,
								  "swidth", lightColorMapBlur,
								  "twidth", lightColorMapBlur );
		}
		else if((lightColorMap != "")&&(UselightColorMap == 1)&&(lightColorMapPlacement == 3))
		{
			colL = color environment(lightColorMap, Rworld);
		}
		else if((lightColorMapPlacement != 2) || (lightColorMapPlacement != 3)&&(lightColorMap == ""))
		{
			colL = Cl;
		}
	return colL;
	}

	float doIntensity(string IntensityMap; uniform float UseIntensityMap, IntensityMapPlacement,
	IntensityMapBlur, DefaultIntensity ;varying float ss, tt; varying vector Rworld; output float intL)
	{
		if((IntensityMap != "")&&(UseIntensityMap != 0)&&(IntensityMapPlacement == 2))
		{
			intL = float texture(IntensityMap, ss, tt,
								"swidth", IntensityMapBlur,
								"twidth", IntensityMapBlur );
		}
		else if((IntensityMap != "")&&(UseIntensityMap != 0)&&(IntensityMapPlacement == 3))
		{
			intL = float environment(IntensityMap,  Rworld);
		}
		else if((IntensityMapPlacement != 2) || (IntensityMapPlacement != 3)&&(IntensityMap == ""))
		{
			intL = DefaultIntensity;
		}
	return intL;
	}

	float doConeAng(string ConeAngMap; uniform float UseConeAngMap, ConeAngMapPlacement,
	ConeAngMapBlur, DefaultConeAng ;varying float ss, tt; varying vector Rworld; output float angL)
	{
		if((ConeAngMap != "")&&(UseConeAngMap != 0)&&(ConeAngMapPlacement == 2))
		{
			angL = float texture(ConeAngMap, ss, tt,
								"swidth", ConeAngMapBlur,
								"twidth", ConeAngMapBlur );
		}
		else if((ConeAngMap != "")&&(UseConeAngMap != 0)&&(ConeAngMapPlacement == 3))
		{
			angL = float environment(ConeAngMap,  Rworld);
		}
		else if((ConeAngMapPlacement != 2) || (ConeAngMapPlacement != 3)&&(ConeAngMap == ""))
		{
			angL = DefaultConeAng;
		}
	return angL;
	}


	float doPenumbAng(string PenumbAngMap; uniform float UsePenumbAngMap, PenumbAngMapPlacement,
	PenumbAngMapBlur, DefaultPenumbAng ;varying float ss, tt; varying vector Rworld; output float penL)
	{
		if((PenumbAngMap != "")&&(UsePenumbAngMap != 0)&&(PenumbAngMapPlacement == 2))
		{
			penL = float texture(PenumbAngMap, ss, tt,
								"swidth", PenumbAngMapBlur,
								"twidth", PenumbAngMapBlur );
		}
		else if((PenumbAngMap != "")&&(UsePenumbAngMap != 0)&&(PenumbAngMapPlacement == 3))
		{
			penL = float environment(PenumbAngMap,  Rworld);
		}
		else if((PenumbAngMapPlacement != 2) || (PenumbAngMapPlacement != 3)&&(PenumbAngMap == ""))
		{
			penL = DefaultPenumbAng;
		}
	return penL;
	}


	normal Displace(vector dir; string space; float amp; float truedisplace;)
	{
		extern point P;
		float spacescale = length(vtransform(space, dir));
		vector Ndisp = dir * (amp/ spacescale);
		P += truedisplace * Ndisp;
		return normalize(calculatenormal (P+ (1-truedisplace)*Ndisp));
	}

	normal doDisplace (string DisplaceMap; uniform float UseDisplaceMap, DisplaceMapPlacement,
	DisplaceMapBlur, DisplaceAmt, DisplaceBump ;varying float ss, tt; varying vector Rworld; output normal Nw)
	{
		float dispD = 0;
		if((DisplaceMap != "")&&(UseDisplaceMap != 0)&&(DisplaceMapPlacement == 2))
		{
			dispD = float texture(DisplaceMap, ss, tt,
								"swidth", DisplaceMapBlur,
								"twidth", DisplaceMapBlur );
		}
		else if((DisplaceMap != "")&&(UseDisplaceMap != 0)&&(DisplaceMapPlacement == 3))
		{
			dispD = float environment(DisplaceMap,  Rworld);
		}
		else if((DisplaceMapPlacement != 2) || (DisplaceMapPlacement != 3)&&(DisplaceMap == ""))
		{
			dispD = 0;
		}
	Nw = Displace(normalize(N), "shader", DisplaceAmt*dispD, DisplaceBump);
	return Nw;
	}
/*
 * Greg Ward Larson's anisotropic specular local illumination model.
 * The derivation and formulae can be found in:  Ward, Gregory J.
 * "Measuring and Modeling Anisotropic Reflection," ACM Computer
 * Graphics 26(2) (Proceedings of Siggraph '92), pp. 265-272, July, 1992.
 * Inputs:
 *   N - unit surface normal
 *   V - unit viewing direction (from P toward the camera)
 *   xdir - a unit tangent of the surface which defines the reference
 *          direction for the anisotropy.
 *   xroughness - the apparent roughness of the surface in xdir.
 *   yroughness - the roughness for the direction of the surface
 *          tangent which is perpendicular to xdir.
 */
color
LocIllumWardAnisotropic (normal N;  vector V;
                         vector xdir;  float xroughness, yroughness;)
{
    float sqr (float x) { return x*x; }

    float cos_theta_r = clamp (N.V, 0.0001, 1);
    vector X = xdir / xroughness;
    vector Y = (N ^ xdir) / yroughness;

    color C = 0;
    extern point P;
    illuminance (P, N, PI/2) {
        /* Must declare because extern L & Cl because we're in a function */
        extern vector L;  extern color Cl;
        float nonspec = 0;
        lightsource ("__nonspecular", nonspec);
        if (nonspec < 1) {
            vector LN = normalize (L);
            float cos_theta_i = LN . N;
            if (cos_theta_i > 0.0) {
                vector H = normalize (V + LN);
                float rho = exp (-2 * (sqr(X.H) + sqr(Y.H)) / (1 + H.N))
                    / sqrt (cos_theta_i * cos_theta_r);
                C += Cl * ((1-nonspec) * cos_theta_i * rho);
            }
        }
    }

    return C / (4 * xroughness * yroughness);
}

vector calcHalfVector(vector vDir, lDir)
{
	float x1 = xcomp(vDir), y1 = ycomp(vDir), z1 = zcomp(vDir);
	float x2 = xcomp(lDir), y2 = ycomp(lDir), z2 = zcomp(lDir);
	float x = 0, y = 0, z = 0;
	float t = 0.5;


	x = ((1 - t)*x1) +(t*x2);
	y = ((1 - t)*y1) +(t*y2);
	z = ((1 - t)*x1) +(t*x2);

	vector out = (x, y,z);

	return out;
}
color reflector(string reflname; output color g)
{
	normal Nf = faceforward(N, I);
	vector V = -normalize(I);
	vector D = reflect(I, normalize(Nf));
	D = vtransform("current", "world", D);
	g = (color environment(reflname, D));
	return g;
}

normal shadingnormal(normal N)
{
    normal Ns = normalize(N);
    uniform float sides = 2;
    uniform float raydepth;
    attribute("Sides", sides);
    rayinfo("depth", raydepth);
    if (sides == 2 || raydepth > 0)
        Ns = faceforward(Ns, I, Ns);
    return Ns;
}


 float occsurf(string filename; float samples, maxdist, mode)
    {
      normal Nf = shadingnormal(N);
      float occ = 0;

	  if((mode == 1)&&(filename != "")){
		  occ = occlusion(P, Nf, samples, "maxdist", maxdist);
	      irradiancecache("insert", filename, "w", P, Nf, "occlusion", occ);
	      }
      if((mode == 2)&&(filename != "")){
          irradiancecache("query", filename, "r", P, Nf, "occlusion", occ);
          }
      if((mode == 0)&&(filename == "")){
		  occ = occlusion(P, Nf, samples, "maxdist", maxdist);}

      // Set Ci and Oi

      float occl = (1 - occ);

      return occl;

    }

 color irradsurf(string irradfilename; float irradsamples, irradmaxdist, irradmode)
    {
      normal Nf = shadingnormal(N);
		color irrad = 0;
      if((irradmode == 0)&&(irradfilename != "")){
          irrad = diffuse(Nf) + indirectdiffuse(P, Nf, irradsamples, "maxdist", irradmaxdist);}
	  if((irradmode == 1)&&(irradfilename != "")){
          irrad = diffuse(Nf) + indirectdiffuse(P, Nf, irradsamples, "maxdist", irradmaxdist);
	      irradiancecache("insert", irradfilename, "w", P, Nf, "indirectdiffuse", irrad);
	      }
      if((irradmode == 2)&&(irradfilename != "")){
          irradiancecache("query", irradfilename, "r", P, Nf, "indirectdiffuse", irrad);
          }

      // Set Ci and Oi

      color irr = (1 - irrad);

      return irr;

    }

 color ibisurf(string ibifilename, imagefile; float ibisamples, ibimaxdist, ibimode)
    {
      normal Nf = shadingnormal(N);
      color ibi = 0;
      if((ibimode == 0)&&(ibifilename != "")){
		  ibi = diffuse(Nf) + indirectdiffuse(P, Nf, ibisamples, "maxdist", ibimaxdist,"environmentmap", imagefile);}
	  if((ibimode == 1)&&(ibifilename != "")){
		 ibi = diffuse(Nf) + indirectdiffuse(P, Nf, ibisamples, "maxdist", ibimaxdist,"environmentmap", imagefile);
	      irradiancecache("insert", ibifilename, "w", P, Nf, "indirectdiffuse", ibi);
	      }
      else if((ibimode == 2)&&(ibifilename != "")){
          irradiancecache("query", ibifilename, "r", P, Nf, "indirectdiffuse", ibi);
          }

      // Set Ci and Oi

      color ibill = (1 - ibi);

      return ibill;

    }

#endif