light hyperPointLight (
	float intensity = 1;
	color lightcolor = 1;
	point from = point "shader" (0, 0, 0);
	string sMapXP = "";
	string sMapYP = "";
	string sMapZP = "";
	string sMapXN = "";
	string sMapYN = "";
	string sMapZN = "";
    float width      = 1.0;
    float shadowsamples    = 16.0;
output varying float _shadow = 0;
string __category = "shadowlight";)
{
 float    attenuation = 0.0;
    float    Lx, Ly, Lz, AbsLx, AbsLy, AbsLz;
    vector   Lrel;

    illuminate( from ) {

        Lrel = vtransform("world", L);

        Lx = xcomp(Lrel);
        AbsLx = abs(Lx);
        Ly = ycomp(Lrel);
        AbsLy = abs(Ly);
        Lz = zcomp(Lrel);
        AbsLz = abs(Lz);

        if((AbsLx > AbsLy) && (AbsLx > AbsLz)) {
            if((Lx > 0.0)&&(sMapXP != ""))
		attenuation = shadow( sMapXP, Ps, "shadowsamples", shadowsamples,
                                       "twidth", width, "swidth", width );
                                     
            else if (sMapXN != "")
		attenuation = shadow( sMapXN, Ps, "shadowsamples", shadowsamples,
                                      "twidth", width, "swidth", width );
        
	}
        else if((AbsLy > AbsLx) && (AbsLy > AbsLz)) {
            if((Ly > 0.0)&&(sMapYP != ""))
		attenuation = shadow( sMapYP, Ps, "shadowsamples", shadowsamples,
                                      "twidth", width, "swidth", width );
            else if (sMapYN != "")
		attenuation = shadow( sMapYN, Ps, "shadowsamples", shadowsamples,
                                      "twidth", width, "swidth", width );
	}
        else if((AbsLz > AbsLy) && (AbsLz > AbsLx)) {
            if((Lz > 0.0)&&(sMapZP != ""))
		attenuation = shadow( sMapZP, Ps, "shadowsamples", shadowsamples,
                                      "twidth", width, "swidth", width );
            else if (sMapZN != "")
		attenuation = shadow( sMapZN, Ps, "shadowsamples", shadowsamples,
                                      "twidth", width, "swidth", width );
	}         
    Cl =  intensity * lightcolor / (L.L);
    }
}

