displacement normalmap_displace(
	float   Km  		= 1.0;
	float	Km_pos		= 0.0;
	float	Km_neg		= 0.0;
	string	displace_map	= "";
	string 	normal_map	= "";
	string	normal_map_space = "current")
{
	float   magnitude = 0;
	float	level = 0;
	float	pos_level = 0;
	float	neg_level = 0;	
	color 	color_level = color(0,0,0);

	color Ncolor = color(0,0,0);
	point Nvector = point(0,0,0);
	point Nref = point(0,0,0);
	point Nside = point(0,0,0);	
	point Ntransformed = point(0,0,0);
	float testSide = 0;
	
	point dPds, dPdt;
	
	dPds = Deriv(P,s);
	dPdt = Deriv(P,t);

	if( displace_map != "")
	{
		color_level = color 
				texture(
					displace_map,
					s,
					(1-t),
					"swidth", 0.0001,
					"twidth", 0.0001,
					"samples", 1);
		if ((Km_pos == 0) && (Km_neg == 0))
		{
			level = comp(color_level,0);

			magnitude = ((level * 2) - 1) * Km;
		}
		else
		{
			pos_level = comp(color_level,0);
			neg_level = comp(color_level,1);
					
			magnitude = (( pos_level * Km_pos ) - ( neg_level * Km_neg )) * Km;
		}
	}
	else
	{
		magnitude	= 0.0;
	}

	P += normalize(N) * magnitude;

	
	if( normal_map != "")	
	{
			Ncolor = color
				texture( 
					normal_map, 
					s,
					(1-t));
					
		Nvector = (vector(Ncolor)*2) - vector(1.0, 1.0, 1.0);
	
		if ((normal_map_space == "point") || (normal_map_space == "pointU") || (normal_map_space == "pointV")
		    || (normal_map_space == "facet") || (normal_map_space == "facetU") || (normal_map_space == "facetV"))
		{

			if ((normal_map_space == "point") || (normal_map_space == "pointU") || (normal_map_space == "pointV"))
				Nref = N;
			else
				Nref = Ng;
				
			Nside = dPds ^ dPdt;
			testSide = Nside.Nref;
			
			if ((normal_map_space == "pointU") || (normal_map_space == "facetU"))
			{
				dPdt = dPds ^ Nref;
			}
			if ((normal_map_space == "pointV") || (normal_map_space == "facetV"))
			{
				dPds = Nref ^ dPdt;
			}
				
			dPds = normalize (dPds);
			dPdt = normalize (dPdt);
			Nref = normalize (Nref); 

			Ntransformed = vector(comp(Nvector,0) * comp(dPds,0) + comp(Nvector,1) * comp(dPdt,0) + comp(Nvector,2) * comp(Nref,0),
					      comp(Nvector,0) * comp(dPds,1) + comp(Nvector,1) * comp(dPdt,1) + comp(Nvector,2) * comp(Nref,1),
					      comp(Nvector,0) * comp(dPds,2) + comp(Nvector,1) * comp(dPdt,2) + comp(Nvector,2) * comp(Nref,2));
		}
		else
			Ntransformed = ntransform (normal_map_space, "current", Nvector);
			
		N = normalize(Ntransformed);
	}
	else
	{
		N = calculatenormal( P);
	}
	
	
}

